local oldBeatFunction = _BeatFunction
local energySmoother = 0
local massSmoother = 0
local massOldIncome = 0
local energyOldIncome = 0

function _BeatFunction()
	oldBeatFunction()
    local simFrequency = GetSimTicksPerSecond()

	local econData = GetEconomyTotals()
	local energyMaxStorageVal = econData["maxStorage"]["ENERGY"]
	local energyStoredVal = econData["stored"]["ENERGY"]
    local massMaxStorageVal = econData["maxStorage"]["MASS"]
    local massStoredVal = econData["stored"]["MASS"]

	if import('/lua/user/prefs.lua').GetFromCurrentProfile("uimanager_sav")["verticalenergy"]==1 and import('/lua/user/prefs.lua').GetFromCurrentProfile("uimanager_sav")["miniui_econ"]==0 and controls.energyStorageMax then
	    controls.energyStorage:SetText(string.format("%d", energyStoredVal))
	    controls.energyStorageMax:SetText(string.format("%d", energyMaxStorageVal))
	end
	if import('/lua/user/prefs.lua').GetFromCurrentProfile("uimanager_sav")["verticalmass"]==1 and import('/lua/user/prefs.lua').GetFromCurrentProfile("uimanager_sav")["miniui_econ"]==0 and  controls.massStorageMax then
	    controls.massStorage:SetText(string.format("%d", massStoredVal))
	    controls.massStorageMax:SetText(string.format("%d", massMaxStorageVal))
	end
	
	
	local massOld = massSmoother
	
    local massIncomeVal = econData["income"]["MASS"]
	local massLastRequestedVal = econData["lastUseRequested"]["MASS"]
    local massLastActualVal = econData["lastUseActual"]["MASS"]
	local massRequestedAvg = math.min(massLastRequestedVal * simFrequency, 99999)
    local massActualAvg = math.min(massLastActualVal * simFrequency, 99999)
    local massIncomeAvg = math.min(massIncomeVal * simFrequency, 99999)
    local massBarRateVal = 0
    if massStoredVal > 0.5 then
        massBarRateVal = math.floor(( massIncomeAvg - massActualAvg ) + 0.5 )
    else
        massBarRateVal = math.floor(( massIncomeAvg - massRequestedAvg ) + 0.5 )
    end

	local massAveragedIncome = math.min(massIncomeAvg, massOldIncome)
	
	if massBarRateVal > massAveragedIncome then
		massBarRateVal = math.floor(massAveragedIncome + 0.5)
	elseif massBarRateVal < (-massAveragedIncome) then
		massBarRateVal = -math.floor(massAveragedIncome + 0.5)
	end
	
	--to fix a glitch where the incomeavg suddenly shoots up for 1 tick
	massOldIncome = massIncomeAvg
	massSmoother = (massBarRateVal + 3*massOld)/4
	if massSmoother < 10 then
		if import('/lua/user/prefs.lua').GetFromCurrentProfile("uimanager_sav")["verticalmass"]==1 and controls.massRatePos then
			controls.massRatePos:SetRange(0, math.max(math.floor(10*massAveragedIncome + 0.5), 1))
			controls.massRatePos:SetValue(math.floor(10*massSmoother + 0.5))
		end
		if import('/lua/user/prefs.lua').GetFromCurrentProfile("uimanager_sav")["verticalmass"]==1 and controls.massRateNeg then
			controls.massRateNeg:SetRange(0, math.max(math.floor(10*massAveragedIncome + 0.5), 1))
			controls.massRateNeg:SetValue(-math.floor(10*massSmoother))
		end
	else
		if import('/lua/user/prefs.lua').GetFromCurrentProfile("uimanager_sav")["verticalmass"]==1 and controls.massRatePos then
			controls.massRatePos:SetRange(0, math.max(math.floor(massAveragedIncome + 0.5), 1))
			controls.massRatePos:SetValue(math.floor(massSmoother + 0.5))
		end
		if import('/lua/user/prefs.lua').GetFromCurrentProfile("uimanager_sav")["verticalmass"]==1 and controls.massRateNeg then
			controls.massRateNeg:SetRange(0, math.max(math.floor(massAveragedIncome + 0.5), 1))
			controls.massRateNeg:SetValue(-math.floor(massSmoother))
		end
	end
	
	local energyOld = energySmoother
	
	local energyIncomeVal = econData["income"]["ENERGY"]
	local energyLastRequestedVal = econData["lastUseRequested"]["ENERGY"]
    local energyLastActualVal = econData["lastUseActual"]["ENERGY"]
	local energyRequestedAvg = math.min(energyLastRequestedVal * simFrequency, 99999)
    local energyActualAvg = math.min(energyLastActualVal * simFrequency, 99999)
    local energyIncomeAvg = math.min(energyIncomeVal * simFrequency, 99999)
    local energyBarRateVal = 0
    if energyStoredVal > 0.5 then
        energyBarRateVal = math.floor(( energyIncomeAvg - energyActualAvg ) + 0.5 )
    else
        energyBarRateVal = math.floor(( energyIncomeAvg - energyRequestedAvg ) + 0.5 )
    end
	
	local energyAveragedIncome = math.min(energyIncomeAvg, energyOldIncome)
	
	if energyBarRateVal > energyAveragedIncome then
		energyBarRateVal = math.floor(energyAveragedIncome + 0.5)
	elseif energyBarRateVal < (-energyAveragedIncome) then
		energyBarRateVal = -math.floor(energyAveragedIncome + 0.5)
	end
	
	--to fix a glitch where the incomeavg suddenly shoots up for 1 tick
	energyOldIncome = energyIncomeAvg

	energySmoother = (energyBarRateVal + 3*energyOld)/4
	if import('/lua/user/prefs.lua').GetFromCurrentProfile("uimanager_sav")["verticalenergy"]==1 and controls.energyRatePos then
		controls.energyRatePos:SetRange(0, math.max(math.floor(energyAveragedIncome + 0.5), 1))
		controls.energyRatePos:SetValue(math.floor(energySmoother + 0.5))
	end
	if import('/lua/user/prefs.lua').GetFromCurrentProfile("uimanager_sav")["verticalenergy"]==1 and controls.energyRateNeg then
		controls.energyRateNeg:SetRange(0, math.max(math.floor(energyAveragedIncome + 0.5), 1))
		controls.energyRateNeg:SetValue(-math.floor(energySmoother))
	end
end
