--*****************************************************************************
--* File: lua/ui/game/gamemain.lua
--* Author: Cleopatre and Says
--* 
--* Summary: hook for the gamemain.lua
--* two function: SetLayout launch a function before and after a new layout / and on Creat
--*
--* Copyright  2007 SCA  All rights reserved.
--*****************************************************************************
-- when this script loads, get the original CreateUI function
local originalCreateUI = CreateUI
local originalSetLayout = SetLayout
local originalOnSelectionChanged = OnSelectionChanged

local uimod = import('/mods/uimod/sca_utils/uimod.lua')
local sca_utils = '/mods/uimod/sca_utils/'
local profiles = GetPreference("profile.profiles") -- Gets our profiles table
local current = GetPreference("profile.current") -- gets the current profile
local Prefs = import('/lua/user/prefs.lua')--preferences
local UIUtil = import('/lua/ui/uiutil.lua')
local skinning= import('/mods/uimod/sca_utils/skinning.lua')

function SetLayout(layout)
	--WARN("---->Gamemain SetLayout")
	skinning.start_skinning_process()
	-- to avoid bug at the desinstallation, please keep this
	Prefs.SetToCurrentProfile("layout", "sca")
	Prefs.SavePreferences()
	
	-- call the original function first to set up the rest of the game UI
	originalSetLayout(layout)

	skinning.end_skinning_process()
	uimod.On_layout_sca()

	Prefs.SetToCurrentProfile("layout", "bottom")
	Prefs.SavePreferences()

end

function CreateUI(isReplay)
	local sav = Prefs.GetFromCurrentProfile('uimanager_sav')
	if sav then
		if sav.loadOK == false then
			sav.currentscaLayout = {'Default', 'Saya'}
			sav.skin = 'Default'
		end
		sav.loadOK = false
		Prefs.SetToCurrentProfile("uimanager_sav", sav)
	end
	Prefs.SetToCurrentProfile("layout", "sca")
	Prefs.SavePreferences()
	UIUtil.SetCurrentLayout("sca")
    -- call the original function first to set up the rest of the game UI
	originalCreateUI(isReplay)
	--WARN("---->Gamemain initialisation")
	uimod.initialisation_sca()
end 

function OnSelectionChanged(oldSelection, newSelection, added, removed)
    originalOnSelectionChanged(oldSelection, newSelection, added, removed)
    local currentOrders, currentToggles = GetUnitCommandData(newSelection)
    import(sca_utils.. 'radialmenu.lua').SetAvailableOrders(currentOrders, currentToggles, newSelection)
end
