local UIUtil = import('/lua/ui/uiutil.lua')
local LayoutHelpers = import('/lua/maui/layouthelpers.lua')
local Group = import('/lua/maui/group.lua').Group
local Bitmap = import('/lua/maui/bitmap.lua').Bitmap
local profiles = GetPreference("profile.profiles") -- Gets our profiles table
local current = GetPreference("profile.current") -- gets the current profile
local Prefs = import('/lua/user/prefs.lua')--preferences
local sca_utils = '/mods/uimod/sca_utils/'
local UIManager = import(sca_utils .. 'uimanager.lua')
local skinning= import(sca_utils .. 'skinning.lua')

function SetLayout(gameParent)

	local controls = import('/lua/ui/game/borders.lua').controls
	
	if not controls.resizegroup then
		controls.resizegroup = Bitmap(gameParent)
		UIManager.dragOnUI(controls.resizegroup, "borders", true)
	end
	
	controls.bottom:SetTexture(UIUtil.SkinnableFile('/game/border_bottom/back_brd_l.dds'))
	controls.bottom.Bottom:Set(controls.resizegroup.Bottom)
	controls.bottom.Left:Set(gameParent.Left)
	controls.bottom.Right:Set(gameParent.Right)
	controls.bottom.Width:Set(function() return bottom.Right() - bottom.Left() end)
	controls.bottom:SetRenderPass(UIUtil.UIRP_UnderWorld)
	
	LayoutHelpers.FillParent(controls.controlClusterGroup, controls.bottom)
	controls.controlClusterGroup:SetRenderPass(UIUtil.UIRP_PostGlow)    
	
	controls.top:SetTexture(UIUtil.SkinnableFile('/game/border_bottom/back_brd_l.dds'))
	controls.top.Top:Set(controls.resizegroup.Top)
	controls.top.Left:Set(gameParent.Left)
	controls.top.Right:Set(gameParent.Right)
	controls.top.Width:Set(function() return controls.top.Right() - controls.top.Left() end)
	
	LayoutHelpers.FillParent(controls.statusClusterGroup, controls.top)
	
	controls.left:SetTexture(UIUtil.SkinnableFile('/game/border_bottom/back_brd_l.dds'))
	controls.left.Top:Set(controls.top.Bottom)
	controls.left.Bottom:Set(controls.bottom.Top)
	controls.left.Left:Set(controls.resizegroup.Left)
	controls.left.Height:Set(function() return controls.left.Bottom() - controls.left.Top() end)
	
	controls.right:SetTexture(UIUtil.SkinnableFile('/game/border_bottom/back_brd_r.dds'))
	controls.right.Top:Set(controls.top.Bottom)
	controls.right.Bottom:Set(controls.bottom.Top)
	controls.right.Right:Set(controls.resizegroup.Right)
	controls.right.Height:Set(function() return controls.right.Bottom() - controls.right.Top() end)
	
	
	controls.bottom.Depth:Set(5)
	controls.left.Depth:Set(5)
	controls.right.Depth:Set(5)
	controls.top.Depth:Set(5)
	controls.left:SetRenderPass(UIUtil.UIRP_UnderWorld)
	controls.top:SetRenderPass(UIUtil.UIRP_UnderWorld)
	controls.right:SetRenderPass(UIUtil.UIRP_UnderWorld)

	
	controls.mapGroup.Left:Set(controls.left.Right)
	controls.mapGroup.Top:Set(controls.top.Bottom)
	controls.mapGroup.Right:Set(controls.right.Left)
	controls.mapGroup.Bottom:Set(controls.bottom.Top)
	
	controls.bottomLeftOS:Destroy()
	controls.bottomRightOS:Destroy()
	controls.topLeftOS:Destroy()
	controls.topRightOS:Destroy()
	controls.bottomOS:Destroy()
	controls.topOS:Destroy()
	controls.leftOS:Destroy()
	controls.rightOS:Destroy()
	
	controls.bottomLeftOS = false
	controls.bottomRightOS = false
	controls.topLeftOS = false
	controls.topRightOS = false
	controls.bottomOS = false
	controls.topOS = false
	controls.leftOS = false
	controls.rightOS = false
	
	if Prefs.GetFromCurrentProfile("uimanager_sav")["showborders"]==1 then
		controls.resizegroup:Show()
		skinning.GetSkin("borders", controls.resizegroup, gameParent, "bg")
	else
		controls.resizegroup:Hide()
	end
	if controls.mapGroupLeft then
		controls.mapGroupLeft.Left:Set(controls.left.Right)
		controls.mapGroupLeft.Top:Set(controls.top.Bottom)
		controls.mapGroupLeft.Right:Set(function() return (controls.left.Right() - 3) + ((controls.right.Left() - controls.left.Right()) / 2) end)
		controls.mapGroupLeft.Bottom:Set(controls.bottom.Top)
		
		controls.mapGroupRight.Left:Set(function() return (controls.left.Right() + 3) + ((controls.right.Left() - controls.left.Right()) / 2) end)
		controls.mapGroupRight.Top:Set(controls.top.Bottom)
		controls.mapGroupRight.Right:Set(controls.right.Left)
		controls.mapGroupRight.Bottom:Set(controls.bottom.Top)
			
		controls.mapGroup.Left:Set(controls.mapGroupLeft.Left)
		controls.mapGroup.Top:Set(controls.mapGroupLeft.Top)
		controls.mapGroup.Right:Set(controls.mapGroupRight.Right)
		controls.mapGroup.Bottom:Set(controls.mapGroupLeft.Bottom)
	else
		controls.mapGroup.Left:Set(controls.left.Right)
		controls.mapGroup.Top:Set(controls.top.Bottom)
		controls.mapGroup.Right:Set(controls.right.Left)
		controls.mapGroup.Bottom:Set(controls.bottom.Top)
	end
end
