local UIUtil = import('/lua/ui/uiutil.lua')
local LayoutHelpers = import('/lua/maui/layouthelpers.lua')
local Grid = import('/lua/maui/grid.lua').Grid
local pathuiimg = '/mods/uimod/textures'
local Bitmap = import('/lua/maui/bitmap.lua').Bitmap

local MultiFunction = import('/lua/ui/game/multifunction.lua')
local profiles = GetPreference("profile.profiles") -- Gets our profiles table
local current = GetPreference("profile.current") -- gets the current profile
local Prefs = import('/lua/user/prefs.lua')--preferences
local sca_utils = '/mods/uimod/sca_utils/'
local skinning=import(sca_utils .. 'skinning.lua')


gridX = 48
gridY = 48

function SetLayout()
    local controls = import('/lua/ui/game/construction.lua').controls
    local mfdControl = import('/lua/ui/game/construction.lua').mfdControl
    local ordersControl = import('/lua/ui/game/construction.lua').ordersControl
    local controlClusterGroup = import('/lua/ui/game/construction.lua').controlClusterGroup
    local queueControl = import('/lua/ui/game/construction.lua').queueControl
	
	controls.constructionGroup.Depth:Set(150)
    

	controls.constructionGroup.Mini = function(state)
		controls.constructionGroup:SetHidden(state)
	end


	LayoutHelpers.AtLeftTopIn(controls.unitsBGCapMin, controls.constructionGroup)
	LayoutHelpers.AtLeftTopIn(controls.unitsBGCapMax, controls.constructionGroup)
	LayoutHelpers.AtLeftTopIn(controls.unitsBGMiddle, controls.constructionGroup)
	controls.unitsBGCapMin:SetTexture(pathuiimg.. '/blank.dds')
    controls.unitsBGCapMax:SetTexture(pathuiimg.. '/blank.dds')
    controls.unitsBGMiddle:SetTexture(pathuiimg.. '/blank.dds')
	controls.tech1Tab.checkbox:SetTexture(pathuiimg.. '/blank.dds')
	controls.tech1Tab.icon:SetTexture(pathuiimg.. '/blank.dds')
	controls.tech2Tab.checkbox:SetTexture(pathuiimg.. '/blank.dds')
	controls.tech2Tab.icon:SetTexture(pathuiimg.. '/blank.dds')
	controls.tech3Tab.checkbox:SetTexture(pathuiimg.. '/blank.dds')
	controls.tech3Tab.icon:SetTexture(pathuiimg.. '/blank.dds')
	controls.tech4Tab.checkbox:SetTexture(pathuiimg.. '/blank.dds')
	controls.tech4Tab.icon:SetTexture(pathuiimg.. '/blank.dds')
	controls.scrollUnitsBackButton:SetTexture(pathuiimg.. '/blank.dds')
	controls.scrollUnitsFwdButton:SetTexture(pathuiimg.. '/blank.dds')
	controls.enhanceButton:SetTexture(pathuiimg.. '/blank.dds')
	controls.unitGrid:Destroy()
	controls.unitGrid = Grid(controls.unitsBGMiddle, gridX, gridY)
	
	controls.unitsBGCapMin.Depth:Set(controls.constructionGroup.Depth() + 2)
    controls.unitsBGCapMax.Depth:Set(controls.constructionGroup.Depth() + 2)
    controls.unitsBGMiddle.Depth:Set(controls.constructionGroup.Depth() + 2)
	controls.tech1Tab.checkbox.Depth:Set(controls.constructionGroup.Depth() + 5)
	controls.tech1Tab.icon.Depth:Set(controls.constructionGroup.Depth() + 5)
	controls.tech2Tab.checkbox.Depth:Set(controls.constructionGroup.Depth() + 5)
	controls.tech2Tab.icon.Depth:Set(controls.constructionGroup.Depth() + 5)
	controls.tech3Tab.checkbox.Depth:Set(controls.constructionGroup.Depth() + 5)
	controls.tech3Tab.icon.Depth:Set(controls.constructionGroup.Depth() + 5)
	controls.tech4Tab.checkbox.Depth:Set(controls.constructionGroup.Depth() + 5)
	controls.tech4Tab.icon.Depth:Set(controls.constructionGroup.Depth() + 5)
	controls.scrollUnitsBackButton.Depth:Set(controls.constructionGroup.Depth() +4)
	controls.scrollUnitsFwdButton.Depth:Set(controls.constructionGroup.Depth() + 4)
	controls.enhanceButton.Depth:Set(controls.constructionGroup.Depth() + 4)
	controls.unitGrid.Depth:Set(controls.constructionGroup.Depth() + 3)

	if Prefs.GetFromCurrentProfile("uimanager_sav")["vertconstruction"] == 1 then
		skinning.GetSkin("construction", controls.constructionGroup, controls.constructionGroup, "verticalbg")
	 
		if Prefs.GetFromCurrentProfile("uimanager_sav")["altconstruction"] == 1 then
			skinning.GetSkin("construction", controls.tech1Tab.checkbox, controls.constructionGroup, "tech1tab_mini")			
			skinning.GetSkin("construction", controls.tech2Tab.checkbox, controls.constructionGroup, "tech2tab_mini")			
			skinning.GetSkin("construction", controls.tech3Tab.checkbox, controls.constructionGroup, "tech3tab_mini")			
			skinning.GetSkin("construction", controls.tech4Tab.checkbox, controls.constructionGroup, "tech4tab_mini")			
			skinning.GetSkin("construction", controls.enhanceButton, controls.constructionGroup, "enhancebtn_mini")			
			skinning.GetSkin("construction", controls.scrollUnitsBackButton, controls.constructionGroup, "scrollup_vmini")			
			skinning.GetSkin("construction", controls.scrollUnitsFwdButton, controls.constructionGroup, "scrolldown_vmini")			
			skinning.GetSkin("construction", controls.tech1Tab.icon, controls.tech1Tab.checkbox, "tech1icon_mini")
			skinning.GetSkin("construction", controls.tech2Tab.icon, controls.tech2Tab.checkbox, "tech2icon_mini")			
			skinning.GetSkin("construction", controls.tech3Tab.icon, controls.tech3Tab.checkbox, "tech3icon_mini")			
			skinning.GetSkin("construction", controls.tech4Tab.icon, controls.tech4Tab.checkbox, "tech4icon_mini")			
		else
			skinning.GetSkin("construction", controls.tech1Tab.checkbox, controls.constructionGroup, "tech1tab_v")			
			skinning.GetSkin("construction", controls.tech2Tab.checkbox, controls.constructionGroup, "tech2tab_v")			
			skinning.GetSkin("construction", controls.tech3Tab.checkbox, controls.constructionGroup, "tech3tab_v")			
			skinning.GetSkin("construction", controls.tech4Tab.checkbox, controls.constructionGroup, "tech4tab_v")			
			skinning.GetSkin("construction", controls.enhanceButton, controls.constructionGroup, "enhancebtn_v")			
			skinning.GetSkin("construction", controls.scrollUnitsBackButton, controls.constructionGroup, "scrollup_v")			
			skinning.GetSkin("construction", controls.scrollUnitsFwdButton, controls.constructionGroup, "scrolldown_v")			
			skinning.GetSkin("construction", controls.tech1Tab.icon, controls.tech1Tab.checkbox, "tech1icon_v")
			skinning.GetSkin("construction", controls.tech2Tab.icon, controls.tech2Tab.checkbox, "tech2icon_v")			
			skinning.GetSkin("construction", controls.tech3Tab.icon, controls.tech3Tab.checkbox, "tech3icon_v")			
			skinning.GetSkin("construction", controls.tech4Tab.icon, controls.tech4Tab.checkbox, "tech4icon_v")			
		end
		

		LayoutHelpers.FillParent(controls.tech2disabledOverGroup, controls.tech2Tab.checkbox) 
		LayoutHelpers.FillParent(controls.tech3disabledOverGroup, controls.tech3Tab.checkbox) 
		LayoutHelpers.FillParent(controls.tech4disabledOverGroup, controls.tech4Tab.checkbox) 

		local gridLeft, gridTop, gridRight, gridBottom = skinning.SetGridBounds("construction", "grid_v")
		controls.unitGrid.Left:Set(function() return controls.constructionGroup.Left() + gridLeft end)
		controls.unitGrid.Top:Set(function() return controls.constructionGroup.Top() + gridTop end)
		controls.unitGrid.Right:Set(function() return controls.constructionGroup.Right() - gridRight end)
		controls.unitGrid.Bottom:Set(function() return controls.constructionGroup.Bottom() - gridBottom end)
		controls.unitGrid.Depth:Set(controls.constructionGroup.Depth() + 8)
		--for the minimum resize value
		controls.constructionGroup.xmin = 180
		controls.constructionGroup.ymin = 190

	else
		skinning.GetSkin("construction", controls.constructionGroup, controls.constructionGroup, "bg")
	 
		if Prefs.GetFromCurrentProfile("uimanager_sav")["altconstruction"] == 1 then
			skinning.GetSkin("construction", controls.tech1Tab.checkbox, controls.constructionGroup, "tech1tab_mini")			
			skinning.GetSkin("construction", controls.tech2Tab.checkbox, controls.constructionGroup, "tech2tab_mini")			
			skinning.GetSkin("construction", controls.tech3Tab.checkbox, controls.constructionGroup, "tech3tab_mini")			
			skinning.GetSkin("construction", controls.tech4Tab.checkbox, controls.constructionGroup, "tech4tab_mini")			
			skinning.GetSkin("construction", controls.enhanceButton, controls.constructionGroup, "enhancebtn_mini")			
			skinning.GetSkin("construction", controls.tech1Tab.icon, controls.tech1Tab.checkbox, "tech1icon_mini")
			skinning.GetSkin("construction", controls.tech2Tab.icon, controls.tech2Tab.checkbox, "tech2icon_mini")			
			skinning.GetSkin("construction", controls.tech3Tab.icon, controls.tech3Tab.checkbox, "tech3icon_mini")			
			skinning.GetSkin("construction", controls.tech4Tab.icon, controls.tech4Tab.checkbox, "tech4icon_mini")			
		else
			skinning.GetSkin("construction", controls.tech1Tab.checkbox, controls.constructionGroup, "tech1tab")			
			skinning.GetSkin("construction", controls.tech2Tab.checkbox, controls.constructionGroup, "tech2tab")			
			skinning.GetSkin("construction", controls.tech3Tab.checkbox, controls.constructionGroup, "tech3tab")			
			skinning.GetSkin("construction", controls.tech4Tab.checkbox, controls.constructionGroup, "tech4tab")			
			skinning.GetSkin("construction", controls.enhanceButton, controls.constructionGroup, "enhancebtn")			
			skinning.GetSkin("construction", controls.tech1Tab.icon, controls.tech1Tab.checkbox, "tech1icon")
			skinning.GetSkin("construction", controls.tech2Tab.icon, controls.tech2Tab.checkbox, "tech2icon")			
			skinning.GetSkin("construction", controls.tech3Tab.icon, controls.tech3Tab.checkbox, "tech3icon")			
			skinning.GetSkin("construction", controls.tech4Tab.icon, controls.tech4Tab.checkbox, "tech4icon")			
		end

		LayoutHelpers.FillParent(controls.tech2disabledOverGroup, controls.tech2Tab.checkbox) 
		LayoutHelpers.FillParent(controls.tech3disabledOverGroup, controls.tech3Tab.checkbox) 
		LayoutHelpers.FillParent(controls.tech4disabledOverGroup, controls.tech4Tab.checkbox) 

		
		skinning.GetSkin("construction", controls.scrollUnitsBackButton, controls.constructionGroup, "scrollup")			
		skinning.GetSkin("construction", controls.scrollUnitsFwdButton, controls.constructionGroup, "scrolldown")			
		
		local gridLeft, gridTop, gridRight, gridBottom = skinning.SetGridBounds("construction", "grid")
		controls.unitGrid.Left:Set(function() return controls.constructionGroup.Left() + gridLeft end)
		controls.unitGrid.Top:Set(function() return controls.constructionGroup.Top() + gridTop end)
		controls.unitGrid.Right:Set(function() return controls.constructionGroup.Right() - gridRight end)
		controls.unitGrid.Bottom:Set(function() return controls.constructionGroup.Bottom() - gridBottom end)
		--for the minimum resize value
		controls.constructionGroup.xmin = 180
		controls.constructionGroup.ymin = 64  --126
	end

	controls.constructionGroup:DisableHitTest()
end
