local pathui = '/mods/uimod/hook'
local pathuiimg='/mods/uimod/textures'
local UIManager= import('/mods/uimod/sca_utils/uimanager.lua')
local sca_utils = '/mods/uimod/sca_utils/'
local UIManager = import(sca_utils .. 'uimanager.lua')
local skinning=import(sca_utils .. 'skinning.lua')

local UIUtil = import('/lua/ui/uiutil.lua')
local LayoutHelpers = import('/lua/maui/layouthelpers.lua')
local Group = import('/lua/maui/group.lua').Group
local Bitmap = import('/lua/maui/bitmap.lua').Bitmap
local Checkbox = import('/lua/maui/checkbox.lua').Checkbox
local Button = import('/lua/maui/button.lua').Button
local controls = import('/lua/ui/game/multifunction.lua').controls
local buttonData = import('/lua/ui/game/multifunction.lua').buttonData
local Tooltip = import('/lua/ui/game/tooltip.lua')

--mod
local minimap = true --Prefs.GetFromCurrentProfile('stratview') or false

local orders = import('/lua/ui/game/orders.lua').controls.bg

local MultiFunction = import('/lua/ui/game/multifunction.lua')
local profiles = GetPreference("profile.profiles") -- Gets our profiles table
local current = GetPreference("profile.current") -- gets the current profile
local Prefs = import('/lua/user/prefs.lua')--preferences

local function CreateMFDCheckbox(name, behavior, label, isbutton)
    local button = false
    if not isbutton then
        button = Checkbox(controls.bg, nil, nil, nil, nil, nil, nil, "UI_MFD_Click", "UI_MFD_Rollover")
        button.HandleEvent = function(self, event)
            if event.Type == 'MouseEnter' then
                Tooltip.CreateMouseoverDisplay(self, label, nil, true)
            elseif event.Type == 'MouseExit' then
                Tooltip.DestroyMouseoverDisplay()
            end
            Checkbox.HandleEvent(self, event)
        end
        button.OnCheck = behavior
    else
        button = Button(controls.bg, nil, nil, nil, nil, "UI_MFD_Click", "UI_MFD_Rollover")
        button.HandleEvent = function(self, event)
            if event.Type == 'MouseEnter' then
                Tooltip.CreateMouseoverDisplay(self, label, nil, true)
            elseif event.Type == 'MouseExit' then
                Tooltip.DestroyMouseoverDisplay()
            end
            Button.HandleEvent(self, event)
        end
        button.OnClick = behavior
    end
    return button
end

function SetLayout(minimap, onToggleMinimap)
    if not onToggleMinimap then
		if controls.miniMap.BG.Resizer then	controls.miniMap.BG.Resizer:Destroy() controls.miniMap.BG.Resizer = false end
		if controls.miniMap.BG then controls.miniMap.BG:Destroy() controls.miniMap.BG = false end
        if controls.displayGroup then controls.displayGroup:Destroy() controls.displayGroup = false end
        if controls.miniMap then controls.miniMap:Destroy() controls.miniMap = false end
		if controls.bg.Resizer then	controls.bg.Resizer:Destroy() controls.bg.Resizer = false end
		if controls.bg then	controls.bg:Destroy() controls.bg = false end
	end
    if not controls.group then
        controls.group = Group(controls.controlClusterGroup, "MFD Group")
    
        controls.group:DisableHitTest()
    end
	
	if not controls.bg then
		controls.bg = Bitmap(controls.group)
		UIManager.dragOnUI(controls.bg, "mfd")

		controls.bg.Left:Set(controls.bg.Resizer.Left)
		controls.bg.Top:Set(controls.bg.Resizer.Top)

		for i = 1, table.getn(buttonData) do
			controls.minimapBtns[i] = CreateMFDCheckbox(buttonData[i].btnName, buttonData[i].clickBehavior, buttonData[i].label, buttonData[i].button)
			controls.minimapBtns[i].Depth:Set(function() return controls.bg.Depth() + 1 end)
		end
	end
	if not controls.displayGroup then
		controls.displayGroup = Group(GetFrame(0),"MFD Display Group")
		controls.displayGroup.Depth:Set(3)
	end
	if not controls.miniMap then
		controls.miniMap = import('/lua/ui/controls/worldview.lua').WorldView(controls.displayGroup, 'MiniMap', 2, true, 'WorldCamera')    -- depth value is above minimap
		controls.miniMap:SetName("Minimap")
        controls.miniMap:Register('MiniMap', true, '<LOC map_view_0000>MiniMap')
		controls.miniMap:SetRenderPass(UIUtil.UIRP_UnderWorld) -- don't change this or the camera will lag one frame behind
		controls.miniMap.Depth:Set(10)
		controls.miniMap:SetNeedsFrameUpdate(true)
		-- defer the camera reset one frame so a view is created, this causes a fully zoomed out map
		local frameCount = 0
		controls.miniMap.OnFrame = function(self, elapsedTime)
			if frameCount == 1 then
				controls.miniMap:CameraReset()
				controls.miniMap.OnFrame = nil  -- we want the control to continue to get frame updates in the engine, but not in Lua. PLEASE DON'T CHANGE THIS OR IT BREAKS CAMERA DRAGGING
			end
			frameCount = frameCount + 1
		end
		LayoutHelpers.FillParent(controls.miniMap, controls.displayGroup)
        if not minimap then 
            controls.displayGroup:Hide()
        end 
	end
	if not controls.miniMap.BG then
		controls.miniMap.BG = Bitmap(controls.miniMap)
		controls.miniMap.BG.Depth:Set(function() return controls.miniMap.Depth() -1 end)
		UIManager.dragOnUI(controls.miniMap.BG, "minimap", true)
		controls.glow = Bitmap(controls.miniMap.BG)
		controls.glow:DisableHitTest()
		controls.glow.Depth:Set(function() return controls.miniMap.Depth() - 1 end)
		controls.glow:SetRenderPass(UIUtil.UIRP_PostGlow)
	end
	controls.bg:SetTexture(pathuiimg.. '/blank.dds')
	controls.glow:SetTexture(pathuiimg.. '/blank.dds')
	controls.miniMap.BG:SetTexture(pathuiimg.. '/blank.dds')
	LayoutHelpers.FillParent(controls.miniMap.BG, controls.miniMap)
	LayoutHelpers.FillParent(controls.glow, controls.miniMap.BG)

	if Prefs.GetFromCurrentProfile("uimanager_sav")["verticalMFD"]==1 then
		skinning.GetSkin("mfd", controls.bg, controls.bg, "verticalbg")
		for i, v in controls.minimapBtns do
			local index = i
			skinning.GetSkin("mfd", controls.minimapBtns[index], controls.bg, buttonData[index].btnName .. '_v')
		end		
	else
		skinning.GetSkin("mfd", controls.bg, controls.bg, "bg")
		for i, v in controls.minimapBtns do
			local index = i
			skinning.GetSkin("mfd", controls.minimapBtns[index], controls.bg, buttonData[index].btnName)
		end		
	end
	
	skinning.GetSkin("minimap", controls.glow, controls.miniMap.BG, "glow")
	skinning.GetSkin("minimap", controls.miniMap.BG, controls.miniMap.BG, "bg")
	if controls.miniMap.BG.Resizer then
		LayoutHelpers.FillParent(controls.miniMap.BG, controls.miniMap.BG.Resizer)
	else
		controls.miniMap.BG.Left:Set(150)
		controls.miniMap.BG.Top:Set(100)
	end

	controls.group.Top:Set(0)
    controls.group.Left:Set(0)
    controls.group.Bottom:Set(10)
    controls.group.Right:Set(10)

--[[	controls.displayGroup.Top:Set(function() return controls.miniMap.BG.Top() + 10 end)
	controls.displayGroup.Bottom:Set(function() return controls.miniMap.BG.Bottom() - 12 end)
	controls.displayGroup.Left:Set(function() return controls.miniMap.BG.Left() + 10 end)
	controls.displayGroup.Right:Set(function() return controls.miniMap.BG.Right() - 10 end)]]
	
	minimapLeft, minimapTop, minimapRight, minimapBottom = skinning.SetGridBounds('minimap', 'borders')
	controls.displayGroup.Top:Set(function() return controls.miniMap.BG.Top() + minimapTop end)
	controls.displayGroup.Bottom:Set(function() return controls.miniMap.BG.Bottom() - minimapBottom end)
	controls.displayGroup.Left:Set(function() return controls.miniMap.BG.Left() + minimapLeft end)
	controls.displayGroup.Right:Set(function() return controls.miniMap.BG.Right() - minimapRight end)
	
	controls.miniMap.BG.xmin = 100
	controls.miniMap.BG.ymin = 100
	
    if Prefs.GetFromCurrentProfile("uimanager_sav")["miniui_econ"]==1 then
		if controls.bg then
			controls.bg.Resizer:Destroy()
			controls.bg.Resizer = false
			controls.bg:Destroy() 
			controls.bg = false
		end
	    for i, v in controls.minimapBtns do
	        if controls.minimapBtns[i] then
	            controls.minimapBtns[i]:Destroy()
	            controls.minimapBtns[i] = false
	        end
	    end
	end
end
