
local UIUtil = import('/lua/ui/uiutil.lua')
local LayoutHelpers = import('/lua/maui/layouthelpers.lua')
local GameCommon = import('/lua/ui/game/gamecommon.lua')
local numSlots = 12
local firstAltSlot = 7
local Cols = 3
local Rows = 4

local pathuiimg = '/mods/uimod/textures'
local MultiFunction = import('/lua/ui/game/multifunction.lua')
local profiles = GetPreference("profile.profiles") -- Gets our profiles table
local current = GetPreference("profile.current") -- gets the current profile
local Prefs = import('/lua/user/prefs.lua')--preferences
local sca_utils = '/mods/uimod/sca_utils/'
local skinning= import(sca_utils .. 'skinning.lua')
--gridX = 64
--gridY = 64

function SetLayout()
    local controls = import('/lua/ui/game/orders.lua').controls
	controls.bg.Depth:Set(110)
	controls.bg:SetTexture(pathuiimg.. '/blank.dds')
	if Prefs.GetFromCurrentProfile("uimanager_sav")["ordersgrid"]==34 then
		skinning.GetSkin("orders", controls.bg, controls.bg, "3by4")
		skinning.SetOrdersGrid("orders", controls.orderButtonGrid, controls.bg, "3by4Grid")
    elseif Prefs.GetFromCurrentProfile("uimanager_sav")["ordersgrid"]==43 then
		skinning.GetSkin("orders", controls.bg, controls.bg, "4by3")
		skinning.SetOrdersGrid("orders", controls.orderButtonGrid, controls.bg, "4by3Grid")
	elseif Prefs.GetFromCurrentProfile("uimanager_sav")["ordersgrid"]==62 then
		skinning.GetSkin("orders", controls.bg, controls.bg, "6by2")
		skinning.SetOrdersGrid("orders", controls.orderButtonGrid, controls.bg, "6by2Grid")
	else
		controls.orderButtonGrid.Width:Set(200)
		controls.orderButtonGrid.Height:Set(200)
		LayoutHelpers.AtCenterIn(controls.orderButtonGrid, controls.bg)
		controls.orderButtonGrid:AppendRows(3)
		controls.orderButtonGrid:AppendCols(4)
	end

	controls.bg:Show()
	controls.orderButtonGrid:Show()

	if Prefs.GetFromCurrentProfile("uimanager_sav")["affiche_construc"]==0 then
		controls.bg.Mini = function(state)
			controls.bg:Show()
			controls.orderButtonGrid:Show()
		end
	else
		controls.bg.Mini = function(state)
			controls.bg:SetHidden(state)
			controls.orderButtonGrid:SetHidden(state)
		end	
	end
end