
local Grid = import('/lua/maui/grid.lua').Grid
local pathuiimg = '/mods/uimod/textures'
local LayoutHelpers = import('/lua/maui/layouthelpers.lua')

local profiles = GetPreference("profile.profiles") -- Gets our profiles table
local current = GetPreference("profile.current") -- gets the current profile
local Prefs = import('/lua/user/prefs.lua')--preferences
local sca_utils = '/mods/uimod/sca_utils/'
local skinning=import(sca_utils .. 'skinning.lua')

gridX = 48
gridY = 48

function SetLayout()
    local controls = import('/lua/ui/game/queue.lua').controls

	controls.queueGroup.Depth:Set(130)
    
  	if Prefs.GetFromCurrentProfile("uimanager_sav")["affiche_construc"]==0 then
		controls.queueGroup.Mini = function(state)
			controls.queueGroup:Show()
		end
		controls.queueGroup:Show()
	else
	    controls.queueGroup.Mini = function(state)
			controls.queueGroup:SetHidden(state)
		end
	end	

	LayoutHelpers.AtLeftTopIn(controls.queueBGCapMin, controls.queueGroup)
	LayoutHelpers.AtLeftTopIn(controls.queueBGCapMax, controls.queueGroup)
	LayoutHelpers.AtLeftTopIn(controls.queueBGMiddle, controls.queueGroup)
	controls.queueBGCapMin:SetTexture(pathuiimg.. '/blank.dds')
	controls.queueBGCapMax:SetTexture(pathuiimg.. '/blank.dds')
	controls.queueBGMiddle:SetTexture(pathuiimg.. '/blank.dds')
	controls.infiniteQueueToggle:SetTexture(pathuiimg.. '/blank.dds')
	controls.pauseToggle:SetTexture(pathuiimg.. '/blank.dds')
	controls.scrollQueueBackButton:SetTexture(pathuiimg.. '/blank.dds')
	controls.scrollQueueFwdButton:SetTexture(pathuiimg.. '/blank.dds')
	controls.infiniteQueueToggle.Depth:Set(function() return controls.queueGroup.Depth() + 10 end)
	controls.pauseToggle.Depth:Set(function() return controls.queueGroup.Depth() + 10 end)
	controls.scrollQueueBackButton.Depth:Set(function() return controls.queueGroup.Depth() + 10 end)
	controls.scrollQueueFwdButton.Depth:Set(function() return controls.queueGroup.Depth() + 10 end)
	controls.scrollQueueBackButton:Disable()
	controls.scrollQueueFwdButton:Disable()

	controls.queueGrid:Destroy()
	controls.queueGrid = Grid(controls.queueGroup, gridX, gridY)
	
	if Prefs.GetFromCurrentProfile("uimanager_sav")["vertqueue"]==1 then
		skinning.GetSkin("queue", controls.queueGroup, controls.queueGroup, "verticalbg")
		skinning.GetSkin("queue", controls.infiniteQueueToggle, controls.queueGroup, "infinitebtn_v")
		skinning.GetSkin("queue", controls.pauseToggle, controls.queueGroup, "pausebtn_v")
		skinning.GetSkin("queue", controls.scrollQueueBackButton, controls.queueGroup, "scrollup_v")
		skinning.GetSkin("queue", controls.scrollQueueFwdButton, controls.queueGroup, "scrolldown_v")

		local gridLeft, gridTop, gridRight, gridBottom = skinning.SetGridBounds("queue", "grid_v")
		controls.queueGrid.Left:Set(function() return controls.queueGroup.Left() + gridLeft end)
		controls.queueGrid.Top:Set(function() return controls.queueGroup.Top() + gridTop end)
		controls.queueGrid.Right:Set(function() return controls.queueGroup.Right() - gridRight end)
		controls.queueGrid.Bottom:Set(function() return controls.queueGroup.Bottom() - gridBottom end)

		controls.queueGroup.xmin = 160
		controls.queueGroup.ymin = 120
	else
		skinning.GetSkin("queue", controls.queueGroup, controls.queueGroup, "bg")
		skinning.GetSkin("queue", controls.infiniteQueueToggle, controls.queueGroup, "infinitebtn")
		skinning.GetSkin("queue", controls.pauseToggle, controls.queueGroup, "pausebtn")
		skinning.GetSkin("queue", controls.scrollQueueBackButton, controls.queueGroup, "scrollup")
		skinning.GetSkin("queue", controls.scrollQueueFwdButton, controls.queueGroup, "scrolldown")

		local gridLeft, gridTop, gridRight, gridBottom = skinning.SetGridBounds("queue", "grid")
		controls.queueGrid.Left:Set(function() return controls.queueGroup.Left() + gridLeft end)
		controls.queueGrid.Top:Set(function() return controls.queueGroup.Top() + gridTop end)
		controls.queueGrid.Right:Set(function() return controls.queueGroup.Right() - gridRight end)
		controls.queueGrid.Bottom:Set(function() return controls.queueGroup.Bottom() - gridBottom end)

		controls.queueGroup.xmin = 160
		controls.queueGroup.ymin = 64
	end
 
	controls.queueScrollBG:Destroy() -- CHECK THIS STILL WORKS AFTER NEXT PATCH, GPG BUG ATM.
	

end