
local UIUtil = import('/lua/ui/uiutil.lua')
local LayoutHelpers = import('/lua/maui/layouthelpers.lua')
local Grid = import('/lua/maui/grid.lua').Grid
local Group = import('/lua/maui/group.lua').Group
local Bitmap = import('/lua/maui/bitmap.lua').Bitmap
local Button = import('/lua/maui/button.lua').Button
local pathuiimg = '/mods/uimod/textures'

local MultiFunction = import('/lua/ui/game/multifunction.lua')
local profiles = GetPreference("profile.profiles") -- Gets our profiles table
local current = GetPreference("profile.current") -- gets the current profile
local Prefs = import('/lua/user/prefs.lua')--preferences
local sca_utils = '/mods/uimod/sca_utils/'
local skinning=import(sca_utils .. 'skinning.lua')

gridX = 48
gridY = 48

function SetLayout()
	local controls = import('/lua/ui/game/selectionmanager.lua').controls
	local constGroup = import('/lua/ui/game/construction.lua').controls.constructionGroup

    if not controls.panelmin then
        controls.panelmin = Bitmap(controls.controlClusterGroup)
        controls.panelmin.Depth:Set(600)
    end
	if not controls.panelmax then
        controls.panelmax = Bitmap(controls.panelmin)
    end
    if not controls.panelstretch then
        controls.panelstretch = Bitmap(controls.panelmin)
    end
	if Prefs.GetFromCurrentProfile("uimanager_sav")["affiche_construc"]==0 then
		controls.panelmin.Mini = function(state)
			controls.panelmin:Show()
		end
		controls.panelmin:Show()
	else
	    controls.panelmin.Mini = function(state)
			controls.panelmin:SetHidden(state)
		end
	end	
    if not controls.scrollup then
        controls.scrollup = Button(controls.panelmin)
    end
    
    if not controls.scrolldown then
        controls.scrolldown = Button(controls.panelmin)
    end
	
	if not controls.panelmin.grp then
		controls.panelmin.grp = Bitmap(controls.panelmin)
	end

	LayoutHelpers.AtLeftTopIn(controls.panelmin, constGroup)
	LayoutHelpers.AtLeftTopIn(controls.panelmax, constGroup)
	LayoutHelpers.AtLeftTopIn(controls.panelstretch, constGroup)
	controls.panelmin:SetTexture(pathuiimg.. '/blank.dds')
	controls.panelmax:SetTexture(pathuiimg.. '/blank.dds')
	controls.panelstretch:SetTexture(pathuiimg.. '/blank.dds')
	controls.scrollup:SetTexture(pathuiimg.. '/blank.dds')
 	controls.scrolldown:SetTexture(pathuiimg.. '/blank.dds')
	if controls.iconGrid then controls.iconGrid:Destroy() end
	controls.iconGrid = Grid(controls.panelstretch, gridX, gridY)
	
	controls.panelmin.Depth:Set(function() return 600 end)
	controls.panelmax.Depth:Set(function() return 600 end)
	controls.panelstretch.Depth:Set(function() return 600 end)
	controls.scrollup.Depth:Set(function() return controls.panelmin.Depth() + 10 end)
 	controls.scrolldown.Depth:Set(function() return controls.panelmin.Depth() + 10 end)
	controls.panelmin.grp.Depth:Set(function() return controls.panelmin.Depth() + 5 end)
	controls.iconGrid.Depth:Set(function() return controls.panelmin.Depth() + 10 end)

	
	LayoutHelpers.FillParent(controls.panelmin.grp, constGroup)

	if Prefs.GetFromCurrentProfile("uimanager_sav")["vertconstruction"] == 1 then
		skinning.GetSkin("selection", controls.panelmin.grp, constGroup, "verticalbg")
		skinning.GetSkin("selection", controls.scrollup, controls.panelmin.grp, "scrollup_v")
		skinning.GetSkin("selection", controls.scrolldown, controls.panelmin.grp, "scrolldown_v")

		local gridLeft, gridTop, gridRight, gridBottom = skinning.SetGridBounds("selection", "grid_v")
		controls.iconGrid.Left:Set(function() return controls.panelmin.grp.Left() + gridLeft end)
		controls.iconGrid.Top:Set(function() return controls.panelmin.grp.Top() + gridTop end)
		controls.iconGrid.Right:Set(function() return controls.panelmin.grp.Right() - gridRight end)
		controls.iconGrid.Bottom:Set(function() return controls.panelmin.grp.Bottom() - gridBottom end)
	else
		skinning.GetSkin("selection", controls.panelmin.grp, constGroup, "bg")
		skinning.GetSkin("selection", controls.scrollup, controls.panelmin.grp, "scrollup")
		skinning.GetSkin("selection", controls.scrolldown, controls.panelmin.grp, "scrolldown")
		
		local gridLeft, gridTop, gridRight, gridBottom = skinning.SetGridBounds("selection", "grid")
		controls.iconGrid.Left:Set(function() return controls.panelmin.grp.Left() + gridLeft end)
		controls.iconGrid.Top:Set(function() return controls.panelmin.grp.Top() + gridTop end)
		controls.iconGrid.Right:Set(function() return controls.panelmin.grp.Right() - gridRight end)
		controls.iconGrid.Bottom:Set(function() return controls.panelmin.grp.Bottom() - gridBottom end)
	end
end
