do
	local Prefs = import('/lua/user/prefs.lua')--preferences
	local sca_utils = '/mods/uimod/sca_utils/'
	local uimanager = import(sca_utils .. 'uimanager.lua')
	local uimod = import(sca_utils .. 'uimod.lua')
	local selectLayout = import(sca_utils .. 'layoutmanager.lua').selectLayout
	-- when this script loads, get the original function
	local originalUIFile = UIFile

	-- if the file name containt mods/...textures.. don't modify the directory
	-- otherwise could have ' /textures/ui/common/mods/uimod/hook/textures/ui/common/mod/' --> the program is unable to find the file
	function UIFile(filespec)
		local curfile=filespec
		if (string.find(filespec,'mods/') != nil) and (string.find(filespec,'textures') != nil) then
			--LOG("--fix directory-->",filespec)
		else
			curfile=originalUIFile(filespec)
		end	

	    return curfile
	end

	--* cycle through all available layouts
	function RotateLayout(direction)
		local scaLayouts = Prefs.GetFromCurrentProfile("uimanager_sav").basicLayouts
		local currentscaLayout = Prefs.GetFromCurrentProfile("uimanager_sav").currentscaLayout

	    # disable when in Screen Capture mode
	    if import('/lua/ui/game/gamemain.lua').gameUIHidden then
	        return
	    end

	    local dir
	    if direction == '+' then
	        dir = 1
	    else
	        dir = -1
	    end

	    local numLayouts = table.getn(scaLayouts)
		if numLayouts > 0 then
			local selected = false
		    for index, layout in scaLayouts do
				if layout[1] == currentscaLayout[1] and layout[2] == currentscaLayout[2] then
					local nextLayoutIndex = index + dir
					if nextLayoutIndex > numLayouts then nextLayoutIndex = 1 end
					if nextLayoutIndex < 1 then nextLayoutIndex = numLayouts end
					selectLayout(scaLayouts[nextLayoutIndex][1], scaLayouts[nextLayoutIndex][2])
					selected = true
					break
				end
			end
			if not selected then
				selectLayout(scaLayouts[1][1], scaLayouts[1][2])
			end
		end
	end
end
