--*****************************************************************************
--*
--*  mass fab switcher
--*
--*****************************************************************************
local UIUtil = import('/lua/ui/uiutil.lua')
local LayoutHelpers = import('/lua/maui/layouthelpers.lua')
local Bitmap = import('/lua/maui/bitmap.lua').Bitmap
local GameMain = import('/lua/ui/game/gamemain.lua')
local Button = import('/lua/maui/button.lua').Button
local Group = import('/lua/maui/group.lua').Group

local listThread
local switchThread

function CreateMassFabSwitchDisplay(parent)

-- the group creates a nice depth arrangement. otherwise the buttons show up under the map and dont get mouse input.
	MassFabSwitchContainer = Group (parent, "MassFabSwitchContainer")
	MassFabSwitchContainer:DisableHitTest()
	LayoutHelpers.AtLeftTopIn(MassFabSwitchContainer, parent, 0, 0)
	
	--[[
		function CreateCheckbox(parent, up, upsel, over, oversel, dis, dissel, clickCue, rollCue)

			avatarToggle = UIUtil.CreateCheckbox(avatarContainer, 
	        UIUtil.UIFile('/game/avatar-tab-btn/tab-close_btn_up.dds'),
	        UIUtil.UIFile('/game/avatar-tab-btn/tab-open_btn_up.dds'),
	        UIUtil.UIFile('/game/avatar-tab-btn/tab-close_btn_over.dds'),
	        UIUtil.UIFile('/game/avatar-tab-btn/tab-open_btn_over.dds'),
	        UIUtil.UIFile('/game/avatar-tab-btn/tab-close_btn_dis.dds'),
	        UIUtil.UIFile('/game/avatar-tab-btn/tab-open_btn_dis.dds'), 
	        'UI_Avatar_Hide')
	    LayoutHelpers.AtRightTopIn(avatarToggle, parent, 3, 15)
	 --   avatarToggle.OnCheck = function(self, checked)
	        ToggleAvatars(not checked)
	    end
	    ToolTip.AddCheckboxTooltip(avatarToggle, 'avatar_toggle')

    --ToggleCheck = function(self)
        if self._checkState == "checked" then
            self:SetCheck(false)
        else
            self:SetCheck(true)

		--]]

    local MFButton = UIUtil.CreateCheckbox(MassFabSwitchContainer,
        UIUtil.UIFile('/game/resources/energy_btn_dis.dds'),
        UIUtil.UIFile('/game/resources/energy_btn_over.dds'),
        UIUtil.UIFile('/game/resources/energy_btn_up.dds'),
        UIUtil.UIFile('/game/resources/energy_btn_down.dds'),
        UIUtil.UIFile('/game/resources/energy_btn_dis.dds'),
        UIUtil.UIFile('/game/resources/energy_btn_dis.dds'))

    LayoutHelpers.AtLeftTopIn(MFButton, MassFabSwitchContainer)
	
	MFButton.MassFabTotalList = {}
	MFButton.OnClick = function(self, modifiers)

		KillThread(listThread)
		KillThread(switchThread)

		if modifiers.Right then
			-- nothing, because we want the threads killed and refreshed either way
			self:SetCheck(false)
		else
			UpdateMassFabList(MFButton)
	--		SwitchMassFabs(MFButton.MassFabTotalList, false)
			listThread = ForkThread(MonitorMassFabList, MFButton)
			switchThread = ForkThread(RegulateMassFabs, MFButton)
			self:SetCheck(true)
		end
	end

	MFButton.T1Icon = Bitmap(MFButton, UIUtil.UIFile('/game/tech-icons-sm_btn/tech-level-1_icon_btn_up.dds'))
	LayoutHelpers.Below(MFButton.T1Icon, MFButton)

	MFButton.T1fabsontext = UIUtil.CreateText(MFButton, "on", 14, UIUtil.bodyFont)
	LayoutHelpers.RightOf(MFButton.T1fabsontext, MFButton.T1Icon, 0)
	MFButton.T1fabsontext:DisableHitTest()
	MFButton.T1fabstotaltext = UIUtil.CreateText(MFButton, "total", 14, UIUtil.bodyFont)
	LayoutHelpers.Below(MFButton.T1fabstotaltext, MFButton.T1fabsontext, 0)
	MFButton.T1fabstotaltext:DisableHitTest()

	MFButton.T3Icon = Bitmap(MFButton, UIUtil.UIFile('/game/tech-icons-sm_btn/tech-level-3_icon_btn_up.dds'))
	LayoutHelpers.Below(MFButton.T3Icon, MFButton.T1Icon)

	MFButton.T3fabsontext = UIUtil.CreateText(MFButton, "on", 14, UIUtil.bodyFont)
	LayoutHelpers.RightOf(MFButton.T3fabsontext, MFButton.T3Icon, 0)
	MFButton.T3fabsontext:DisableHitTest()
	MFButton.T3fabstotaltext = UIUtil.CreateText(MFButton, "total", 14, UIUtil.bodyFont)
	LayoutHelpers.Below(MFButton.T3fabstotaltext, MFButton.T3fabsontext, 0)
	MFButton.T3fabstotaltext:DisableHitTest()

--	GameMain.AddBeatFunction(forktest)

end

--[[local forktestthread
local threadrunning = false

function forktest()	-- beat function, will happen every game tick
	if threadrunning then
	--	KillThread(forktestthread)
	else
		forktestthread = ForkThread(forkinghell)
		print ("forking")
	
	end
end

function forkinghell()
	threadrunning = true
	WaitSeconds(2)
	threadrunning = false
	print ("forked")
end
--]]

--[[function checkrollover()
	local result = GetScriptBit(MassFabList, 4) -- returns false if they're ALL switched on, otherwise true
	local rolloverinfo = GetRolloverInfo()
	LOG('RolloverInfo = ', repr(rolloverinfo))
end
--]]

--[[  example junk:
local monitorThread = ForkThread(function()
  while not v:IsDead() do
     LOG('My Unit is not dead yet!')
     WaitSeconds(5)
  end
end)

KillThread(monitorThread)
--]]

--# comment to comment - rethinking this. # unit selection makes constant monitoring completely annoying.

function RegulateMassFabs(control)
	while true do
		CleanFabList(control)
		SwitchMassFabs(control.MassFabTotalList, false)
		UpdateMassFabText(control)
		WaitSeconds(3)	-- looks like it takes about 1 second for massfabs to actually switch - lag between sim and UI?
	end
end

function CleanFabList(control)	-- NEEDS DEATH CHECK JUST LIKE MEXES
	local fablist = control.MassFabTotalList
	for fab in fablist do
		collapseArray(fablist, function(fab) return fab:IsDead() end)
	end
	control.MassFabTotalList = fablist
end

function MonitorMassFabList(control)
	local rayden_has_no_eyes = true -- he's the thunder warrior with eternal life!
	while rayden_has_no_eyes do
		local selection = GetSelectedUnits()
			--# problem:
			--# if selection contains construction stuff, it will mess with queue. 
			--# if you are issuing orders (patrol, etc), it will cancel the order state.
		if selection then
			WaitSeconds(0.4)
		else
			UpdateMassFabList(control)
			WaitSeconds(5)
		end
	end
end

function UpdateMassFabText(control)
	local fablist = control.MassFabTotalList
	local T1FabsOnList, T1FabsOffList, T3FabsOnList, T3FabsOffList = SplitFabList(fablist)

	local numT1MassFabs = (table.getsize(T1FabsOnList) + table.getsize(T1FabsOffList))
	local t1mftotaltext = (string.format("%d", numT1MassFabs))
	local numT1MassFabsOn = table.getsize(T1FabsOnList)
	local t1fabsontext = (string.format("%d", numT1MassFabsOn))

	local numT3MassFabs = (table.getsize(T3FabsOnList) + table.getsize(T3FabsOffList))
	local t3mftotaltext = (string.format("%d", numT3MassFabs))
	local numT3MassFabsOn = table.getsize(T3FabsOnList)
	local t3fabsontext = (string.format("%d", numT3MassFabsOn))

	control.T1fabstotaltext:SetText(t1mftotaltext)
	control.T1fabsontext:SetText(t1fabsontext)

	control.T3fabstotaltext:SetText(t3mftotaltext)
	control.T3fabsontext:SetText(t3fabsontext)
end

function UpdateMassFabList(control)
	local fablist = GetMassFabList()
	control.MassFabTotalList = fablist
	UpdateMassFabText(control)
	print ("massfab list updated")
end

function GetMassFabList()
	local selection = GetSelectedUnits()
		--# the right way to do it?
		--# Get a list of T1 land units. -- local t1Land = ArmyBrains[1]:GetListOfUnits(categories.TECH1 * categories.LAND)
	UISelectionByCategory("MASSFABRICATION * STRUCTURE", false, false, false, false)
	local mflist = GetSelectedUnits()
	if mflist == nil then mflist = {} end

	SelectUnits(selection)
	return mflist
end

--Changed numbers about, and enabled t3 switching
function SwitchMassFabs(fablist, aggromode)

	local econData = GetEconomyTotals()
	local energyIncomeVal = econData["income"]["ENERGY"]
	local energyLastRequestedVal = econData["lastUseRequested"]["ENERGY"]
    local energyMaxStorageVal = econData["maxStorage"]["ENERGY"]	-- storage starts at 2500 (actually 2500. wtf?) and gets over 10k around T3
    local energyStoredVal = econData["stored"]["ENERGY"]

	local tolerance = energyStoredVal / energyMaxStorageVal	-- how wide a gap to allow in energy (radius style, 1 direction?) should be based on input, not storage
print ("tolerance: " .. tolerance)
	local energyNeeded = 1.2*(energyLastRequestedVal - energyIncomeVal) -- remember displayed values are this x10. (seconds vs game ticks?)
print ("energyneeded: " .. energyNeeded)	-- starting energy of +10 makes this number -1
--	local T1FabsToKill = math.ceil(energyNeeded / 4)	-- trying random crap.
--	local T1FabsToKill = (energyNeeded / 4)	-- T1 fabs suck down 40 energy if theres no adjacency

	local T1FabsOnList, T1FabsOffList, T3FabsOnList, T3FabsOffList = SplitFabList(fablist)

	if tolerance > 0.75 then
		-- lets switch SOMETHING
		local switchfablist = {}
		if energyNeeded < 0 then
			local sourceT3fablist = T3FabsOffList
			local i = 1
			if table.getn(sourceT3fablist) > 0 then
				while energyNeeded < 0 do
					table.insert(switchfablist, sourceT3fablist[i])
					i = i + 1
					energyNeeded = energyNeeded + 15 -- T3 fab
				end
			end
			local sourceT1fablist = T1FabsOffList
			local j = 1
			while energyNeeded < 0 do
				table.insert(switchfablist, sourceT1fablist[i])
				i = i + 1
				energyNeeded = energyNeeded + 4	-- T1 fab
			end
			ToggleScriptBit(switchfablist, 4, true)
		end
	end
	
	if tolerance < 0.25 then
		-- lets switch SOMETHING
		local switchfablist = {}
		if energyNeeded > 0 then
			local sourceT3fablist = T3FabsOnList
			local i = 1
			if table.getn(sourceT3fablist) > 0 then
				while energyNeeded > 0 do
					table.insert(switchfablist, sourceT3fablist[i])
					i = i + 1
					energyNeeded = energyNeeded - 12 -- T1 fab
				end
			end
			
			local sourceT1fablist = T1FabsOnList
			local j = 1
			while energyNeeded > 0 do
				table.insert(switchfablist, sourceT1fablist[i])
				i = i + 1
				energyNeeded = energyNeeded - 3	-- T1 fab
			end
			ToggleScriptBit(switchfablist, 4, false)
		end
	end
end

--[[ ORIGINAL SWITCH FUNCTION
function SwitchMassFabs(fablist, aggromode)

	local econData = GetEconomyTotals()
	local energyIncomeVal = econData["income"]["ENERGY"]
	local energyLastRequestedVal = econData["lastUseRequested"]["ENERGY"]
    local energyMaxStorageVal = econData["maxStorage"]["ENERGY"]	-- storage starts at 2500 (actually 2500. wtf?) and gets over 10k around T3
    local energyStoredVal = econData["stored"]["ENERGY"]

	local bias = (energyMaxStorageVal - energyStoredVal) / 500	-- where the target energy should be, ie 0, +20, +100, whatever - based on amount in storage
	local tolerance = (energyIncomeVal / 10) + 2	-- how wide a gap to allow in energy (radius style, 1 direction?) should be based on input, not storage
print ("tolerance: " .. tolerance)
	local energyNeeded = energyLastRequestedVal - energyIncomeVal + bias-- remember displayed values are this x10. (seconds vs game ticks?)
print ("energyneeded: " .. energyNeeded)	-- starting energy of +10 makes this number -1
--	local T1FabsToKill = math.ceil(energyNeeded / 4)	-- trying random crap.
--	local T1FabsToKill = (energyNeeded / 4)	-- T1 fabs suck down 40 energy if theres no adjacency

	local T1FabsOnList, T1FabsOffList, T3FabsOnList, T3FabsOffList = SplitFabList(fablist)

--	tolerance = 4	-- 1 T1 massfab = 4
	if math.abs(energyNeeded) > tolerance then	-- doesnt modify the original energyNeeded number, btw
--print ("tolerance hit")
		-- lets switch SOMETHING
		local turnOn = false
		local sourcefablist = T1FabsOnList
		local switchfablist = {}
		if energyNeeded > 0 then	-- need energy, shut some down
			-- re-declare stuff for shutdown here? naaahhh
		else
			turnOn = true
			sourcefablist = T1FabsOffList
		end

-- SWITCH ALL THIS CRAP TO DIRECTLY USE ENERGY, SCREW THE NUMFABS
--		local numfabs = math.abs(energyNeeded / 3)	-- pretend T1 fabs use -30 energy
		energyNeeded = math.abs(energyNeeded)	-- pretend T1 fabs use -30 energy
--	print ("switching OFF: " .. numfabs)
		local i = 1
		while energyNeeded > 0 do
				table.insert(switchfablist, sourcefablist[i])
			i = i + 1
			energyNeeded = energyNeeded - 4	-- T1 fab
		end

		ToggleScriptBit(switchfablist, 4, turnOn)
	end

--[[    if energyStoredVal < (energyMaxStorageVal * 0.5) then	-- if we're below half storage, panic
    -- switch them all off
		ToggleScriptBit(fablist, 4, false)	-- ToggleScriptBit takes a list, not a single unit
	elseif energyStoredVal > (energyMaxStorageVal * 0.99) then	-- plenty of energy, go negative -- switching them all back on, for now
		ToggleScriptBit(fabsOffList, 4, true)
	else	-- non panic mode, try to hit a target number
		if T1FabsToKill > 0 then	-- shut some off
			for fab in fabsOnList do
				local fabsonnum = table.getsize(fabsOnList)
				if T1FabsToKill < fabsonnum then	-- strip some out till it matches target
					table.remove(fabsOnList, fab)
		--			T1FabsToKill = T1FabsToKill + 1
				end
				print ("offtarget: " .. T1FabsToKill .. " off: " .. fabsonnum)
			end
			ToggleScriptBit(fabsOnList, 4, false)	-- switch the list off
			
		elseif T1FabsToKill < -1 then	-- turn some on -- -1 to keep it positive
			local T1FabsToActivate = - T1FabsToKill		-- -1 again here, duh!!!!!!!!!!!!
			for fab in fabsOffList do
				local fabsoffnum = table.getsize(fabsOffList)
				if T1FabsToActivate < fabsoffnum then
					table.remove(fabsOffList, fab)
		--			T1FabsToActivate = T1FabsToActivate + 1
				end
			end
			ToggleScriptBit(fabsOffList, 4, true)	-- switch this list ON!
		end
    end
	--]]
	
end]]

function SplitFabList(fablist)
	local fabsOnList = table.copy(fablist)	-- deepcopy?
	local fabsOffList = {}
	for fab in fabsOnList do	-- holy crap this worked the first time. mark it on the calendar.
		local junkyjunk = {}
		junkyjunk[1] = fabsOnList[fab]
		local fabStatusOff = GetScriptBit(junkyjunk, 4)	-- returns false if they're ALL switched on, otherwise true
		if fabStatusOff then
			table.insert(fabsOffList, fabsOnList[fab])
			table.remove(fabsOnList, fab)
		end
	end
	local T1FabsOn = EntityCategoryFilterDown(categories.TECH1, fabsOnList)
	local T3FabsOn = EntityCategoryFilterDown(categories.TECH3, fabsOnList)
	local T1FabsOff = EntityCategoryFilterDown(categories.TECH1, fabsOffList)
	local T3FabsOff = EntityCategoryFilterDown(categories.TECH3, fabsOffList)

	return T1FabsOn, T1FabsOff, T3FabsOn, T3FabsOff
end

