local currentLandFactoryIndex = 1
local currentAirFactoryIndex = 1
local currentNavalFactoryIndex = 1


function GetNextLandFactory()
	UISelectionByCategory("FACTORY * LAND", false, false, false, false)
	local FactoryList = GetSelectedUnits()
    if FactoryList then
        local nextFac = FactoryList[currentLandFactoryIndex] or FactoryList[1]
        currentLandFactoryIndex = currentLandFactoryIndex + 1
        if currentLandFactoryIndex > table.getn(FactoryList) then
            currentLandFactoryIndex = 1
        end
        SelectUnits({nextFac})
    end
end

function GetNextAirFactory()
	UISelectionByCategory("FACTORY * AIR", false, false, false, false)
	local FactoryList = GetSelectedUnits()
    if FactoryList then
        local nextFac = FactoryList[currentAirFactoryIndex] or FactoryList[1]
        currentAirFactoryIndex = currentAirFactoryIndex + 1
        if currentAirFactoryIndex > table.getn(FactoryList) then
            currentAirFactoryIndex = 1
        end
        SelectUnits({nextFac})
    end
end

function GetNextNavalFactory()
	UISelectionByCategory("FACTORY * NAVAL", false, false, false, false)
	local FactoryList = GetSelectedUnits()
    if FactoryList then
        local nextFac = FactoryList[currentNavalFactoryIndex] or FactoryList[1]
        currentNavalFactoryIndex = currentNavalFactoryIndex + 1
        if currentNavalFactoryIndex > table.getn(FactoryList) then
            currentNavalFactoryIndex = 1
        end
        SelectUnits({nextFac})
    end
end


--this function might be too slow in larger games, needs testing
function GetSimilarUnits()
	local enhance = import('/lua/enhancementcommon.lua')
	local curSelection = GetSelectedUnits()
	if curSelection then
		--find out what enhancements the current unit has
		local curUnitId = curSelection[1]:GetEntityId()
        local curUnitEnhancements = enhance.GetEnhancements(curUnitId)

		--select all similar units by category
		local bp = curSelection[1]:GetBlueprint()
		local bpCats = bp.Categories
		local catString = ""
		for i, cat in bpCats do
			if i == 1 then
				catString = cat
			else
				catString = catString.." * " ..cat
			end
		end
		UISelectionByCategory(catString, false, false, false, false)
		
		--get enhancements on each unit and filter down to only those with the same as the first unit
		local newSelection = GetSelectedUnits()
		local tempSelectionTable = {}
		for i, unit in newSelection do
			local unitId = unit:GetEntityId()
	        local unitEnhancements = enhance.GetEnhancements(unitId)
			if curUnitEnhancements and unitEnhancements then
				if table.equal(unitEnhancements, curUnitEnhancements) then
					table.insert(tempSelectionTable, unit)
				end
			elseif curUnitEnhancements == nil and unitEnhancements == nil then
					table.insert(tempSelectionTable, unit)
			end
		end
		SelectUnits(tempSelectionTable)

	end
end
