--*****************************************************************************
--* File: mods/uimod/sca_utils/uimanager.lua
--* Author: Saya and Cleopatre
--* Summary: UI manager for the UI mod 
--* construct the config pannel
--*
--* Copyright  2007 Gas Powered Games, Inc.  All rights reserved. 
--*****************************************************************************



local debug_sca = false -- debugging mode, change the value here and in gamemain.lua
time_effect=.4
local pathui = '/mods/uimod/hook'
local pathuiimg='/mods/uimod/textures'
local sca_utils = '/mods/uimod/sca_utils/'
local uimod= import(sca_utils .. 'uimod.lua')
local gamemain = import('/lua/ui/game/gamemain.lua')
local remap = import(sca_utils .. 'remap.lua')
local skinning= import(sca_utils .. 'skinning.lua')
local info= import(sca_utils .. 'info.lua')

Make_ListBox = import(sca_utils .. 'modcontrols.lua').ListBox
Make_Slider = import(sca_utils .. 'modcontrols.lua').Make_Slider
Make_CheckBox = import(sca_utils .. 'modcontrols.lua').Make_CheckBox
Get_opt = import(sca_utils .. 'modcontrols.lua').Get_opt
reset = import(sca_utils .. 'modcontrols.lua').reset
CreateText_sca = import(sca_utils .. 'modcontrols.lua').CreateText_sca
trad = import(sca_utils .. 'modcontrols.lua').trad
refresh_lang = import(sca_utils .. 'modcontrols.lua').refresh_lang
selectLayout = import(sca_utils .. 'layoutmanager.lua').selectLayout

local UIUtil = import('/lua/ui/uiutil.lua')
local LayoutHelpers = import('/lua/maui/layouthelpers.lua')
local Bitmap = import('/lua/maui/bitmap.lua').Bitmap
local Group = import('/lua/maui/group.lua').Group
local Checkbox = import('/lua/maui/checkbox.lua').Checkbox
local Button = import('/lua/maui/button.lua').Button
local Scrollbar = import('/lua/maui/scrollbar.lua').Scrollbar
local Effect = import('/lua/maui/effecthelpers.lua')
local Tooltip = import('/lua/ui/game/tooltip.lua')
local MyEffects = import(sca_utils.. 'myeffecthelpers.lua')
local Dragger = import('/lua/maui/dragger.lua').Dragger
local Slider = import('/lua/maui/slider.lua').Slider
local construction = import('/lua/ui/game/construction.lua')
local constructionCtr = construction.controls
local queue = import('/lua/ui/game/queue.lua')
local selectionmanager = import('/lua/ui/game/selectionmanager.lua')
local queueCtr = import('/lua/ui/game/queue.lua').controls
local Window = import('/lua/maui/window.lua').Window
local MultiFunction = import('/lua/ui/game/multifunction.lua')
local Prefs = import('/lua/user/prefs.lua')--preferences
local ItemList = import('/lua/maui/itemlist.lua').ItemList
local Scrollbar = import('/lua/maui/scrollbar.lua').Scrollbar
win =false
Output=false
info_panel=false

ResizeTable = {}
ResizerActivation = false

--table of resizer config window functions
local configwindow = {}
local dialog = false
local infoIcon = false
local binput_lock=false  -- is the input lock ? Used during moving windows.
bRefresh_allow = true -- when false, during the init of checkbox and slider no refresh is done
constructing = false -- to set sliders/checkboxes without changing anything


sav_for_reset={
				starting_layout = "sca",
				modVersion = "ver. 3.0", -- display in the bottom left during moving (max 8car), it's only for displaying the value importante is under
				modVersion_int=3.32,   -- use to test compatibility (if new is 0.01 higher than rewrite the profile preference and delete save)
				snapCheckBox = 1,
				AutoSharing=1,
				cam_FarPitch=1,
				cam_MinSpinPitch=0,
				cam_MaxZoomMult= 0.4,
				cam_NearPitch=40/90,
				cam_ZoomSpeedLarge=.25,
				cam_PanSpeed=0.16,
				middle_mouse_bouton=1,
				langue="english",
				hide_panel_on_startup=0,
				unselectable_panel=0,
			
				transparencyCheckBox=1,  -- data saved in game;perfs
				transparenceSlider=0.6,			   
				inverse_barre=1,
				affiche_construc=1,  -- display the windows construction/orders/queue/selection when nothing is selected ? if 1 -->no
				affiche_help=0, -- display the help tips (building/units informations) ?			   
				hide_orders=0,
				hide_mfd=0,
				hide_mass=0,
				hide_energy=0,
				hide_options=0,
				hide_queue=0,
				hide_construction=0,
				hide_unitview=0,
				new_unit_view=1,
				popzoom = 0.35,
				iconsize = 0.44,
				verticalenergy = 0,
				verticalmass = 0,
				verticaloptions = 0,
				verticalMFD = 1,
				straticons = 1,
				altconstruction = 0,
				vertconstruction = 0,
				miniui_econ = 0,
				showborders = 1,
				ordersgrid = 34,
				vertqueue = 0,
				const_sizing = 0,
				
				skinDebugWindow = 0,
				skin = 'Default',
				AEONskin = 'SCA_Aeon',
				CYBRANskin = 'SCA_Cybran',
				UEFskin = 'SCA_UEF',
				
				--list of all known layouts
				layouts = {},
				--list of layouts to show in the basic layout manager
				basicLayouts = {},
				currentscaLayout = {'Default', 'Saya'},
				defaultLayout = true,
				
				loadOK = true,
			} 

uimanager_sav = false
if Prefs.GetFromCurrentProfile("uimanager_sav") then
	uimanager_sav = Prefs.GetFromCurrentProfile("uimanager_sav")
else
	uimanager_sav = table.copy(sav_for_reset)
end
			   
--UI config panel
UIconfigPanel = false
--consolePanel = false
keyPanel = false
local Auto_Hide = false
local popslider = false
local popslider_label=false
unitview = false -- the small panneau at the bottom left display when the Config Pannel is open, used also to move informations Panel( unit_view and unit_view_detail)
score_grp = false  -- use to access the score windows, difficulties with hooking otherwise
local Unlock = false
local Lock=false
local Text_lang = false
local consolePanel = false

-- saved the windows state when the config panel is open
construction_done=false

-- for Splash windows
local UISplash = false
local UImini = false
local UIsca = false
lang="english"

--various variables
local testList2 = false
local mainPopup = false
local mainPopup_bouton = false
local gone = false
local MoveResizeBtn = false
--options panel for resizemode
resize_opt = {
	panel = false,
	button = false,
	}


-- for credit panel
local creditPanel = false
local close_video=false
local mdThread=false
local chrono=false
local chrono_fct=false

--key remapping
resultList = false
GeneralCommandTab = false
BuildCommandTab = false
results = {}

--for icon resizing
GridBorders = {
	constructionHeight = 0,
	constructionWidth = 0,
	queueHeight = 0,
	queueWidth = 0,
	selectionHeight = 0,
	selectionWidth = 0,
}

function trad(id)
	return import(sca_utils .. 'dialog_txt.lua').trad(id)
end



-- create the transparency
function modTransparence(niv,niv2)
	if niv==nil or niv2==nil then
		niv=Get_opt("transparenceSlider")
		niv2=Get_opt("transparenceSlider")+0.2
	end
	if Get_opt("transparencyCheckBox")==0 then
		niv=1
		niv2=1
	end
	if construction_done then
		import('/lua/ui/game/construction.lua').controls.constructionGroup:SetAlpha(niv,false)
		import('/lua/ui/game/construction.lua').controls.unitGrid:SetAlpha(1,false)
		if (Prefs.GetFromCurrentProfile("uimanager_sav")["miniui_econ"] == 0) and (import('/lua/ui/game/economy.lua').controls.massBG!=nil) then -- then no economic bar
			if import('/lua/ui/game/economy.lua').controls.massBG then
				import('/lua/ui/game/economy.lua').controls.massBG:SetAlpha(niv2,false)
				import('/lua/ui/game/economy.lua').controls.energyBG:SetAlpha(niv2,false)
				import('/lua/ui/game/economy.lua').controls.massWarningBG:SetAlpha(0,false)
				import('/lua/ui/game/economy.lua').controls.energyWarningBG:SetAlpha(0,false)
			end
			import('/lua/ui/game/options.lua').GUI.bg:SetAlpha(niv,false)
			import('/lua/ui/game/options.lua').GUI.buttons[6].glow:SetAlpha(0,true) -- remove glow on pause
		end
		if score_grp.Left !=nil then score_grp:SetAlpha(niv,false) end
		import('/lua/ui/game/queue.lua').controls.queueGroup:SetAlpha(niv,false)
		import('/lua/ui/game/construction.lua').mfdControl:SetAlpha(niv,false)
		import('/lua/ui/game/selectionmanager.lua').controls.panelmin:SetAlpha(niv,false)
		import('/lua/ui/game/selectionmanager.lua').controls.panelmax:SetAlpha(niv,false)
		import('/lua/ui/game/selectionmanager.lua').controls.panelstretch:SetAlpha(niv,false)
		import('/lua/ui/game/unitview.lua').controls.roBG:SetAlpha(niv,false)
	
		if not(gamemain.GetReplayState()) then
			import('/lua/ui/game/orders.lua').controls.bg:SetAlpha(niv,false)
		else
			import('/lua/ui/game/replay.lua').controls.bg:SetAlpha(niv,false)
		end
	end
end


function On_layout_sca()
	MoveResizeBtn:Enable()
	if Get_opt("hide_panel_on_startup")==0 then
		mainPopup:Show()
		mainPopup_bouton:Show()
	else
		chrono=GetSystemTimeSeconds()-5
		mainPopup:Hide()
		mainPopup_bouton:Show()
	end
end

-- ========================================== Main function =========================================================

-- build the windows but no use of data (the data isn't initialise yet)
function construct_all(parent)
	
	
	parent=GetFrame(0)

	--Make_Test_Button(parent)--test
	
	Make_resize_opt(parent)

	-- build main object
	mainPopup_bouton=Make_popup_bouton(parent)
	
	if mainPopup == false then
		mainPopup = Make_Popup_Panel(parent)
	end

	--needed for unitview
	Make_Information_Panel(parent)

	-- build option panel
	--Make_console_option_panel(parent)

	--skin debug window
	if uimanager_sav.skinDebugWindow == 1 then
		Make_skin_info()
	end

	-- for testing
	if  gamemain.GetReplayState() or GetFocusArmy() == -1 then info_panel=info.create_info_dialog(parent) end
	chrono=GetSystemTimeSeconds()+2
	construction_done=true
	return  false, UIconfigPanel
end

-----------------------------------------------------------begin contruction fonction--------------------------------------------------------------------------

function Make_Test_Button(parent)
	--Bouton de test
	boutonTest = UIUtil.CreateButton(parent, pathuiimg..'/ok.dds', pathuiimg..'/ok_actif.dds', pathuiimg..'/ok_actif.dds', pathuiimg..'/ok_actif.dds', nil, nil, nil, nil, '')
	LayoutHelpers.AtCenterIn(boutonTest,parent)--centre le bouton sur lecran quel que sit la resolution :)
	boutonTest.Depth:Set( 600 )--always on top

	boutonTest.OnClick = function()   --insrer code de test dans cette fonctions
		--skinning.GetSkin("order",parent,"UEF")
	--[[	val=function() return 108 end
		tab={essai=val()+12}
		LOG("essai 1: ",tab.essai)
		val=function() return 2 end
		LOG("essai 2: ",tab.essai)
		
		val=function() return 108 end
		tab2=function() return {essai=val()+12} end
		LOG("essai 3: ",tab2().essai)
		val=function() return 2 end
		LOG("essai 4: ",tab2().essai)		]]
		
	end
	return boutonTest
end

function Make_skin_info()
	local mainFrame = GetFrame(0)
	local location = {Top = 100, Left = 100, Bottom = 500, Right = 400}
	win = Window(mainFrame, 'Skinning process output:', nil, nil, true, false, false, 'console_window', location)
	win.Depth:Set(5000)
	win:SetMinimumResize(200, 170)
	win.OnClose = function(self) win:Destroy() win = false end
	Tooltip.AddButtonTooltip(win._closeBtn, 'chat_close')
	Output = ItemList(win)
	Output.Top:Set(function() return win:GetClientGroup().Top() + 5 end)
	Output.Bottom:Set(function() return win:GetClientGroup().Bottom() - 5 end)
	Output.Left:Set(function() return win:GetClientGroup().Left() + 10 end)
	Output.Right:Set(function() return win:GetClientGroup().Right() - 38 end)
	Output.Depth:Set(win.Depth() + 2)
	Output:SetColors(UIUtil.consoleFGColor(), UIUtil.consoleTextBGColor()) --, UIUtil.consoleFGColor(), UIUtil.consoleTextBGColor()) -- we don't really want selection here so don't differentiate colors
	Output:SetFont(UIUtil.fixedFont, 13)
	UIUtil.CreateVertScrollbarFor(Output)
end

function Output_text(text)
	if win then
		Output:AddItem(text)
	end
end

function GetUnitIconFileNames2(name)
    local iconName = '/textures/ui/common/icons/units/' .. name.. '_icon.dds'
    local upIconName = '/textures/ui/common/icons/units/' .. name .. '_build_btn_up.dds'
    local downIconName = '/textures/ui/common/icons/units/' .. name .. '_build_btn_down.dds'
    local overIconName = '/textures/ui/common/icons/units/' .. name .. '_build_btn_over.dds'
    
    if DiskGetFileInfo(iconName) == false then
        iconName = '/textures/ui/common/icons/units/default_icon.dds'
    end
    
    if DiskGetFileInfo(upIconName) == false then
        upIconName = iconName
    end

    if DiskGetFileInfo(downIconName) == false then
        downIconName = iconName
    end

    if DiskGetFileInfo(overIconName) == false then
        overIconName = iconName
    end
    
    return iconName, upIconName, downIconName, overIconName
end


function saveloadUserLayout()
	local quicksaveIndex = false
	for i, v in uimanager_sav.layouts do
		if v[3] == 'Quicksave' then
			quicksaveIndex = i
		end
	end
	UIUtil.QuickDialog(GetFrame(0), trad("saveloadlayout"), "Quick Save",
		function()
			print(trad("savelayoutUser"))
			uimanager_sav = Prefs.GetFromCurrentProfile("uimanager_sav")
			if quicksaveIndex then
				uimanager_sav.layouts[quicksaveIndex] = {uimanager_sav["skin"], 'Quicksave', 'Quicksave', uimanager_sav["AEONskin"], uimanager_sav["CYBRANskin"], uimanager_sav["UEFskin"]}
				for i, v in uimanager_sav.basicLayouts do
					local index = i
					if v[3] == 'Quicksave' then
						uimanager_sav.basicLayouts[index] = {uimanager_sav["skin"], 'Quicksave', 'Quicksave', uimanager_sav["AEONskin"], uimanager_sav["CYBRANskin"], uimanager_sav["UEFskin"]}
					end
				end
			else
				table.insert(uimanager_sav.layouts, {uimanager_sav["skin"], 'Quicksave', 'Quicksave', uimanager_sav["AEONskin"], uimanager_sav["CYBRANskin"], uimanager_sav["UEFskin"]})
				table.insert(uimanager_sav.basicLayouts, {uimanager_sav["skin"], 'Quicksave', 'Quicksave', uimanager_sav["AEONskin"], uimanager_sav["CYBRANskin"], uimanager_sav["UEFskin"]})
			end
			uimanager_sav.currentscaLayout = {uimanager_sav["skin"], 'Quicksave'}
			uimanager_sav.defaultLayout = false
			Prefs.SetToCurrentProfile("uimanager_sav", uimanager_sav)
			uimod.saveModValues("Quicksave")
		end, 
		"Quick load",
		function()
			if quicksaveIndex then
				import(sca_utils .. 'layoutmanager.lua').selectLayout(uimanager_sav.layouts[quicksaveIndex][1], "Quicksave")
				print(trad("loadlayoutUser"))
			else
				print(trad("noquicksave"))
			end
		end, 
			"<LOC _Cancel>", function()  end, true, {escapeButton = 3, worldCover = false})
end


function Launch_credit_Panel()
	local creditPanel = Bitmap(GetFrame(0))
	creditPanel:SetTexture(UIUtil.SkinnableFile(pathuiimg..'/fond_credit.dds'))
	LayoutHelpers.AtCenterIn(creditPanel,GetFrame(0))
	creditPanel.Depth:Set(1100)
	local ctr_sav=creditPanel.HandleEvent
	creditPanel.HandleEvent = function(self, event)
        -- cancel movie playback on mouse click or key hit
		if event.Type == "ButtonPress" or event.Type == "KeyDown" then
			close_video()
			creditPanel:Destroy()
			mdThread()
			return true
		end
	end

	close_video=play_video(creditPanel)
	mdThread=play_credit2(creditPanel)
end

function Make_popup_bouton(parent)
	local popup_bouton = UIUtil.CreateButton(parent,pathuiimg..'/popup_bouton.dds', pathuiimg..'/popup_bouton_actif.dds', pathuiimg..'/popup_bouton_actif.dds',pathuiimg..'/popup_bouton_actif.dds')
	popup_bouton.Top:Set(function() return (GetFrame(0).Bottom()- popup_bouton.BitmapHeight())/2 end )
	popup_bouton.Depth:Set(10)
	popup_bouton.Left:Set(0)
	popup_bouton.OnClick=function()
		if Get_opt("unselectable_panel")==0 then toggleMainPopup() end
	end
	return popup_bouton
end

--makes the main popup window
function Make_Popup_Panel(parent)
	parent=GetFrame(0)
	--control group
	local popupPanel = Group(parent)
	LayoutHelpers.AtLeftTopIn(popupPanel,parent)
	popupPanel.Depth:Set(10000) --always on top
	popupPanel.Width:Set(50)
	popupPanel.Height:Set(50)
	popupPanel:DisableHitTest()
	
	--main bitmap
	local popupBitmap = Bitmap(popupPanel)
	popupBitmap:SetTexture(UIUtil.SkinnableFile(pathuiimg..'/popup_panel.dds'))
	popupBitmap.Left:Set(0)
	popupBitmap.Top:Set(function() return (GetFrame(0).Bottom()- popupBitmap.BitmapHeight())/2 end )
	popupBitmap.Depth:Set(popupPanel.Depth()+1) 
	--popupBitmap.OnClick=function() toggleMainPopup() end
	
	local savHandle= popupBitmap.HandleEvent
	popupBitmap.HandleEvent = function(self, event)
		if (event.Type == "ButtonPress" or event.Type == "KeyDown") and (event.MouseX>(popupBitmap.Right() -42)) then
			toggleMainPopup()
		end
		chrono=GetSystemTimeSeconds() 
		savHandle()
	end
	chrono=GetSystemTimeSeconds()+30 
	local titre_popup1 = CreateText_sca(popupBitmap,("title_popup1"), 23, UIUtil.titleFont)
	LayoutHelpers.AtRightTopIn(titre_popup1, popupBitmap, 60, 44)
	titre_popup1:SetColor(UIUtil.dialogCaptionColor)	

	local titre_popup2 = CreateText_sca(popupBitmap,("title_popup2"), 20, UIUtil.titleFont)
	LayoutHelpers.AtLeftTopIn(titre_popup2, popupBitmap, 10, 70)
	titre_popup2:SetColor(UIUtil.dialogCaptionColor)	
	
	local bt_sca = UIUtil.CreateButton(popupBitmap,pathuiimg..'/bt_sca.dds', pathuiimg..'/bt_sca_actif.dds', pathuiimg..'/bt_sca_actif.dds',pathuiimg..'/bt_sca_actif.dds', nil, nil, nil, nil,'')
	LayoutHelpers.AtLeftTopIn(bt_sca,popupBitmap,2,660)
	bt_sca.Depth:Set(popupBitmap.Depth()+1)
	bt_sca.OnClick=function()
		Launch_credit_Panel()
	end
	local titre_credit = CreateText_sca(bt_sca,("title_credit"), 16, UIUtil.titleFont)
	LayoutHelpers.AtLeftTopIn(titre_credit, bt_sca, 5, -20)
	titre_credit:SetColor("White") --UIUtil.dialogCaptionColor)	

	--panel opening buttons
	MoveResizeBtn = Make_Move_Resize_Btn(popupBitmap, 20, 110)
	local openConfig = Make_Button_Open_Config(popupBitmap, 20, 180)
	local openCamera = Make_Button_Open_Camera_Options(popupBitmap, 20, 250)
	local openKey = Make_Button_Open_Key_map(popupBitmap, 20, 320)
	local openSave = Make_Button_Save_Load_Current_Layout(popupBitmap,20, 390)
	local openFit=Make_Button_LayoutManager(popupBitmap, 20, 460)
	local openStat=Make_Button_Stat(popupBitmap, 20, 530)
	--function to show the popup panel
	popupPanel.enter = function()
		--openFit.Toggle(true)
		chrono=GetSystemTimeSeconds() 
		MyEffects.FadeInAndMoveX(popupBitmap,0.4,0,0.1,0.9)		
	end
	

	--function to hide the popup panel
	popupPanel.exit = function()
		MyEffects.FadeHideAndMoveX(popupBitmap,0.4, -popupBitmap.Width())		
	end
	
	local view=import('/lua/ui/game/borders.lua').controls.mapGroup --import('/lua/ui/game/worldview.lua').view
	local savview= view.HandleEvent
	view.HandleEvent = function(self, event)
		if (event.Type == "ButtonPress" or event.Type == "KeyDown") and not gone then
			toggleMainPopup()
		end
		--print(event.Type)

		savview()
	end
	
	beat_fct=function()
		if (GetSystemTimeSeconds()-chrono)>6 then 
			--print("Chrono") 
			if not gone then
				toggleMainPopup()
			end
		end
	end
    
    import('/lua/ui/game/gamemain.lua').AddBeatFunction(beat_fct)

	return popupPanel
end


--toggles the main popup
function toggleMainPopup()
	if gone == true then
		mainPopup.enter()
		gone = false
	else
		mainPopup.exit()
		gone = true
	end
end


function Make_resize_opt(parent)
	posTable = {Left = 300, Top = 300, Right = 550, Bottom = 500}
	resize_opt.panel = Window(parent, nil, nil, nil, nil, true, false, "resizeopt", posTable)
	resize_opt.panel.Depth:Set(2000)
	resize_opt.panel:DisableHitTest()
	
	resize_opt.button = Make_Bouton_Leave_move_mode(resize_opt.panel)
	resize_opt.button.Left:Set(function() return resize_opt.panel.Left() + 75 end)
	resize_opt.button.Top:Set(function() return resize_opt.panel.Top() + 35 end)
	resize_opt.button.Right:Set(function() return resize_opt.panel.Left() + 160 end)
	resize_opt.button.Bottom:Set(function() return resize_opt.panel.Top() + 95 end)
	
	local hidetxt1 = CreateText_sca(resize_opt.panel, "hide", 18, UIUtil.titleFont)
	local hidetxt2 = CreateText_sca(resize_opt.panel, "hide2", 18, UIUtil.titleFont)
	LayoutHelpers.AtRightTopIn(hidetxt1, resize_opt.panel, 20, 60)
	LayoutHelpers.AtRightTopIn(hidetxt2, resize_opt.panel, 20, 78)
	
	Make_CheckBox(resize_opt.panel,5,100,"hide_options",function() flemmeMinimize("options") end,function() flemmeMaximize("options") end,false,true,("options_title"),nil,nil,false,false,false,("hide_help"))
	Make_CheckBox(resize_opt.panel,5,122,"hide_mfd",function() flemmeMinimize("mfd") end,function() flemmeMaximize("mfd") end,false,true,("mfd_title"),nil,nil,false,false,false,("hide_help"))
	Make_CheckBox(resize_opt.panel,5,144,"hide_mass",function() flemmeMinimize("mass") end,function() flemmeMaximize("mass") end,false,true,("mass_title"),nil,nil,false,false,false,("hide_help"))
	Make_CheckBox(resize_opt.panel,5,166,"hide_energy",function() flemmeMinimize("energy") end,function() flemmeMaximize("energy") end,false,true,("energy_title"),nil,nil,false,false,false,("hide_help"))
	Make_CheckBox(resize_opt.panel,105,100,"hide_orders",function() flemmeMinimize("orders") end,function() flemmeMaximize("orders") end,false,true,("orders_title"),nil,nil,false,false,false,("hide_help"))
	Make_CheckBox(resize_opt.panel,105,122,"hide_queue",function() flemmeMinimize("queue") end,function() flemmeMaximize("queue") end,false,true,("queue_title"),nil,nil,false,false,false,("hide_help"))
	Make_CheckBox(resize_opt.panel,105,144,"hide_construction",function() flemmeMinimize("construction") end,function() flemmeMaximize("construction") end,false,true,("construction_title"),nil,nil,false,false,false,("hide_help"))
	Make_CheckBox(resize_opt.panel,105,166,"hide_unitview",function() flemmeMinimize("unitview") end,function() flemmeMaximize("unitview") end,false,true,("unitview_title"),nil,nil,false,false,false,("hide_help"))

	resize_opt.panel:Hide()
end
	
function Make_Bouton_Leave_move_mode(parent)
	local Bouton_Leave_move_mode = UIUtil.CreateButton(parent,pathuiimg..'/bouton_move.dds', pathuiimg..'/bouton_move_actif.dds', pathuiimg..'/bouton_move_actif.dds',pathuiimg..'/bouton_move_actif.dds', nil, nil, nil, nil,'')
		
	Bouton_Leave_move_mode.Depth:Set(2900 )
	Bouton_Leave_move_mode.OnClick = function(self, checked)
		Off_Move_Resize()
		MoveResizeBtn:SetCheck(false,false)
		
		if not gone then toggleMainPopup() end
	end
	local txt1= CreateText_sca(Bouton_Leave_move_mode,("Move_Resize_resume1"), 14, UIUtil.titleFont)
	LayoutHelpers.AtRightTopIn(txt1, Bouton_Leave_move_mode, 5, 20)
       txt1:SetColor("white")
	local txt2= CreateText_sca(Bouton_Leave_move_mode,("Move_Resize_resume2"), 14, UIUtil.titleFont)
	LayoutHelpers.AtRightTopIn(txt2, Bouton_Leave_move_mode, 5, 35)
       txt2:SetColor("white")
	return Bouton_Leave_move_mode
end

--makes a button to unlock the ui
function Make_Move_Resize_Btn(parent, left, top)
	local Move_Resize_Btn = UIUtil.CreateCheckbox(parent,pathuiimg..'/bouton_move.dds', pathuiimg..'/bouton_move_actif.dds', pathuiimg..'/bouton_move_actif.dds', pathuiimg..'/bouton_move_actif.dds',pathuiimg..'/bouton_move_dis.dds', pathuiimg..'/bouton_move_dis.dds', '')
		
	Move_Resize_Btn.Depth:Set( parent.Depth()+2 )
	LayoutHelpers.AtLeftTopIn(Move_Resize_Btn, parent, left, top)
	Move_Resize_Btn.Width:Set(Move_Resize_Btn.Width()/1.5)
	Move_Resize_Btn.Height:Set(Move_Resize_Btn.Height()/1.5)
	local txt1= CreateText_sca(Move_Resize_Btn,("Move_Resize_Btn1"), 14, UIUtil.titleFont)
	LayoutHelpers.AtRightTopIn(txt1, Move_Resize_Btn, 10, 20)
       txt1:SetColor("white")
	local txt2= CreateText_sca(Move_Resize_Btn,("Move_Resize_Btn2"), 14, UIUtil.titleFont)
	LayoutHelpers.AtRightTopIn(txt2, Move_Resize_Btn, 10, 35)
       txt2:SetColor("white")
	  
	Move_Resize_Btn.OnClick = function(self)
		UISelectionByCategory("", false, false, false, false) -- unselect all

		if self:IsChecked() then
			Off_Move_Resize()
			self:SetCheck(false)
		else
			if Prefs.GetFromCurrentProfile("uimanager_sav")["defaultLayout"] then
				UIUtil.QuickDialog(GetFrame(0), "Warning: Entering move/resize mode will disable any dependencies between panels.",
					"<LOC _OK>",
					function()
						uimanager_sav.defaultLayout = false
						uimanager_sav.currentscaLayout = {uimanager_sav.skin, "tempUserLayout"}
						Prefs.SetToCurrentProfile("uimanager_sav", uimanager_sav)
						On_Move_Resize()
						uimod.ClearCode()
						self:SetCheck(true)
					end,
					"<LOC _Cancel>", function() end, nil, nil, true, {escapeButton = 2, enterButton = 1})
			else
				On_Move_Resize()
				self:SetCheck(true)

			end
		end
	end
	
	return Move_Resize_Btn
end

--toggle ui lock/unlock
function MoveResizeToggle()
	UISelectionByCategory("", false, false, false, false) -- unselect all
	if MoveResizeBtn:IsChecked() then
		MoveResizeBtn:SetCheck(false,false)
	else
		MoveResizeBtn:SetCheck(true,false)
	end	
	if not gone then toggleMainPopup() end
end
	   
--makes an open config button
function Make_Button_Open_Config(parent,left,top)

	--When you click on the open config button the config panel  pops out	 THE MAIN BUTTON
	local Open_Config = UIUtil.CreateButton(parent,pathuiimg..'/bouton_option.dds', pathuiimg..'/bouton_option_actif.dds', pathuiimg..'/bouton_option_actif.dds',pathuiimg..'/bouton_option_actif.dds', nil, nil, nil, nil,'')
		
	Open_Config.Depth:Set( parent.Depth()+2 )
	LayoutHelpers.AtLeftTopIn(Open_Config, parent, left, top)
	Open_Config.Width:Set(Open_Config.Width()/1.5)
	Open_Config.Height:Set(Open_Config.Height()/1.5)
	local txt1= CreateText_sca(Open_Config,("Open_Config1"), 14, UIUtil.titleFont)
	LayoutHelpers.AtRightTopIn(txt1, Open_Config, 10, 20)
       txt1:SetColor("white")
	local txt2= CreateText_sca(Open_Config,("Open_Config2"), 14, UIUtil.titleFont)
	LayoutHelpers.AtRightTopIn(txt2, Open_Config, 10, 35)
       txt2:SetColor("white")
	   
	   
	Open_Config.OnClick = function(self)
		toggle_config_panel()
		toggleMainPopup()
	end
	
	--return control
	return Open_Config
end

function toggle_config_panel()
	if UIconfigPanel then
		UIconfigPanel:Destroy()
		UIconfigPanel = false
	else
		constructing = true
		Make_Config_Panel()
		constructing = false
	end
end
--makes an open camera options button
function Make_Button_Open_Camera_Options(parent,left,top)
	-- close the Config Panel
	local Open_Camera_Options = UIUtil.CreateButton(parent, pathuiimg..'/bouton_camera.dds', pathuiimg..'/bouton_camera_actif.dds', pathuiimg..'/bouton_camera_actif.dds', pathuiimg..'/bouton_camera_actif.dds' , nil, nil, nil, nil, '')
	Open_Camera_Options.Depth:Set( parent.Depth()+2 )
	LayoutHelpers.AtLeftTopIn(Open_Camera_Options, parent, left, top)
	
	local txt1= CreateText_sca(Open_Camera_Options,("Open_Camera_Options1"), 14, UIUtil.titleFont)
	LayoutHelpers.AtRightTopIn(txt1, Open_Camera_Options, 10, 20)
       txt1:SetColor("white")
	local txt2= CreateText_sca(Open_Camera_Options,("Open_Camera_Options2"), 14, UIUtil.titleFont)
	LayoutHelpers.AtRightTopIn(txt2, Open_Camera_Options, 10, 35)
       txt2:SetColor("white")	
	Open_Camera_Options.Width:Set(Open_Camera_Options.Width()/1.5)
	Open_Camera_Options.Height:Set(Open_Camera_Options.Height()/1.5)
	Open_Camera_Options.OnClick = function()
		Make_console_option_panel(parent)
		toggleMainPopup()
	end
end

--makes an open statistic button
function Make_Button_Stat(parent,left,top)
	-- close the Config Panel
	local Open_Stat = false
	
	--disable if replay
	Open_Stat = UIUtil.CreateButton(parent, pathuiimg..'/bouton_stat_up.dds', pathuiimg..'/bouton_stat_down.dds', pathuiimg..'/bouton_stat_over.dds', pathuiimg..'/bouton_stat_dis.dds' , nil, nil, nil, nil, '')
	Open_Stat.OnClick = function()
		info_panel=info.create_info_dialog(parent)
		toggleMainPopup()
	end
	
	Open_Stat.Depth:Set( parent.Depth()+2 )
	LayoutHelpers.AtLeftTopIn(Open_Stat, parent, left, top)
	
	local txt1= CreateText_sca(Open_Stat,("Stat1"), 14, UIUtil.titleFont)
	LayoutHelpers.AtRightTopIn(txt1, Open_Stat, 10, 20)
       txt1:SetColor("white")
	local txt2= CreateText_sca(Open_Stat,("Stat2"), 14, UIUtil.titleFont)
	LayoutHelpers.AtRightTopIn(txt2, Open_Stat, 10, 35)
       txt2:SetColor("white")		
	Open_Stat.Width:Set(Open_Stat.Width()/1.5)
	Open_Stat.Height:Set(Open_Stat.Height()/1.5)
	
	return Open_Stat
end

function Make_Button_Save_Load_Current_Layout(parent,left,top)
	-- close the Config Panel
	local Save_Current_Layout = UIUtil.CreateButton(parent, pathuiimg..'/bouton_save.dds', pathuiimg..'/bouton_save_actif.dds', pathuiimg..'/bouton_save_actif.dds' , pathuiimg..'/bouton_save_actif.dds' , nil, nil, nil, nil, '')
	Save_Current_Layout.Depth:Set( parent.Depth()+2 )
	LayoutHelpers.AtLeftTopIn(Save_Current_Layout, parent, left, top)
	
	local txt1= CreateText_sca(Save_Current_Layout,("Open_Save"), 14, UIUtil.titleFont)
	LayoutHelpers.AtRightTopIn(txt1, Save_Current_Layout, 10, 20)
       txt1:SetColor("white")
	local txt2= CreateText_sca(Save_Current_Layout,("Open_Save2"), 14, UIUtil.titleFont)
	LayoutHelpers.AtRightTopIn(txt2, Save_Current_Layout, 10, 35)
       txt2:SetColor("white")		
	Save_Current_Layout.Width:Set(Save_Current_Layout.Width()/1.5)
	Save_Current_Layout.Height:Set(Save_Current_Layout.Height()/1.5)
	Save_Current_Layout.OnClick = function()
		saveloadUserLayout()
		toggleMainPopup()
	end
	
	return Save_Current_Layout
end

--makes an open keymap button
function Make_Button_Open_Key_map(parent,left,top)
	-- close the Config Panel
	local Open_Key_map = false
	
	--disable if replay
	if not gamemain.GetReplayState() then
		Open_Key_map = UIUtil.CreateButton(parent, pathuiimg..'/bouton_key_map.dds', pathuiimg..'/bouton_key_map_actif.dds', pathuiimg..'/bouton_key_map_actif.dds', pathuiimg..'/bouton_key_map_actif.dds' , nil, nil, nil, nil, '')
		Open_Key_map.OnClick = function()
			if not keyPanel then
				Make_Key_Map_Panel(GetFrame(0))
			else
				keyPanel:Destroy()
				keyPanel = false
			end
			toggleMainPopup()
		end
	else
		Open_Key_map = Bitmap(parent)
		Open_Key_map:SetTexture(UIUtil.SkinnableFile(pathuiimg..'/bouton_key_map.dds'))
	end
	
	
	Open_Key_map.Depth:Set( parent.Depth()+2 )
	LayoutHelpers.AtLeftTopIn(Open_Key_map, parent, left, top)
	
	local txt1= CreateText_sca(Open_Key_map,("Open_Key_map1"), 14, UIUtil.titleFont)
	LayoutHelpers.AtRightTopIn(txt1, Open_Key_map, 10, 20)
       txt1:SetColor("white")
	local txt2= CreateText_sca(Open_Key_map,("Open_Key_map2"), 14, UIUtil.titleFont)
	LayoutHelpers.AtRightTopIn(txt2, Open_Key_map, 10, 35)
       txt2:SetColor("white")		
	Open_Key_map.Width:Set(Open_Key_map.Width()/1.5)
	Open_Key_map.Height:Set(Open_Key_map.Height()/1.5)
	
	return Open_Key_map
end

function Make_Config_Panel()
	local parent = gamemain.GetGameParent()
	--main UI configuration panel layout
	if UIconfigPanel then UIconfigPanel:Destroy() end
	UIconfigPanel = Bitmap(parent)
	UIconfigPanel:SetTexture(UIUtil.SkinnableFile(pathuiimg..'/fond_config.dds'))
	LayoutHelpers.AtCenterIn(UIconfigPanel,parent)
	UIconfigPanel.Depth:Set(3000)
	UIconfigPanel:Hide()
	-- informations for minimizing
	UIconfigPanel.mPosition = 8  	UIconfigPanel.mOffset = -15  	UIconfigPanel.mPath = 'reduitgd'  UIconfigPanel.mRefresh = 0 UIconfigPanel.mminimizable_when_panel_open=true

	-- make title
	local titre=CreateText_sca(UIconfigPanel, ("uimodconfig"), 16, UIUtil.titleFont)
	LayoutHelpers.AtLeftTopIn(titre, UIconfigPanel, 29,24)
	titre:SetColor(UIUtil.dialogColumnColor)
	
	local version = UIUtil.CreateText(UIconfigPanel,sav_for_reset["modVersion"], 12, UIUtil.titleFont)
	LayoutHelpers.AtRightTopIn(version, UIconfigPanel,50,340)
       version:SetColor("gray")
	
	if uimanager_sav.skin == 'Auto Faction' then
		factionpic = Bitmap(UIconfigPanel, UIUtil.SkinnableFile(pathuiimg..'/radial_backgrounds/radialbg_' .. uimod.factionTable[uimod.factionIndex] .. '.dds'))
	else
		factionpic = Bitmap(UIconfigPanel, UIUtil.SkinnableFile(pathuiimg..'/radial_backgrounds/radialbg_default.dds'))
	end
	LayoutHelpers.AtLeftTopIn(factionpic, UIconfigPanel, 305, 60)
	factionpic:SetAlpha(0.65)

	--function Make_CheckBox(parent,x,y,name_in_game_pref,fct_ON,fct_OFF,brefresh,bmake_init,label_txt,xrelatif,yrelatif,size_txt,style,color,help_tips)

	-- Construction all the others object
	Make_CheckBox(UIconfigPanel,37,70,"affiche_construc",nil,nil,true,true,("autohide"),false,false,false,false,false,("autohide2"))
	Make_CheckBox(UIconfigPanel,37,110,"affiche_help",nil,nil,false,true,("autohelp"),false,false,false,false,false,("autohelp2"))
	Make_CheckBox(UIconfigPanel,37,150,"straticons",nil,nil,true,true,("straticons"),false,false,false,false,false,("straticons2"))
	Make_CheckBox(UIconfigPanel,37,190,"miniui_econ",
		function()
			LOG(UIUtil.currentLayout)
			if import(sca_utils .. 'modcontrols.lua').ConfigCheckTable["hide_mfd"] then
				import(sca_utils .. 'modcontrols.lua').ConfigCheckTable["hide_mfd"]:Disable()
				import(sca_utils .. 'modcontrols.lua').ConfigCheckTable["hide_mass"]:Disable()
				import(sca_utils .. 'modcontrols.lua').ConfigCheckTable["hide_energy"]:Disable()
				import(sca_utils .. 'modcontrols.lua').ConfigCheckTable["hide_options"]:Disable()
			end
			if ResizerActivation == true then
				ResizeTable["energyBG"]:Hide()
				ResizeTable["massBG"]:Hide()
				ResizeTable["MFD"]:Hide()
				ResizeTable["options"]:Hide()
			end
		end,
		function()
			if import(sca_utils .. 'modcontrols.lua').ConfigCheckTable["hide_mfd"] then
				import(sca_utils .. 'modcontrols.lua').ConfigCheckTable["hide_mfd"]:Enable()
				import(sca_utils .. 'modcontrols.lua').ConfigCheckTable["hide_mass"]:Enable()
				import(sca_utils .. 'modcontrols.lua').ConfigCheckTable["hide_energy"]:Enable()
				import(sca_utils .. 'modcontrols.lua').ConfigCheckTable["hide_options"]:Enable()
			end
			if ResizerActivation == true then
				if bRefresh_allow then uimod.RefreshLayout() end
				ResizeTable["energyBG"]:Show()
				ResizeTable["massBG"]:Show()
				ResizeTable["MFD"]:Show()
				ResizeTable["options"]:Show()
			end
		end,
		true,true,("miniuiecon"),false,false,false,false,false,("miniuieconhelp"))
	Make_CheckBox(UIconfigPanel,37,230,"snapCheckBox",nil,nil,false,true,("autosnap"),false,false,false,false,false,("autosnap2"))
	Make_CheckBox(UIconfigPanel,37,275,"transparencyCheckBox",function() modTransparence() UIconfigPanel:SetAlpha(0.95) end,function() modTransparence(1,1) UIconfigPanel:SetAlpha(1) end,false,true,("transparency"),40,-6,false,false,false,("transparency2"))
	Make_CheckBox(UIconfigPanel,37,320,"const_sizing", nil, nil,false,true,("const_sizing"),false,false,false,false,false,("const_sizing2"))
	Make_CheckBox(UIconfigPanel,37,360,"unselectable_panel",nil,nil,false,true,("unselectable_panel"),false,false,false,false,false,("unselectable_panel2"))
	Make_CheckBox(UIconfigPanel,440,410,"hide_panel_on_startup",nil,nil,false,true,("hide_panel_on_startup"),-150,4,15,false,false,("hide_panel_on_startup2"))
	Make_Slider(UIconfigPanel,70,290,"transparenceSlider",0.3,0.8,function(val) if Get_opt("transparencyCheckBox")==1 then modTransparence() end end,true,false,false,false,false,false,false,("transparency2"))		
	if debug_sca then Make_Test_Button(parent) end --use only for making test
	okBtn = Make_Button_generic(UIconfigPanel)
	okBtn.OnQuit = function()
		uimod.RefreshLayout()
		UIconfigPanel:Destroy()
		UIconfigPanel = false
	end
	Make_Reset_Button(parent)
	Make_Language_Select(UIconfigPanel,180,412)
	Make_Slider(UIconfigPanel,310,260,"iconsize",0,1,function(val) resizeIcons( math.ceil(val*64 + 32) ) end,true,("iconsize"),2,-18,false,false,false,("iconsize2"))
	infoIcon = Make_Size_Icon(UIconfigPanel,315,300,math.ceil(Get_opt("iconsize")*64 + 32))
	Effect.FadeIn(UIconfigPanel,time_effect)
	UIconfigPanel:Show()
end

function Make_console_option_panel(parent_old)
	-- panel to set and save camera option
	local parent=GetFrame(0)
	if consolePanel then
		consolePanel:Destroy()
		consolePanel = false
	else
		consolePanel = Bitmap(parent)
		consolePanel:SetTexture(UIUtil.SkinnableFile(pathuiimg..'/fenetre_console.dds'))
		LayoutHelpers.AtCenterIn(consolePanel,parent)
		consolePanel.Depth:Set(1100)
		consolePanel:Hide()
		-- informations for minimizing
		consolePanel.mPosition = 10  	consolePanel.mOffset = -15  	consolePanel.mPath = 'reduitgd'  consolePanel.mRefresh = 0 consolePanel.mminimizable_when_panel_open=true

		-- make title
		local titre=CreateText_sca(consolePanel, ("camera"), 16, UIUtil.titleFont)
		LayoutHelpers.AtLeftTopIn(titre, consolePanel, 29,24)
		titre:SetColor(UIUtil.dialogColumnColor)
		OKBtn = Make_Button_genericv2(consolePanel)
		OKBtn.OnQuit = function()
			consolePanel:Destroy()
			consolePanel = false
		end
		Make_Slider(consolePanel,44,85,"cam_FarPitch",0,1,function(val) ConExecute("cam_FarPitch ".. (math.ceil(val*90))) end,true,("farpitch"),2,-18,false,false,false,("farpitch2"))
		Make_Slider(consolePanel,44,145,"cam_MinSpinPitch",0,1,function(val) ConExecute("cam_MinSpinPitch ".. (val*-1.1+0.1)) end,true,("minpitch"),2,-18,false,false,false,("minpitch2"))
		Make_Slider(consolePanel,44,205,"cam_NearPitch",0,1,function(val) ConExecute("cam_NearPitch ".. (math.ceil(val*90))) end,true,("nearpitch"),2,-18,false,false,false,("nearpitch2"))
		Make_Slider(consolePanel,44,265,"cam_ZoomSpeedLarge",0,1,function(val) ConExecute("cam_ZoomSpeedLarge ".. (math.ceil(val*20))) end,true,("zoomspeed"),2,-18,false,false,false,("zoomspeed2"))
		Make_Slider(consolePanel,285,85,"cam_MaxZoomMult",0,1,function(val) ConExecute("cam_MaxZoomMult ".. ((val+0.9))) end,true,("maxzoom"),2,-18,false,false,false,("maxzoom2"))
		Make_Slider(consolePanel,285,145,"cam_PanSpeed",0,1,function(val) ConExecute("cam_PanSpeed ".. ((val*5 + 0.2))) end,true,("panspeed"),2,-18,false,false,false,("panspeed2"))
		popslider,popslider_label = Make_Slider(consolePanel,285,265,"popzoom",0,1,function() end,true,("zoompopS"),2,-18,false,false,false,("zoompopS2"))
		Make_CheckBox(consolePanel,253,205,"middle_mouse_bouton",function() uimod.Refresh_third_button() popslider_label:SetColor(UIUtil.dialogCaptionColor) lockSlider(popslider,false) end,function() uimod.Refresh_third_button() popslider_label:SetColor("gray") lockSlider(popslider,true) end,false,true,("zoompopC"),false,false,false,false,false,("zoompopC2"))
		Effect.FadeIn(consolePanel,time_effect)
		--function Make_CheckBox(parent,x,y,name_in_game_pref,fct_ON,fct_OFF,brefresh,bmake_init,label_txt,xrelatif,yrelatif,size_txt,style,color,help_tips)
	end
end
--function Make_Slider(parent,x,y,name_in_game_pref,debut,fin,fct_call,bmake_init,label_txt,xrelatif,yrelatif,size_txt,style,color,help_tips)
			--   cam_FarPitch=1,
			--   cam_MinSpinPitch=0.1,
			--   cam_NearPitch=90/40,
			--   cam_ZoomSpeedLarge=.25} 

function Make_Information_Panel(parent)
	-- create an example of the unit windows at the bottom of the screen when the uipanel is displayed
	-- display also the version number
	if not unitview then unitview = Bitmap(parent) end
	unitview:SetTexture(UIUtil.UIFile(pathuiimg..'/image_bottom.dds'))
	unitview.Left:Set(parent.Left()+2)
	unitview.Width:Set(unitview.BitmapWidth)
	unitview.Height:Set(unitview.BitmapHeight)
	unitview.Top:Set(parent.Bottom() - unitview.BitmapHeight())
	unitview.Bottom:Set(function() return unitview.BitmapHeight() + unitview.Top() end)
	unitview.Right:Set(function() return unitview.BitmapWidth() + unitview.Left() end)
	unitview.Depth:Set(800)
	unitview:Hide()
	
	 local unitviewtxt = CreateText_sca(unitview,("title"), 12, UIUtil.titleFont)
	LayoutHelpers.AtRightTopIn(unitviewtxt, unitview, 20, 9)
       unitviewtxt:SetColor(UIUtil.dialogCaptionColor)	
	local unitviewtxt2 = UIUtil.CreateText(unitview,uimanager_sav["modVersion"], 11, UIUtil.titleFont)
	LayoutHelpers.AtLeftTopIn(unitviewtxt2, unitview,15, 42)
       unitviewtxt2:SetColor("red")
	local unitviewtxtver = CreateText_sca(unitview,"autors", 12, UIUtil.titleFont)
	LayoutHelpers.AtRightTopIn(unitviewtxtver, unitview,20, 95)
       unitviewtxtver:SetColor("orange")
	   
	local unitviewtxt3 = CreateText_sca(unitview,("contains1"), 11, UIUtil.titleFont)
	LayoutHelpers.AtLeftTopIn(unitviewtxt3, unitview, 85, 32)
       unitviewtxt3:SetColor("White")
	 local unitviewtxt4 = CreateText_sca(unitview,("contains2"), 11, UIUtil.titleFont)
	LayoutHelpers.AtLeftTopIn(unitviewtxt4, unitview, 85, 51)
       unitviewtxt4:SetColor("White")
	 local unitviewtxt5 = CreateText_sca(unitview,("contains3"), 11, UIUtil.titleFont)
	LayoutHelpers.AtLeftTopIn(unitviewtxt5, unitview, 85, 70)
       unitviewtxt5:SetColor("White")
end

function Make_Reset_Button(parent)
	-- bouton reset
	local Reset_bouton = UIUtil.CreateButton(UIconfigPanel,
	'/game/icons/icon-trash-lg_btn_up.dds', '/game/icons/icon-trash-lg_btn_down.dds', '/game/icons/icon-trash-lg_btn_down.dds', '/game/icons/icon-trash-lg_btn_down.dds', nil, nil, nil, nil, '')
	LayoutHelpers.AtLeftTopIn(Reset_bouton, UIconfigPanel, 545, 250)
	Reset_bouton.Width:Set(Reset_bouton.Width()/1.5)
	Reset_bouton.Height:Set(Reset_bouton.Height()/1.5)
	Reset_bouton.OnClick = function()   
		UIUtil.QuickDialog(GetFrame(0), trad("reset2"), "<LOC _OK>",
			function()
				UIconfigPanel:Destroy()
				chrono=GetSystemTimeSeconds()+500
				local lang=Get_opt("langue")
				uimanager_sav = table.copy(sav_for_reset)
				uimanager_sav["langue"]=lang
				Prefs.SetToCurrentProfile("uimanager_sav",sav_for_reset)
				Prefs.SavePreferences()
#				reset()
				uimod.reset_sca()
				--reset keymapping
				results = {}
				remap.reset()
#				Splash(parent)
		end , "<LOC _Cancel>", function()  end, nil, nil, true, {escapeButton = 2, enterButton = 1, worldCover = false})
	end
	local Reset_txt = CreateText_sca(UIconfigPanel, ("reset"), 12, UIUtil.fixedFont)
	LayoutHelpers.AtLeftTopIn(Reset_txt, UIconfigPanel, 541, 300)
	return Reset_bouton
end

--make language selection control
function Make_Language_Select(parent,x,y)
		
		--that value will be loaded from prefs
		local language = Get_opt("langue")
		
		--language selection menu
		local lang1 = Bitmap(parent)
		lang1:SetTexture(UIUtil.UIFile(pathuiimg..'/bouton_vide.dds'))
		LayoutHelpers.AtLeftTopIn(lang1,parent,x,y)
		lang1.Depth:Set(parent.Depth() + 10) 
		
		--language selection slot 1
		local lang2 = Bitmap(GetFrame(0))
		lang2:SetTexture(UIUtil.UIFile(pathuiimg.. '/bouton_vide_top.dds'))
		lang2.Top:Set(function() return lang1.Bottom()-7 end)
		lang2.Left:Set(function() return lang1.Left() end)
		lang2.Width:Set(function() return lang2.BitmapWidth()*1.4 end)
		lang2.Depth:Set(lang1.Depth())
		
		--language selection slot 2 
		local lang3 = Bitmap(GetFrame(0))
		lang3:SetTexture(UIUtil.UIFile(pathuiimg.. '/bouton_vide_bottom.dds'))
		lang3.Top:Set(function() return lang2.Bottom() end)
		lang3.Left:Set(function() return lang1.Left() end)
		lang3.Width:Set(function() return lang3.BitmapWidth()*1.4 end)		
		lang3.Depth:Set(lang1.Depth())
		
		--english/american flag bitmap
		local enus = Bitmap(lang2)
		enus:SetTexture(UIUtil.UIFile(pathuiimg..'/enus_flag.dds'))
		LayoutHelpers.AtRightTopIn(enus,lang2,12,11)
		
		--french flag bitmap
		local fr = Bitmap(lang3)
		fr:SetTexture(UIUtil.UIFile(pathuiimg..'/french_flag.dds'))
		LayoutHelpers.AtRightTopIn(fr,lang3,12,3)
		
		--current language
		local current = Bitmap(lang1)
		if Get_opt("langue") == "english" then 
			current:SetTexture(UIUtil.UIFile(pathuiimg..'/enus_flag.dds'))
		elseif language == "francais" then
			current:SetTexture(UIUtil.UIFile(pathuiimg..'/french_flag.dds'))
		else
			current:SetTexture(UIUtil.UIFile(pathuiimg..'/enus_flag.dds'))
		end
		LayoutHelpers.CenteredRightOf(current,lang1,-35)
		
		--text1
		Text_lang = UIUtil.CreateText(lang1, Get_opt("langue") , 13, UIUtil.fixedFont)
		LayoutHelpers.AtLeftTopIn(Text_lang, lang1, 13, 10)
		
		--text2
		local text2 = UIUtil.CreateText(lang2, trad("english") , 13, UIUtil.fixedFont)
		LayoutHelpers.AtLeftTopIn(text2, lang2, 25, 10)	
		
		--text3
		local text3 = UIUtil.CreateText(lang3, trad("francais") , 13, UIUtil.fixedFont)
		LayoutHelpers.AtLeftTopIn(text3, lang3, 25, 3)
		
		--hide slots
		
		--refresh_lang_on_panel_off
		lang2:Hide() lang3:Hide()
		
		--menu handle event
		lang1.HandleEvent = function(self, event)
			--clicking on the control will show or hide slots
			if (event.Type == 'ButtonPress')  then
				if lang2:IsHidden() then  
					lang2:Show()
					lang3:Show()
					LOG("selecting mod language...")
				else
					lang2:Hide()
					lang3:Hide()	
					LOG("canceled")
				end
			--hovering over the control will display a tooltip
			elseif event.Type == 'MouseEnter' then
				Tooltip.CreateMouseoverDisplay(self, "select language", .5)
				if (lang2:IsHidden()) then lang1:SetTexture(UIUtil.UIFile(pathuiimg.. '/bouton_vide_actif.dds')) end
			elseif event.Type == 'MouseExit' then
				Tooltip.DestroyMouseoverDisplay()
				lang1:SetTexture(UIUtil.UIFile(pathuiimg.. '/bouton_vide.dds'))
			end
		end
		
		--slot 1 handle event
		lang2.HandleEvent = function(self, event)
			--clicking on the control will select the english language and hide the slots
			if (event.Type == 'ButtonPress')  then
				lang2:Hide()
				lang3:Hide()
				language = "english"
				LOG("mod language selected: " .. language)
				uimanager_sav["langue"] = language  
				Text_lang:SetText(language)
				Prefs.SetToCurrentProfile("uimanager_sav", uimanager_sav)
				Prefs.SavePreferences()
				refresh_lang()
				current:SetTexture(UIUtil.UIFile(pathuiimg..'/enus_flag.dds'))
			--hovering over the control will display a tooltip
			elseif event.Type == 'MouseEnter' then
				Tooltip.CreateMouseoverDisplay(self, "english", .5)
				lang2:SetTexture(UIUtil.UIFile(pathuiimg.. '/bouton_vide_top_actif.dds'))
			elseif event.Type == 'MouseExit' then
				Tooltip.DestroyMouseoverDisplay()
				lang2:SetTexture(UIUtil.UIFile(pathuiimg.. '/bouton_vide_top.dds'))
			end
		end
		
		--slot 2 handle event
		lang3.HandleEvent = function(self, event)
			--clicking on the control will select the french language and hide the slots
			if (event.Type == 'ButtonPress')  then
				lang2:Hide()
				lang3:Hide()
				language = "francais"
				LOG("mod language selected: " .. language)
				uimanager_sav["langue"] = language  
				Text_lang:SetText(language)
				Prefs.SetToCurrentProfile("uimanager_sav", uimanager_sav)
				Prefs.SavePreferences()
				refresh_lang()
				current:SetTexture(UIUtil.UIFile(pathuiimg..'/french_flag.dds'))
			--hovering over the control will display a tooltip
			elseif event.Type == 'MouseEnter' then
				Tooltip.CreateMouseoverDisplay(self, "francais", .5)
				lang3:SetTexture(UIUtil.UIFile(pathuiimg.. '/bouton_vide_bottom_actif.dds'))
			elseif event.Type == 'MouseExit' then
				Tooltip.DestroyMouseoverDisplay()
				lang3:SetTexture(UIUtil.UIFile(pathuiimg.. '/bouton_vide_bottom.dds'))
			end
		--hide slots
		end
end

function Make_Button_LayoutManager(parent,left,top)
	local Button_FitLayout = UIUtil.CreateButton(parent,pathuiimg..'/bouton_reset_layout.dds', pathuiimg..'/bouton_reset_layout_actif.dds', pathuiimg..'/bouton_reset_layout_actif.dds', pathuiimg..'/bouton_reset_layout_actif.dds', '')
			 
	Button_FitLayout:SetTexture(UIUtil.UIFile(pathuiimg..'/bouton_reset_layout.dds'))
	LayoutHelpers.AtLeftTopIn(Button_FitLayout,parent,left, top)
	Button_FitLayout.Width:Set(Button_FitLayout.Width()/1.5)
	Button_FitLayout.Height:Set(Button_FitLayout.Height()/1.5)
	Button_FitLayout.Depth:Set(parent.Depth()+20) 
	
	local txt1= CreateText_sca(Button_FitLayout,("Nice_layout_list1"), 14, UIUtil.titleFont)
	LayoutHelpers.AtRightTopIn(txt1, Button_FitLayout, 10, 20)
	txt1:SetColor("white")
	local txt2= CreateText_sca(Button_FitLayout,("Nice_layout_list2"), 14, UIUtil.titleFont)
	LayoutHelpers.AtRightTopIn(txt2, Button_FitLayout, 10, 35)
	txt2:SetColor("white")
		
	Button_FitLayout.OnClick = function(self)
		import(sca_utils..'layoutmanager.lua').ToggleWindow()
		toggleMainPopup()
	end
	
	return Button_FitLayout
end


--makes a panel to remap the keys
function Make_Key_Map_Panel(parent)

	-- local variables
	local command = false
	local command2 = ""
	local key = ""
	local result = false
	local ismodify = false
	
	
	-- panel to set and save camera option
	keyPanel = Bitmap(parent)
	keyPanel:SetTexture(UIUtil.SkinnableFile(pathuiimg..'/fenetre_keymap.dds'))
	LayoutHelpers.AtCenterIn(keyPanel,parent, -30, 60)
	keyPanel.Depth:Set(1100)
	
	-- panel to set and save camera option
	keyChoice = Bitmap(keyPanel)
	keyChoice:SetTexture(UIUtil.UIFile(pathuiimg..'/keychoice.dds'))
	LayoutHelpers.AtCenterIn(keyChoice,GetFrame(0))
	keyChoice.Depth:Set(5000)
	keyChoice.oldLeft = keyChoice.Left()
	keyChoice.Left:Set(6000)
	
	resultList.Reload = function()
		--keymapsPanel:Show()
		--keymapsPanel.Left:Set(keymapsPanel.oldLeft)
		if keymapsList then
			keymapsList.clear()
			for i,v in remap.keymaps.names do
				keymapsList.addElement(v)
			end
		end
	end
	
	-- key choice text
	local txt= CreateText_sca(keyChoice, "KeyMap_pressKey" , 16, UIUtil.titleFont)
	LayoutHelpers.AtCenterIn(txt, keyChoice)
	txt:SetColor("white") --UIUtil.dialogColumnColor)

	-- informations for minimizing
	keyPanel.mPosition = 10  	
	keyPanel.mOffset = -15  	
	keyPanel.mPath = 'reduitgd'  
	keyPanel.mRefresh = 0 	     
	keyPanel.mminimizable_when_panel_open=true
	

	--overwrite dialog
	local overwriteDialog = Make_Dialog_generic(keyPanel,"Overwrite","Overwrite2",
		function() remap.emptyKeyEntries(key)	remap.addResult(key,command2) remap.refresh_result(resultList,results) end)
	
	--resetDialog
	local resetDialog = Make_Dialog_generic(keyPanel,"ResetWarning","ResetWarning2",
		function() results = {} LOG(repr(results)) remap.refresh_result(resultList,results) end)

	


	
	-- make title
	local titre= CreateText_sca(keyPanel, "KeyMap_title" , 16, UIUtil.titleFont)
	LayoutHelpers.AtLeftTopIn(titre, keyPanel, 70,20)
	titre:SetColor(UIUtil.dialogColumnColor)
	
	--panel content
	
	--init
	GeneralCommandTab = false
	BuildCommandTab = false
	SelectionCommandTab = false
	local keyTab = remap.Keys
	command = GeneralCommandTab[1]
	result = false
	
	--init
	GeneralCommandTab, BuildCommandTab, SelectionCommandTab = remap.makeCommandTab()
	local commandList = Make_ListBox(keyPanel,42,90,320,"normal",40,false,BuildCommandTab,14,"Commands")	
	
	resultList = Make_ListBox(keyPanel,400,90,320, "normal",40,false,{},10,"Result")	
	results = remap.getSavedResults() 
	resultList.select(2,false,false)
	remap.refresh_result(resultList,results)
	remap.remapResultTable(results)
	local resultstitle = CreateText_sca(resultList, "KeyMap_title2" , 16, UIUtil.titleFont)
	LayoutHelpers.AtLeftTopIn(resultstitle, resultList, 0,-21)
	titre:SetColor(UIUtil.dialogColumnColor)
	
	
	commandList.initOpen()	
	
	--if is modify it will check for double values to replace a value
	local ismodify = false
	

	
	--remaps using the values in resultlist
	local remapResults = function()		
		remap.remapResultTable(results)
	end
	
	--a result has the following format: 	{command=String, key=String,category=String}
	resultList.addResult = function(mykey,mycommand)
		local categorytext = ''
		if string.find(mycommand,'<SCA_')!=nil then
			categorytext = '<' .. string.gsub(mycommand,'^<(.*)>.*$',"%1") .. '>'
		end
		local commandtext = string.gsub(mycommand,'^<.*>(.*)$',"%1")
		local result = {command = commandtext, key = mykey, category = categorytext}
		table.insert(results,result)
		LOG("")
		LOG("ADDING RESULT")
		LOG(repr(result))
	end
	
	resultList.removeResult = function(index)	
		LOG("")
		LOG("REMOVING RESULT")
		LOG(repr(results[index]))
		if string.find(results[index].category,'<SCA_SHIFT')!=nil then
			LOG(repr(results[index+1]))
			table.remove(results,index+1)
		end
		LOG(repr(results[index]))
		table.remove(results,index)		
	end


	
	--returns the results
	resultList.results = function()
		return results
	end
	
	--popup overwrite dialog
	resultList.overwrite = function(newkey,newcommand)
		overwriteDialog.Open()
		key = newkey
		command2 = newcommand
	end
	
	--make selection tabs
	buildTabButton = UIUtil.CreateCheckbox(commandList,  pathuiimg..'/tab-bg-up.dds', pathuiimg..'/tab-bg-up_sel.dds', pathuiimg..'/tab-bg-over.dds', pathuiimg..'/tab-bg-up_sel.dds',  pathuiimg..'/tab-bg-up.dds',  pathuiimg..'/tab-bg-up.dds')
	LayoutHelpers.AtLeftTopIn(buildTabButton, commandList, 4, -27)
	buildTabButton.Depth:Set(function() return commandList.Depth() + 100 end)
	local buildtext = UIUtil.CreateText(buildTabButton, "Build", 16)
	LayoutHelpers.AtCenterIn(buildtext, buildTabButton)
	buildTabButton.OnClick = function(self)
		if self:IsChecked() then
		else
			self:SetCheck(true)			commandList.clear()
			local GeneralUpdatedTab, BuildUpdatedTab = remap.makeCommandTab()
			for key,value in BuildUpdatedTab do
				commandList.addElement(value)
			end
			commandList.setPosition(1)
			generalTabButton:SetCheck(false)
			selectionTabButton:SetCheck(false)
		end
	end

	generalTabButton = UIUtil.CreateCheckbox(commandList,  pathuiimg..'/tab-bg-up.dds', pathuiimg..'/tab-bg-up_sel.dds', pathuiimg..'/tab-bg-over.dds', pathuiimg..'/tab-bg-up_sel.dds',  pathuiimg..'/tab-bg-up.dds',  pathuiimg..'/tab-bg-up.dds')
	LayoutHelpers.AtLeftTopIn(generalTabButton, commandList, 107, -27)
	generalTabButton.Depth:Set(function() return commandList.Depth() + 100 end)
	local gentext = UIUtil.CreateText(generalTabButton, "General", 16)
	LayoutHelpers.AtCenterIn(gentext, generalTabButton)
	generalTabButton.OnClick = function(self)
		if self:IsChecked() then
		else
			self:SetCheck(true)
			commandList.clear()
			local GeneralUpdatedTab, BuildUpdatedTab = remap.makeCommandTab()
			for key,value in GeneralUpdatedTab do
				commandList.addElement(value)
			end
			commandList.setPosition(1)
			buildTabButton:SetCheck(false)
			selectionTabButton:SetCheck(false)
		end
	end
	
	selectionTabButton = UIUtil.CreateCheckbox(commandList,  pathuiimg..'/tab-bg-up.dds', pathuiimg..'/tab-bg-up_sel.dds', pathuiimg..'/tab-bg-over.dds', pathuiimg..'/tab-bg-up_sel.dds',  pathuiimg..'/tab-bg-up.dds',  pathuiimg..'/tab-bg-up.dds')
	LayoutHelpers.AtLeftTopIn(selectionTabButton, commandList, 210, -27)
	selectionTabButton.Depth:Set(function() return commandList.Depth() + 100 end)
	local selectext = UIUtil.CreateText(selectionTabButton, "Selection", 16)
	LayoutHelpers.AtCenterIn(selectext, selectionTabButton)
	selectionTabButton.OnClick = function(self)
		if self:IsChecked() then
		else
			self:SetCheck(true)			commandList.clear()
			local GeneralUpdatedTab, BuildUpdatedTab, SelectionUpdatedTab = remap.makeCommandTab()
			for key,value in SelectionUpdatedTab do
				commandList.addElement(value)
			end
			commandList.setPosition(1)
			generalTabButton:SetCheck(false)
			buildTabButton:SetCheck(false)
		end
	end

	buildTabButton:SetCheck(true)
	
	--make an ok button
	local okButton = Make_Button_generic(keyPanel)
	okButton.OnQuit = function()
		--remap keys using the result list
		remap.restoreDefault()
		remapResults()
		keyPanel:Destroy()
		keyPanel = false
	end	
	
	--make a cancel button
	local cancelButton = Make_Button_generic(keyPanel,("Cancel"),false,190)
	cancelButton.OnQuit = function()
		--close keychoice panel
		keyChoice:AbandonKeyboardFocus()
		remap.Cancel()
		keyPanel:Destroy()
		keyPanel = false
	end	
	
	--make a restore default  button
	local restoreButton = Make_Button_generic(keyPanel,("Reset"),false,310)
	restoreButton.OnQuit = function()
		--resultList.clear()
		--resultList.addResult('Shift-Tab','POPUP TOGGLE')
		--resultList.addResult('Tab','ZOOMPOP TOGGLE')
		
		resetDialog.Open()
	end	
	
	--make a removeButton: remove an entry from the result list
	local removeButton = Make_Button_generic(keyPanel,("Remove"),false,270,100)
	removeButton.OnQuit = function()
		LOG("REMOVING AT INDEX: "..remap.returnIndex[resultList.r])
		resultList.removeResult(remap.returnIndex[resultList.r])
		remap.refresh_result(resultList,results)
	end	
	
	--make a modify button: click on modify to remap a key
	local modifyButton = Make_Button_generic(keyPanel,("Modify"),false,160,100)
	modifyButton.OnQuit = function()		
		ismodify = true
		keyChoice:Show()
		keyChoice.Left:Set(keyChoice.oldLeft)
		keyChoice:AcquireKeyboardFocus(true)
	end	
	
	--make a load button: click on load to load a keymap
	local loadButton = Make_Button_generic(keyPanel,("Load"),false,50,100)
	loadButton.OnQuit = function()
		--panel to chose a keymap set
		keymapsPanel = Bitmap(keyPanel)
		keymapsPanel:SetTexture(UIUtil.UIFile(pathuiimg..'/mini-fond.dds'))
		LayoutHelpers.AtCenterIn(keymapsPanel,GetFrame(0))
		keymapsPanel.Depth:Set(5000)
		keymapsPanel:Hide()
		local resultstitle = CreateText_sca(keymapsPanel, "KeyMap_load" , 16, UIUtil.titleFont)
		LayoutHelpers.AtLeftTopIn(resultstitle, keymapsPanel, 30,23)
		titre:SetColor(UIUtil.dialogColumnColor)
		local keymapsList = Make_ListBox(keymapsPanel,70,80,220,"normal",20,false,remap.keymaps.names ,4,"Keymaps")
		keymapsList.select(1,false,false)
		--cancel button for the keymaps panel
		local cancelKeyMapsButton = Make_Button_generic(keymapsPanel,("Cancel"),false,140,30)
		cancelKeyMapsButton.OnQuit = function()	
			--fades out on click
			keymapsPanel:Destroy()
		end		
	
		--cancel button for the keymaps panel
		local okKeyMapsButton = Make_Button_generic(keymapsPanel,("Load"),false,30,30)
		okKeyMapsButton.OnQuit = function()			
			--load table
			results = {}
			resultList.clear()
			for i,v in remap.keymaps.data[keymapsList.currentValue] do
				if v.category and v.command != nil then
					local command = v.category .. v.command
					local key = v.key
					resultList.addResult(key,command)
				end
			end		
			--hide panel		 
			resultList.select(2,false,false)
			remap.refresh_result(resultList,results)
			keymapsPanel:Destroy()
		end	
		--load a keymap from sca.remap on select
		keymapsList.OnSelect = function()	
			--list property, selects current value
		end		
		Effect.FadeIn(keymapsPanel,time_effect)			
		keymapsPanel:Show()	
	end		
	


	
	keyPanel.reset = function()
		results = {}
		resultList.clear()
		--resultList.insertElement('POPUP TOGGLE: Shift-Tab')
		--resultList.insertElement('ZOOMPOP TOGGLE: Tab')
		remap.reset()
	end
	

	
	commandList.OnSelect = function()
		--if commandList.currentValue != nil and string.find(commandList.currentValue,'<SCA_CATEGORY>') == nil then
		command = string.gsub( commandList.currentValue, "^(.*): (.*)$", "%1" )
		keyChoice:Show()
		keyChoice.Left:Set(keyChoice.oldLeft)
		keyChoice:AcquireKeyboardFocus(true)
		--end
	end
	
		
	--handles the add command: key association in resultsList event
	keyChoice.HandleEvent = function(self,event)
		if event.Type == "KeyDown" then
			
			local keyRemapped = remap.interpretKey(event,command,ismodify)
			
			--if a key has been remapped then close the keychoice panel
			if keyRemapped == true then
			keyChoice:Hide()
			keyChoice.Left:Set(6000)
			keyChoice:AbandonKeyboardFocus()
			remap.refresh_result(resultList,results)
			ismodify = false
			end
			
			return true
		end	

	end
		
		
	
	local rkey = {}
	local rvalue = {}
	resultList.OnSelect = function()		
		LOG('EQU INDEX:' .. remap.returnIndex[resultList.r])
		result = resultList.currentValue
		LOG(repr(result))
	end	
	
	
	keyPanel.noFade = {
		commandList.slideGlow,
		resultList.slideGlow,
	}
	
	return keyPanel
end




--generic function to put a an 'ok' button to close the panel on a panel
function Make_Button_generic(parent,text,doExit,xOffset,yOffset, tooltip)
	-- close the Config Panel
	
	--defaults for a quit button on a sca panel
	local x = xOffset or 36
	local y = yOffset or 26
	local name = text or "Ok"
	local quit = true
	if doExit != nil then
		quit = doExit
	end
	
	local okButton = UIUtil.CreateButton(parent, pathuiimg..'/bouton_vide.dds', pathuiimg..'/bouton_vide_actif.dds', pathuiimg..'/bouton_vide_actif.dds', pathuiimg..'/bouton_vide_actif.dds', trad(name), 16, 3)
	okButton.Right:Set(function() return parent.Right() - x end)
	okButton.Bottom:Set(function() return parent.Bottom() - y end)
	
	if tooltip then
		local btnHandleEvent = okButton.HandleEvent
		okButton.HandleEvent = function(self, event)
	        if event.Type == 'MouseEnter' then
	            Tooltip.CreateMouseoverDisplay(self, tooltip, 0.5)
	        elseif event.Type == 'MouseExit' then
	            Tooltip.DestroyMouseoverDisplay()
	        end
			btnHandleEvent(self, event)
		end
    end 
	--edit this function to add more functionality to the quit button 
	okButton.OnQuit = function()
	end
	
	--hides the window and calls the OnQuit function
	okButton.OnClick = function()		
		okButton.OnQuit()
		if quit == true then
			Effect.FadeOut(parent,time_effect) --parent:Hide()
		end
	end

	return okButton
end

--generic function to put a an 'ok' button to close the panel on a panel
function Make_Button_genericv2(parent,text,doExit,xOffset,yOffset)
	-- close the Config Panel
	
	--defaults for a quit button on a sca panel
	local x = xOffset or 36
	local y = yOffset or 26
	local name = text or "Ok"
	local quit = true
	if doExit != nil then
		quit = doExit
	end
	
	local okButton = UIUtil.CreateButton(parent, pathuiimg..'/bouton_vide.dds', pathuiimg..'/bouton_vide_actif.dds', pathuiimg..'/bouton_vide_actif.dds', pathuiimg..'/bouton_vide_actif.dds' , nil, nil, nil, nil, '')
	okButton.Right:Set(function() return parent.Right() - x end)
	okButton.Bottom:Set(function() return parent.Bottom() - y end)
	
	local nameText = CreateText_sca(okButton, name , 16, UIUtil.titleFont)
	LayoutHelpers.AtCenterIn(nameText, okButton, 3)
	nameText:SetColor("White")
	
	--edit this function to add more functionality to the quit button 
	okButton.OnQuit = function()
	end
	
	--hides the window and calls the OnQuit function
	okButton.OnClick = function()		
		okButton.OnQuit()
		if quit == true then
			parent:Destroy()
			--Effect.FadeOut(parent,time_effect) --parent:Hide()
		end
	end

	return okButton
end

--generic function to make a dialog with a yes and no button
function Make_Dialog_generic(parent,text1,text2,function1)

	local texta = ""
	if text1 != nil then
		texta = text1
	end
	local textb = ""
	if text2 != nil then
		textb = text2
	end
	local myfunction = function() end
	if function1 != nil then
		myfunction = function1
	end
	
	--background
	local dialog = Bitmap(parent)
	dialog:SetTexture(UIUtil.UIFile('/dialogs/dialog/panel_bmp.dds'))
	LayoutHelpers.AtCenterIn(dialog,GetFrame(0))
	dialog.Depth:Set(5000)
	dialog.oldLeft = dialog.Left()
	dialog.Left:Set(6000)
	
	-- dialog text 1
	local txt1= CreateText_sca(dialog, texta , 16, UIUtil.titleFont)
	LayoutHelpers.AtCenterIn(txt1, dialog,-40)
	txt1:SetColor("white") --UIUtil.dialogColumnColor)
	
	--dialog text 2
	local txt2= CreateText_sca(dialog, textb , 16, UIUtil.titleFont)
	LayoutHelpers.AtCenterIn(txt2, dialog,-6)
	txt2:SetColor("white") --UIUtil.dialogColumnColor)

	--clicking on the yes button will close the dialog and call the dialog function
	local yesButton = Make_Button_generic(dialog,("Yes"),false,250,30,4)
		yesButton.OnQuit = function()		
		dialog:Hide()
		dialog.Left:Set(6000)
		myfunction()
		--LOG("YES")
	end	

	--clicking on the no button will close the dialog
	local noButton = Make_Button_generic(dialog,("No"),false,70,30,4)
		noButton.OnQuit = function()		
		dialog:Hide()
		dialog.Left:Set(6000)
		--LOG("NO")
	end	
	
	--function to open the dialog
	dialog.Open = function()
		dialog.Left:Set(dialog.oldLeft)
		dialog:Show()
	end
	
	return dialog
end



function Make_Size_Icon(parent,left,top,size)
	sizeIcon = Bitmap(parent)
	sizeIcon:SetTexture(UIUtil.SkinnableFile(pathuiimg..'/iconSize_' .. uimod.factionTable[uimod.factionIndex] .. '.dds'))
	LayoutHelpers.AtLeftTopIn(sizeIcon,parent,left,top)
	sizeIcon.Height:Set(size)
	sizeIcon.Width:Set(size)
	sizeIcon.Depth:Set(parent.Depth() + 2)
	return sizeIcon
end

-- create the Splash windows
function Splash(parent)
	if debug_sca then print("Splash launch") end
	
if not UISplash then
	UISplash = Bitmap(parent)
	UISplash:SetTexture(UIUtil.SkinnableFile(pathuiimg..'/splash.dds'))
	LayoutHelpers.AtCenterIn(UISplash,parent)
	UISplash.Depth:Set(GetFrame(0):GetTopmostDepth() + 1)
	local titre=CreateText_sca(UISplash, ("welcome"), 22, UIUtil.titleFont)
	LayoutHelpers.AtLeftTopIn(titre, UISplash, 30,20)
	titre:SetColor(UIUtil.dialogColumnColor)
	Make_Language_Select(UISplash,700,80)
	
	local style=UIUtil.titleFont
	local size=15
	local text1 = CreateText_sca(UISplash, ("welcome2"), size+3, style)
	LayoutHelpers.AtLeftTopIn(text1, UISplash, 125, 120)
	local text2 = CreateText_sca(UISplash, ("welcome3"), size, style)
	LayoutHelpers.AtLeftTopIn(text2, UISplash, 150, 155)
	local text3 = CreateText_sca(UISplash, ("welcome4"), size, style)
	LayoutHelpers.AtLeftTopIn(text3, UISplash, 150, 185)
	local text4 = CreateText_sca(UISplash, ("welcome5"), size, style)
	LayoutHelpers.AtLeftTopIn(text4, UISplash, 150, 215)
	local text5 = CreateText_sca(UISplash, ("welcome6"), size, style)
	LayoutHelpers.AtLeftTopIn(text5, UISplash, 150, 245)
	local text6 = CreateText_sca(UISplash, ("welcome7"), size, style)
	LayoutHelpers.AtLeftTopIn(text6, UISplash, 150, 275)
	local text7 = CreateText_sca(UISplash, ("empty"), size, style)
	LayoutHelpers.AtLeftTopIn(text7, UISplash, 150, 305)
	
	local text10 = CreateText_sca(UISplash, ("welcome8"), size+3, style)
	LayoutHelpers.AtLeftTopIn(text10, UISplash, 240, 390)
	local text11= CreateText_sca(UISplash, ("welcome9"), size-3, style)
	LayoutHelpers.AtLeftTopIn(text11, UISplash, 530, 288)
	-- for beta version
	-- local beta=Bitmap(UISplash)
	-- beta:SetTexture(UIUtil.SkinnableFile(pathuiimg..'/beta.dds'))
	-- LayoutHelpers.AtLeftTopIn(beta, UISplash, 500,90)
	
else
	UISplash:Show()
end
	local Arrow = Bitmap(UISplash)
	Arrow:SetTexture(UIUtil.SkinnableFile(pathuiimg..'/arrow.dds'))
	LayoutHelpers.AtLeftTopIn(Arrow,UISplash,755,225)
	Arrow.Depth:Set(UISplash.Depth()+2)
	Arrow.Width:Set(50)
	Arrow.Height:Set(50)
	--Effect.Pulse(Arrow,2,0.7,0.3)
	
	local Tab = CreateText_sca(UISplash,("Tab_key"), 22, UIUtil.titleFont)
	LayoutHelpers.AtLeftTopIn(Tab, UISplash, 35, 340)
	Tab:SetColor("green") --UIUtil.dialogCaptionColor)	
	Effect.Pulse(Tab,1.7,0.05,0.88)
	
	local elapsedTime = 0
	Arrow.OnFrame = function(self, frameTime)
			elapsedTime = elapsedTime + frameTime

			--local timeSlice = frameTime / 2
			i=elapsedTime*5
			if i >10 then
				elapsedTime = 0
			end
			if i>10 then i=0 
			elseif i>10 then i=10 end
			LayoutHelpers.AtLeftTopIn(Arrow,UISplash,740+15*math.sin(.314*i),240-15*math.sin(.314*i))
			Arrow:SetAlpha(math.sin(.314*i)*.85)

    end
	Arrow:SetNeedsFrameUpdate(true)
	
	local skinfile = import(skinning.GetActualSkinFile())
	bt_preview(skinfile['Default'].path .. skinfile['Default'].layouts['Saya'].preview,60,425, function()
		--KillThread(mdThread) 
		Arrow:SetNeedsFrameUpdate(false)
		selectLayout('Default', "Saya") UISplash:Hide()   
		Arrow:Destroy()
		Tab:Destroy()
	end)

	bt_preview(skinfile['Default'].path .. skinfile['Default'].layouts['Cleopatre'].preview,310,425, function()
		--KillThread(mdThread) 
		Arrow:SetNeedsFrameUpdate(false)
		selectLayout('Default', "Cleopatre") UISplash:Hide() 
		Arrow:Destroy()
		Tab:Destroy()		
	end)
	
	bt_preview(skinfile['Default'].path .. skinfile['Default'].layouts['Goom'].preview,560,425, function()
		--KillThread(mdThread) 
		Arrow:SetNeedsFrameUpdate(false)
		selectLayout('Default', "Goom") UISplash:Hide()
		Arrow:Destroy()
		Tab:Destroy()		
	end)
	
	UISplash:Show()
end

function bt_preview(file,x,y,fct)
	UI_preview = UIUtil.CreateButton(UISplash, pathuiimg..'/bouton_preview.dds', pathuiimg..'/bouton_preview_actif.dds', pathuiimg..'/bouton_preview_actif.dds', pathuiimg..'/bouton_preview_actif.dds' , nil, nil, nil, nil, '')
	LayoutHelpers.AtLeftTopIn(UI_preview, UISplash, x, y)--mod
	UI_preview :SetAlpha(.2)
	
	UI_preview_fond = Bitmap(UISplash)
	UI_preview_fond:SetTexture(UIUtil.SkinnableFile(pathuiimg..'/bouton_preview.dds'))
	LayoutHelpers.AtCenterIn(UI_preview_fond,UI_preview)
	UI_preview_fond.Depth:Set(UI_preview.Depth() - 2)

	UI_preview.OnClick = function() fct() end
	UI_Saya = Bitmap(UISplash)
	UI_Saya:SetTexture(file)
	LayoutHelpers.AtCenterIn(UI_Saya,UI_preview)
	UI_Saya.Height:Set(152)
	UI_Saya.Width:Set(204)
	UI_Saya.Depth:Set(UI_preview.Depth() - 1)
end


--Generic function to make a panel minimizable.
minimizableOnUI = function(control)
  if (control != false) and (control!=nil) then
	control.minimized = false 
	local minimizer = false
	local maximizer = false
	local minimizedLeft = -400
	local minimizedTop = 10
	
	minimizer = UIUtil.CreateButton(control, pathuiimg..'/reduc.dds', pathuiimg..'/reduc_active.dds', pathuiimg..'/reduc_active.dds', pathuiimg..'/reduc.dds', nil, nil, nil, nil, '')
	
	if (control.mPath ~= nil) then 
		maximizer = UIUtil.CreateButton(control:GetParent(), pathuiimg..'/'..control.mPath .. '.dds', pathuiimg..'/'..control.mPath .. '_active.dds' , pathuiimg..'/'..control.mPath .. '_active.dds' , pathuiimg..'/'..control.mPath .. '.dds' , nil, nil, nil, nil, '')
	else 
		maximizer = UIUtil.CreateButton(control:GetParent(), pathuiimg..'/reduit_normal.dds', pathuiimg..'/reduit_active.dds', pathuiimg..'/reduit_active.dds' , pathuiimg..'/reduit_normal.dds'  , nil, nil, nil, nil, '')
	end
		
	LayoutHelpers.CenteredRightOf(minimizer,control,control.mOffset)
	maximizer.Left:Set(0)
	maximizer.Right:Set(12)
	maximizer.Top:Set(minimizedTop + 50*control.mPosition + 40)
	maximizer:Hide()
	minimizer.Depth:Set(function() return control:Depth() + 5 end )
	maximizer.Depth:Set(function() return control:Depth() + 5 end )
	minimizer.OnClick = function()
		if( not control.minimized ) and (UIconfigPanel:IsHidden() or control.mminimizable_when_panel_open) then
			maximizer.Top:Set(function() return minimizedTop + 60*control.mPosition end)
			control.oldLeft = control.Left()
			control.oldTop = control.Top()
			control.oldHeight = control.Height()
			control.oldWidth = control.Width()
			control.oldAlpha = control:GetAlpha()
			if debug_sca then print("minimizing") end
			control.minimized = true
			minimizer:Hide()
			--function MoveAndSizeTo(control, newWidth, newHeight, xVal, yVal, time, mode, origin, frameFunction, initialAlpha, finalAlpha, controlparent)
			if control.Resizer then
				MyEffects.MoveAndSizeTo(control.Resizer, control.oldWidth, control.oldHeight, minimizedLeft, control.oldTop, 0.4, 0, 0,nil, control.oldAlpha, 0, control)--test
			else
				MyEffects.MoveAndSizeTo(control, control.oldWidth, control.oldHeight, minimizedLeft, control.oldTop, 0.4, 0, 0,nil, control.oldAlpha, 0)--test
			end
			maximizer:SetAlpha(1,true)
			maximizer:Show()
		else
			if( not control.minimized ) then print("UIMOD: Can't minimize this window when config panel is open")
			else LOG("INFO UIMOD: minimize trying to create an already existing minimize button (in minimizableOnUI).") end
		end
	end

	maximizer.OnClick = function()
		if( control.minimized ) then
		if debug_sca then print("maximizing") end
			control.minimized = false
			maximizer:Hide()
			minimizer:Show()
			if control.Resizer then
				MyEffects.MoveAndSizeTo(control.Resizer, control.oldWidth, control.oldHeight, control.oldLeft, control.oldTop, 0.4, 0, 0,function() if control.mRefresh == 1 then
					import('/lua/ui/game/economy.lua').controls.massWarningBG:SetAlpha(0,true)
					import('/lua/ui/game/economy.lua').controls.energyWarningBG:SetAlpha(0,true)
				end end, 0, control.oldAlpha, control)--test
				control.Resizer:Hide()
			else
				MyEffects.MoveAndSizeTo(control, control.oldWidth, control.oldHeight, control.oldLeft, control.oldTop, 0.4, 0, 0,function() if control.mRefresh == 1 then
					import('/lua/ui/game/economy.lua').controls.massWarningBG:SetAlpha(0,true)
					import('/lua/ui/game/economy.lua').controls.energyWarningBG:SetAlpha(0,true)
				end end, 0, control.oldAlpha)--test
			end
--			import('/lua/maui/effecthelpers.lua').MoveAndSizeTo(control, control.oldWidth, control.oldHeight, control.oldLeft, control.oldTop, 0, 0,1,function() if control.mRefresh == 1 then
--				import('/lua/ui/game/economy.lua').controls.massWarningBG:SetAlpha(0,true)
--				import('/lua/ui/game/economy.lua').controls.energyWarningBG:SetAlpha(0,true)
--				LOG('changing alpha')
--			end end)--test

			--if debug_sca then LOG("INFO UIMOD: Maximization done successfully.") end
		else
		--if debug_sca then LOG("INFO UIMOD: maximize is call with a control nil or false (in minimizeonUI).") end
		end
	end
	a=false
	return maximizer.OnClick
	--overviewOnUI(maximizer,control) -- TEST
   else
	WARN("WARNING UIMOD: minimizableOnUI is call with a control nil of false.")
   end
end


--easy way to minimize until minimize(control) works better
flemmeMinimize = function(controlname)
	if construction_done then
		local layout = UIUtil.currentLayout
		local prefsaver = Prefs.GetFromCurrentProfile("uimod_SCA_" ..layout)
		prefsaver[controlname]["oldLeft"] = prefsaver[controlname]["Left"]
		prefsaver[controlname]["oldRight"] = prefsaver[controlname]["Right"]
		prefsaver[controlname]["Left"] = 4000
		prefsaver[controlname]["Right"] = 4500
		Prefs.SetToCurrentProfile("uimod_SCA_" ..layout, prefsaver)
		Prefs.SavePreferences()
		uimod.RefreshLayout()
	end
end

--easy way to maximize until maximize(control) works better
flemmeMaximize = function(controlname)
	if construction_done then
		local layout = UIUtil.currentLayout
		local prefsaver = Prefs.GetFromCurrentProfile("uimod_SCA_" ..layout)
		if prefsaver[controlname]["oldLeft"] != nil then 
			prefsaver[controlname]["Left"] = prefsaver[controlname]["oldLeft"]
			prefsaver[controlname]["Right"] = prefsaver[controlname]["oldRight"]
			Prefs.SetToCurrentProfile("uimod_SCA_" ..layout, prefsaver)
			Prefs.SavePreferences()
			uimod.RefreshLayout()
		else
			LOG("INFO UIMOD: flemmeMaximize has no saved value for control: " ..controlname)
		end
	end
end

function table.copy( self, deep, ud_copy_fn )
    ud_copy_fn = ud_copy_fn or function ( ud ) return ud end
    local new_table = {}
    for key, value in self do
        local new_key
        if ( deep and type( key ) == 'table' ) then
            new_key = table.copy( key, deep, ud_copy_fn )
        elseif ( type( key ) == 'userdata' ) then
            new_key = ud_copy_fn( key )
        else
            new_key = key
        end

        local new_value
        if ( deep and type( value ) == 'table' ) then
            new_value = table.copy( value, deep, ud_copy_fn )
        elseif ( type( value ) == 'userdata' ) then
            new_value = ud_copy_fn( value )
        else
            new_value = value
        end
        new_table[ new_key ] = new_value
    end
     return new_table
end



--new draggable/resizable function using an extra resize group.
--ResizeGrp is based on Window, usage is self = ResizeGrp(parent, title, icon, pin, config, lockSize, lockPosition, xmin, ymin, limitmovement,name)
--it's set up in another file because it's much longer than the original dragonui function
--xmin is minimum horizontal size, ymin is minimum vertical size defined as control.xmin in the relevant layout file, limitmove stops controls being moved offscreen
--name is important for border snapping
local stupidworkaroundlocal = true
local stupidworkaroundlocalindex = 0
dragOnUI = function(control, name, bLimitMove)
	if (control!=nil and control!=false) then
		--if not control.Resizer then STUPID WORKAROUND FIX LATER!
		if stupidworkaroundlocal or (name != "unitview" and name != "score" and name != "resizeopt") then
			--create the resize panel
			GameParent=import('/lua/ui/game/gamemain.lua').GetGameParent()
			
			if uimod.sca[name].configwindow then
				config = true
			else
				config = false
			end
			
			if trad(uimod.sca[name].name .. "_title")!="(no text)" then
				title = uimod.sca[name].name .. "_title"
			else
				title="nothing"
			end
			
			local ResizeGrp = import('/mods/uimod/sca_utils/resizegrp.lua').ResizeGrp
			if name then
				control.Resizer = ResizeGrp(GameParent, title, nil, nil, config, true, false, nil, nil, bLimitMove, name)
			else
				control.Resizer = ResizeGrp(GameParent, 'Unknown', nil, nil, config, true, false, nil, nil, bLimitMove)
			end
			

			if config then
				control.Resizer.OnConfigClick = function(self)
					uimod.saveModValues('default')
					constructing = true
					configwindow[name](control.Resizer)
					constructing = false
				end
			end
			
			control.Resizer:Hide()
			
			--make a table of all active resizers for showing/hiding
			
			ResizeTable[name] = control.Resizer
			import(sca_utils .. 'modcontrols.lua').TitleTable[title] = control.Resizer._title
			
			control.Resizer.OnDestroy = function()
				ResizeTable[name] = nil
				import(sca_utils .. 'modcontrols.lua').TitleTable[title] = nil
			end
		end
	end
	if name == "unitview" or name == "score" or name == "resizeopt" then
		stupidworkaroundlocalindex = stupidworkaroundlocalindex + 1
	end
	if stupidworkaroundlocalindex == 2 then
		stupidworkaroundlocal = false
	end
end


--Resizer config windows, there's a better way of doing this than a big list of functions here but I can't think of it yet.
--function Make_CheckBox(parent,x,y,name_in_game_pref,fct_ON,fct_OFF,brefresh,bmake_init,label_txt,xrelatif,yrelatif,size_txt,style,color,help_tips)

configwindow["energy"] = function(parent)
    if parent.configwindow then return end
    parent.configwindow = Window(GetFrame(0), 'Energy Config', nil, nil, nil, true,false,false,false)
    parent.configwindow.Left:Set(function() return parent.Left() + 10 end)
    parent.configwindow.Top:Set(function() return parent.Top() + 30 end)
    parent.configwindow.Right:Set(function() return parent.Left() + 180 end)
    parent.configwindow.Bottom:Set(function() return parent.Top() + 120 end)
    parent.configwindow.Depth:Set(GetFrame(0):GetTopmostDepth() + 1)
    
    local client = parent.configwindow:GetClientGroup()

	verticalenergy = Make_CheckBox(client, 5, 5, "verticalenergy", nil, nil, true, true, "verticalenergy", nil, nil, nil, nil, nil, "verticalenergyhelp")

	local oldclick = verticalenergy.OnClick
	
	verticalenergy.OnClick = function(self)
		oldclick(self)
		parent.configwindow:Destroy()
        parent.configwindow = false
	end
	

	inverseenergy = Make_CheckBox(client, 5, 27, "inverse_barre", nil, nil, true, true,  "inverseenergy", nil, nil, nil, nil, nil, "inverseenergyhelp")
	
	if verticalenergy:IsChecked() then
		inverseenergy:Disable()
	end
	
	local ioldclick = inverseenergy.OnClick
	
	inverseenergy.OnClick = function(self)
		ioldclick(self)
		parent.configwindow:Destroy()
        parent.configwindow = false
	end
				
	parent.configwindow.OnClose = function(self)
        parent.configwindow:Destroy()
        parent.configwindow = false
    end	
end


configwindow["mass"] = function(parent)
    if parent.configwindow then return end
    parent.configwindow = Window(GetFrame(0), 'Mass Config', nil, nil, nil, true,false,false,false)
    parent.configwindow.Left:Set(function() return parent.Left() + 10 end)
    parent.configwindow.Top:Set(function() return parent.Top() + 30 end)
    parent.configwindow.Right:Set(function() return parent.Left() + 180 end)
    parent.configwindow.Bottom:Set(function() return parent.Top() + 100 end)
    parent.configwindow.Depth:Set(GetFrame(0):GetTopmostDepth() + 1)
    
    local client = parent.configwindow:GetClientGroup()

	verticalmass = Make_CheckBox(client, 5, 5, "verticalmass", nil, nil, true, true,  "verticalmass", nil, nil, nil, nil, nil, "verticalmasshelp")

	local oldclick = verticalmass.OnClick
	
	verticalmass.OnClick = function(self)
		oldclick(self)
		parent.configwindow:Destroy()
        parent.configwindow = false
	end
				
	parent.configwindow.OnClose = function(self)
        parent.configwindow:Destroy()
        parent.configwindow = false
    end	
end


configwindow["options"] = function(parent)
    if parent.configwindow then return end
    parent.configwindow = Window(GetFrame(0), 'Options Config', nil, nil, nil, true,false,false,false)
    parent.configwindow.Left:Set(function() return parent.Left() + 10 end)
    parent.configwindow.Top:Set(function() return parent.Top() + 30 end)
    parent.configwindow.Right:Set(function() return parent.Left() + 180 end)
    parent.configwindow.Bottom:Set(function() return parent.Top() + 100 end)
    parent.configwindow.Depth:Set(GetFrame(0):GetTopmostDepth() + 1)
    
    local client = parent.configwindow:GetClientGroup()

	verticaloptions = Make_CheckBox(client, 5, 5, "verticaloptions", nil, nil, true, true,  "verticaloptions", nil, nil, nil, nil, nil, "verticaloptionshelp")

	local oldclick = verticaloptions.OnClick
	
	verticaloptions.OnClick = function(self)
		oldclick(self)
		parent.configwindow:Destroy()
        parent.configwindow = false
	end
			
	parent.configwindow.OnClose = function(self)
        parent.configwindow:Destroy()
        parent.configwindow = false
    end	
end

configwindow["mfd"] = function(parent)
    if parent.configwindow then return end
    parent.configwindow = Window(GetFrame(0), 'MFD Config', nil, nil, nil, true,false,false,false)
    parent.configwindow.Left:Set(function() return parent.Left() + 10 end)
    parent.configwindow.Top:Set(function() return parent.Top() + 30 end)
    parent.configwindow.Right:Set(function() return parent.Left() + 180 end)
    parent.configwindow.Bottom:Set(function() return parent.Top() + 100 end)
    parent.configwindow.Depth:Set(GetFrame(0):GetTopmostDepth() + 1)
    
    local client = parent.configwindow:GetClientGroup()

	verticalMFD = Make_CheckBox(client, 5, 5, "verticalMFD", nil, nil, true, true,  "verticalmfd", nil, nil, nil, nil, nil, "verticalmfdhelp")

	local oldclick = verticalMFD.OnClick
	
	verticalMFD.OnClick = function(self)
		oldclick(self)
		parent.configwindow:Destroy()
        parent.configwindow = false
	end
			
	parent.configwindow.OnClose = function(self)
        parent.configwindow:Destroy()
        parent.configwindow = false
    end	
end

configwindow["construction"] = function(parent)
    if parent.configwindow then return end
    parent.configwindow = Window(GetFrame(0), 'Const. Config', nil, nil, nil, true,false,false,false)
    parent.configwindow.Left:Set(function() return parent.Left() + 10 end)
    parent.configwindow.Top:Set(function() return parent.Top() + 30 end)
    parent.configwindow.Right:Set(function() return parent.Left() + 180 end)
    parent.configwindow.Bottom:Set(function() return parent.Top() + 120 end)
    parent.configwindow.Depth:Set(GetFrame(0):GetTopmostDepth() + 1)
    
    local client = parent.configwindow:GetClientGroup()

	altconstruction = Make_CheckBox(client, 5, 5, "altconstruction", nil, nil, true, true,  "altconstruction", nil, nil, nil, nil, nil, "altconstructionhelp")

	local oldclick = altconstruction.OnClick
	
	altconstruction.OnClick = function(self)
		oldclick(self)
		parent.configwindow:Destroy()
        parent.configwindow = false
	end
	
	vertconstruction = Make_CheckBox(client, 5, 27, "vertconstruction", nil, nil, true, true,  "vertconstruction", nil, nil, nil, nil, nil, "vertconstructionhelp")

	local oldclick = vertconstruction.OnClick
	
	vertconstruction.OnClick = function(self)
		oldclick(self)
		parent:SetMinimumResize(construction.controls.constructionGroup.xmin, construction.controls.constructionGroup.ymin)
		if parent.Height() < construction.controls.constructionGroup.ymin then
			parent.Bottom:Set(function() return parent.Top() +  construction.controls.constructionGroup.ymin end)
		end
		parent.configwindow:Destroy()
        parent.configwindow = false
	end
	
	parent.configwindow.OnClose = function(self)
        parent.configwindow:Destroy()
        parent.configwindow = false
    end	
end

configwindow["unitview"] = function(parent)
    if parent.configwindow then return end
    parent.configwindow = Window(GetFrame(0), 'Unitview Config', nil, nil, nil, true,false,false,false)
    parent.configwindow.Left:Set(function() return parent.Left() + 10 end)
    parent.configwindow.Top:Set(function() return parent.Top() + 30 end)
    parent.configwindow.Right:Set(function() return parent.Left() + 190 end)
    parent.configwindow.Bottom:Set(function() return parent.Top() + 100 end)
    parent.configwindow.Depth:Set(GetFrame(0):GetTopmostDepth() + 1)
    
    local client = parent.configwindow:GetClientGroup()

	altunitview = Make_CheckBox(client, 5, 5, "new_unit_view", nil, nil, false, true,  "new_unit_view", nil, nil, nil, nil, nil, "new_unit_view2")

	local oldclick = altunitview.OnClick
	
	altunitview.OnClick = function(self)
		oldclick(self)
		parent.configwindow:Destroy()
        parent.configwindow = false
	end
			
	parent.configwindow.OnClose = function(self)
        parent.configwindow:Destroy()
        parent.configwindow = false
    end	
end


configwindow["borders"] = function(parent)
    if parent.configwindow then return end
    parent.configwindow = Window(GetFrame(0), 'Borders Config', nil, nil, nil, true,false,false,false)
    parent.configwindow.Left:Set(function() return parent.Left() + 10 end)
    parent.configwindow.Top:Set(function() return parent.Top() + 30 end)
    parent.configwindow.Right:Set(function() return parent.Left() + 190 end)
    parent.configwindow.Bottom:Set(function() return parent.Top() + 100 end)
    parent.configwindow.Depth:Set(GetFrame(0):GetTopmostDepth() + 1)
    
    local client = parent.configwindow:GetClientGroup()

	showborders = Make_CheckBox(client, 5, 5, "showborders", nil, nil, true, true,  "showborders", nil, nil, nil, nil, nil, "showbordershelp")

	local oldclick = showborders.OnClick
	
	showborders.OnClick = function(self)
		oldclick(self)
		parent.configwindow:Destroy()
        parent.configwindow = false
	end
			
	parent.configwindow.OnClose = function(self)
        parent.configwindow:Destroy()
        parent.configwindow = false
    end
end


configwindow["orders"] = function(parent)
    if parent.configwindow then return end
 	uimod.saveModValues("default")
	parent.configwindow = Window(GetFrame(0), 'Orders Config', nil, nil, nil, true,false,false,false)
    parent.configwindow.Left:Set(function() return parent.Left() + 10 end)
    parent.configwindow.Top:Set(function() return parent.Top() + 30 end)
    parent.configwindow.Right:Set(function() return parent.Left() + 180 end)
    parent.configwindow.Bottom:Set(function() return parent.Top() + 145 end)
    parent.configwindow.Depth:Set(GetFrame(0):GetTopmostDepth() + 1)
    
    local client = parent.configwindow:GetClientGroup()

	local orders34 = UIUtil.CreateCheckboxStd(client, '/dialogs/check-box_btn/radio')
	LayoutHelpers.AtLeftTopIn(orders34, client, 5, 5)
    local orders34label = UIUtil.CreateText(client, " 3x4", 14)
	LayoutHelpers.CenteredRightOf(orders34label, orders34)
	local orders43 = UIUtil.CreateCheckboxStd(client, '/dialogs/check-box_btn/radio')
	LayoutHelpers.AtLeftTopIn(orders43, client, 5, 27)
    local orders43label = UIUtil.CreateText(client, " 4x3", 14)
	LayoutHelpers.CenteredRightOf(orders43label, orders43)
	local orders62 = UIUtil.CreateCheckboxStd(client, '/dialogs/check-box_btn/radio')
	LayoutHelpers.AtLeftTopIn(orders62, client, 5, 49)
    local orders62label = UIUtil.CreateText(client, " 6x2", 14)
	LayoutHelpers.CenteredRightOf(orders62label, orders62)
	
	
	
	if Get_opt("ordersgrid") == 62 then
		orders62:SetCheck(true)
	elseif Get_opt("ordersgrid") == 43 then
		orders43:SetCheck(true)
	else
		orders34:SetCheck(true)
	end
	

	orders34.OnCheck = function(self, checked)
		if checked then
			orders43:SetCheck(false)
			orders62:SetCheck(false)
			uimanager_sav["ordersgrid"] = 34
			Prefs.SetToCurrentProfile("uimanager_sav", uimanager_sav)
			uimod.RefreshLayout()
			parent.configwindow:Destroy()
			parent.configwindow = false
		end
	end

	orders43.OnCheck = function(self, checked)
		if checked then
			orders34:SetCheck(false)
			orders62:SetCheck(false)
			uimanager_sav["ordersgrid"] = 43
			Prefs.SetToCurrentProfile("uimanager_sav", uimanager_sav)
			uimod.RefreshLayout()
			parent.configwindow:Destroy()
			parent.configwindow = false
		end
	end

	orders62.OnCheck = function(self, checked)
		if checked then
			orders34:SetCheck(false)
			orders43:SetCheck(false)
			uimanager_sav["ordersgrid"] = 62
			Prefs.SetToCurrentProfile("uimanager_sav", uimanager_sav)
			uimod.RefreshLayout()
			parent.configwindow:Destroy()
			parent.configwindow = false
		end
	end

	parent.configwindow.OnClose = function(self)
        parent.configwindow:Destroy()
        parent.configwindow = false
    end
end


configwindow["queue"] = function(parent)
    if parent.configwindow then return end
    parent.configwindow = Window(GetFrame(0), 'Queue Config', nil, nil, nil, true,false,false,false)
    parent.configwindow.Left:Set(function() return parent.Left() + 10 end)
    parent.configwindow.Top:Set(function() return parent.Top() + 30 end)
    parent.configwindow.Right:Set(function() return parent.Left() + 190 end)
    parent.configwindow.Bottom:Set(function() return parent.Top() + 100 end)
    parent.configwindow.Depth:Set(GetFrame(0):GetTopmostDepth() + 1)
    
    local client = parent.configwindow:GetClientGroup()

	vertqueue = Make_CheckBox(client, 5, 5, "vertqueue", nil, nil, true, true,  "vertqueue", nil, nil, nil, nil, nil, "vertqueue2")

	local oldclick = vertqueue.OnClick
	
	vertqueue.OnClick = function(self)
		oldclick(self)
		parent:SetMinimumResize(queue.controls.queueGroup.xmin, queue.controls.queueGroup.ymin)
		if parent.Height() < queue.controls.queueGroup.ymin then
			parent.Bottom:Set(function() return parent.Top() +  queue.controls.queueGroup.ymin end)
		end
		parent.configwindow:Destroy()
        parent.configwindow = false
	end
			
	parent.configwindow.OnClose = function(self)
        parent.configwindow:Destroy()
        parent.configwindow = false
    end
end


--function to lock a control by removing its handleevent
lock = function(control, boolean)
	if boolean == true then
		control.oldHandleEvent = control.HandleEvent
		control.HandleEvent = function(self, event)
			--do nothing, control is locked
		end
	else
		if control.oldHandleEvent != nil then
			control.HandleEvent = control.oldHandleEvent
		end
	end
end

--function to lock a slider
lockSlider = function(slider, boolean)
	lock(slider._thumb,boolean)
	lock(slider._background,boolean)
end


--resizes the icons size
function resizeIcons(size)
	
	local pathui = '/mods/uimod/hook'
	local construction_sca = import(pathui .. '/lua/ui/game/layouts/construction_sca.lua')
	local queue_sca = import(pathui .. '/lua/ui/game/layouts/queue_sca.lua')
	local selectionmanager_sca = import(pathui .. '/lua/ui/game/layouts/selectionmanager_sca.lua')
	local constheight = 100
	local constwidth = 200
	local queueheight = 100
	local queuewidth = 200
	
	local value = size
	if (Prefs.GetFromCurrentProfile("uimod_SCA_sca")["construction"]["Bottom"] != nil ) then
		constheight = Prefs.GetFromCurrentProfile("uimod_SCA_sca")["construction"]["Bottom"] - Prefs.GetFromCurrentProfile("uimod_SCA_sca")["construction"]["Top"] - GridBorders["constructionHeight"]
		constwidth = Prefs.GetFromCurrentProfile("uimod_SCA_sca")["construction"]["Right"] - Prefs.GetFromCurrentProfile("uimod_SCA_sca")["construction"]["Left"] - GridBorders["constructionWidth"]
		queueheight = Prefs.GetFromCurrentProfile("uimod_SCA_sca")["queue"]["Bottom"] - Prefs.GetFromCurrentProfile("uimod_SCA_sca")["queue"]["Top"] - GridBorders["queueHeight"]
		queuewidth = Prefs.GetFromCurrentProfile("uimod_SCA_sca")["queue"]["Right"] - Prefs.GetFromCurrentProfile("uimod_SCA_sca")["queue"]["Left"] - GridBorders["queueWidth"]
	end
	
	value = math.min(math.min(math.min(math.min(constheight, value), constwidth), queueheight, queuewidth))

	if value != size then
		print(trad("iconsizewarning"))
	end
		
	for i = 1, 10 do
		if math.abs(i*value - constheight) < 15 then
			value = math.floor(constheight/i - 0.5) + 1
		end
	end
	
	value = math.floor(value + 0.01)
	if infoIcon != false then
		infoIcon.Width:Set(value)
		infoIcon.Height:Set(value)
	end
	
	construction.boutonH = value
	construction.boutonW = value
	queue.boutonH = value
	queue.boutonW = value
	selectionmanager.boutonH = value
	selectionmanager.boutonW = value
	--LOG("=>"..value)
	
	remap.boutonH = value
	remap.boutonW = value
	
	updateIconGrids(construction.controls.unitGrid, value)
	updateIconGrids(selectionmanager.controls.iconGrid, value)
	updateIconGrids(queue.controls.queueGrid, value)
		
	construction_sca.gridX = construction.boutonW
	construction_sca.gridY = construction.boutonH	
	queue_sca.gridX = queue.boutonH
	queue_sca.gridY = queue.boutonW
	selectionmanager_sca.gridX = queue.boutonH
	selectionmanager_sca.gridY = queue.boutonW
	
end

updateIconGrids = function(control, value)
	control._itemWidth = value
	control._itemHeight = value
	control._visible["Horz"]:Set(function() return math.floor(control.Width() / value) end)
	control._visible["Vert"]:Set(function() return math.floor(control.Height() / value) end)
end

-- INFORMATIONS:
------------------------
--LISTE DES DEPTHS POUR LE MOD

--orders:  controls.bg.Depth:Set(110)
--queue:controls.queueGroup.Depth:Set(150)
--construction:controls.constructionGroup.Depth:Set(130)
--mass:controls.massBG.Depth:Set(200)
--energy:controls.energyBG.Depth:Set(400)
--bouton test:boutonTest.Depth:Set( 600 )--always on top
--score: overlay.group.Depth:Set(900)
--ui config panel: UIconfigPanel.Depth:Set(1000)
-- console_option_panel: consolePanel.Depth:Set(1100) 
--GUI.bg.Depth:Set(20)
--borders resizer: 100
--other resizers: 900	

local aStratIconTranslation = import(sca_utils.. 'straticons.lua').aStratIconTranslation
local aSpecificStratIcons = import(sca_utils.. 'straticons.lua').aSpecificStratIcons

--------------------------------------------------------------------------------
-- add a strategic icon to parent
--
function addStrategicIconTo(oParent, bpUnit)
	if uimanager_sav["straticons"] == 1 then
		if not oParent.bmStratIcon then
			local sTexture = false
			if aSpecificStratIcons[bpUnit.BlueprintId] then
				sTexture = pathuiimg.. '/icons_strategic/'..aSpecificStratIcons[bpUnit.BlueprintId]..'.dds'
			elseif aStratIconTranslation[bpUnit.StrategicIconName] then
				sTexture = pathuiimg.. '/icons_strategic/'..aStratIconTranslation[bpUnit.StrategicIconName]..'.dds'
			end
			if sTexture then
				bmStratIcon = Bitmap(oParent)
				bmStratIcon:SetTexture(sTexture)
				bmStratIcon.Bottom:Set(function() return oParent.Bottom() - 1 end)
				bmStratIcon.Right:Set(function() return oParent.Right() - 1 end)
				bmStratIcon.Height:Set(construction.boutonH/2)
				bmStratIcon.Width:Set(construction.boutonW/2)
				bmStratIcon:SetAlpha(0.8)
				bmStratIcon:DisableHitTest()
				oParent.bmStratIcon = bmStratIcon
			end
		end
	end
end





function On_Move_Resize()
	constructing = true
	local view=import('/lua/ui/game/worldview.lua')
	local Unlock=function() end --function() view.viewLeft:UnlockInput() binput_lock=false end  --PATCH FORCE
	local Lock=function() end --view.viewLeft:LockInput() binput_lock=true end -- PATCH FORCE

	ResizerActivation = true
	if not(binput_lock) then
		Lock()
	end
	if not(gamemain.GetReplayState()) then
		constructionCtr.constructionGroup:Hide()
		import('/lua/ui/game/orders.lua').controls.bg:Show()
	end
	unitview:Show()
	import('/lua/ui/game/selectionmanager.lua').controls.panelmin:Show()
	queueCtr.queueGroup:Show()
	for name, control in ResizeTable do
		if Prefs.GetFromCurrentProfile("uimanager_sav")["miniui_econ"]==1 then
			if uimod.sca[name].layout_sca_mini then
				--control:Show()
				--control:SetAlpha(0.75, true)
				if name == "borders" then
					control:Show()
					control:SetAlpha(0.35, true)
				else
					Effect.FadeIn(control,time_effect*2.2,0,0.75)
				end
			end
		else
			if name == "minimap" then
				if not(gamemain.GetReplayState()) then
					if Prefs.GetFromCurrentProfile('stratview') then
						control:Show()
						control:SetAlpha(0.75, true)
					end
				end
			else
				--control:Show()
				--control:SetAlpha(0.75, true)
				if name == "borders" then
					control:Show()
					control:SetAlpha(0.35, true)
				else
					Effect.FadeIn(control,time_effect*2.2,0,0.75)
				end
			end
		end
	end
	selectionmanager.Resizing()
	queue.Resizing()
	toggleMainPopup()
	resize_opt.panel:Show()
	Effect.Pulse(resize_opt.button,2,0.35,1)
	constructing = false
end

function Off_Move_Resize()
	local view=import('/lua/ui/game/worldview.lua')
	local Unlock=function() end --view.viewLeft:UnlockInput() binput_lock=false end  -- PATCH FORCE
	local Lock=function() end --view.viewLeft:LockInput() binput_lock=true end
		
	ResizerActivation = false
	if binput_lock then
		Unlock()
	end
	if not(gamemain.GetReplayState()) then
		constructionCtr.constructionGroup:Hide()
		if Get_opt('affiche_construc')==1 then
			import('/lua/ui/game/orders.lua').controls.bg:Hide()
		end
	end
	unitview:Hide()
	if Get_opt('affiche_construc')==1 then
		import('/lua/ui/game/selectionmanager.lua').controls.panelmin:Hide()
		queueCtr.queueGroup:Hide()
	end
	for i, control in ResizeTable do
		control:Hide()
		if control.configwindow then
		    control.configwindow:Destroy()
			control.configwindow = false
		end
	end
	uimod.saveModValues("default")
	toggleMainPopup()
	resize_opt.panel:Hide()
	uimod.RefreshLayout()
	resizeIcons(math.ceil(64*(uimanager_sav["iconsize"]) + 32))
end

function play_video(ctr)
local Movie = import('/lua/maui/movie.lua').Movie

   	local parent = UIUtil.CreateScreenGroup(ctr, "Campaign Movie ScreenGroup")
	parent.Depth:Set(5000)	--GetFrame(over:GetRootFrame():GetTargetHead()
	AddInputCapture(parent)

	local movie = Movie(parent)
	LayoutHelpers.FillParentPreserveAspectRatio(movie, parent)
	movie:DisableHitTest()    -- get clicks to parent group

	movie:Set("/movies/FMV_Campaign_Intro.sfd") --FMV_Credits.sfd")
	movie.OnLoaded = function(self)
		--movie.sound = PlaySound(Sound( {Cue = cueName, Bank = 'FMV_BG'} ))
		movie:Play()
	end

	local function LeaveMovie()
            RemoveInputCapture(parent)
            movie:Stop()
            StopSound(movie.sound,true)
            parent:Destroy()
	end

	movie.OnFinished = function(self)
		--PlayCampaignMovie('FMV_' .. faction .. '_Outro_2', GetFrame(0), false)
	end
	return LeaveMovie
end

function play_credit2(ctr)
	local maxline=25
	local titre_popup={}
	text={l0="UI mod",
	l1=" ",
	l2=" ",
	l3="Programmers:",
	l4=" ",
	l5="Saya",
	l6="Cleopatre",
	l7="Goom",
	l8=" ",
	l9=" ",
	l10="Contributors:",
	l11=" ",
	l12="III Demon",
	l13="()((()",
	l14="Mereth",
	l15=" ",
	l16=" ",
	l17=" ",
	l18="Special thanks to:",
	l19=" ",
	l20="Gooms girlfriend",
	l21="Trounk (tester) ",
	l22=" ",
	l23=" ",
	l24=" ",
	l25=" ",
	}
	local j=1

	titre_popup[0] = UIUtil.CreateText(ctr,text["l0"], 36, UIUtil.titleFont)
	LayoutHelpers.AtLeftTopIn(titre_popup[0],ctr,(ctr.BitmapWidth() - string.len(text["l0"])*14 )/2, 300)
	titre_popup[0]:SetColor(UIUtil.dialogCaptionColor)
	titre_popup[0].Depth:Set(5002)
	titre_popup[0]:Hide()
	--Effect.Pulse(titre_popup[0],1,0.7,1)


	while j<maxline do
		--for name,val in text do
			titre_popup[j] = UIUtil.CreateText(ctr,text["l"..j], 23, UIUtil.titleFont)
			LayoutHelpers.AtLeftTopIn(titre_popup[j],ctr,(ctr.BitmapWidth() - string.len(text["l"..j])*10 )/2, 300+j*30)
			titre_popup[j]:SetColor(UIUtil.dialogCaptionColor)
			titre_popup[j].Depth:Set(5002)
			titre_popup[j]:Hide()
		--end
		j=j+1
	end
 
	local mdThread = ForkThread(function()
		i=0
		while i<1000 do
			j=0
			WaitSeconds(.001)
			while j<maxline do
				titre_popup[j].Top:Set(titre_popup[j].Top()-1)
				if titre_popup[j].Top()>(ctr.Top()+50) and titre_popup[j].Top()<(ctr.Bottom()-80) then titre_popup[j]:Show() else titre_popup[j]:Hide() end
				j=j+1
			end
			i=i+1
		end
    end)
	kill_fct=function()
		KillThread(mdThread)
		local j=0
		while j<maxline do
			titre_popup[j]:Destroy()
			j=j+1
		end
	end
	return kill_fct

		
end

function buildme(pos)
	local modifiers = {Left = true}
	if GetSelectedUnits() then
		if construction.buildpos[pos] != nil then
			construction.buildpos[pos].OnClick(construction.buildpos[pos], modifiers)
		end
	end
end

