--*****************************************************************************
--* File: mods/uimod/sca_utils/uimod.lua
--* Author: Cleopatre and Saya
--* 
--* Summary: for the entry point for the in sca game UI
--* main function, initialisation, launch drag and drop, and Save/load
--*
--* Copyright  2007 SCA  All rights reserved.
--*****************************************************************************
-- Functions could be used
-- Make_movable : allow you to make movable/resiable anything
-- Save/load : allow you to save what you want, if you want to use save/load don't forgot to add your default value TWICE in the two table under

--FIX THIS IT'S STUPID AND JUST FOR THE BETA RELEASE
local tempScrollArrowTable = {}

debug_sca = false -- debug mode, change the value here and in uimanager
local gamemain = import('/lua/ui/game/gamemain.lua')
local pathui = '/mods/uimod/hook'
local pathuiimg = '/mods/uimod/textures'
local sca_utils = '/mods/uimod/sca_utils/'
local UIManager = import(sca_utils .. 'uimanager.lua')
local LayoutManager = import(sca_utils .. 'layoutmanager.lua')
local skinning= import(sca_utils .. 'skinning.lua')
local UIUtil = import('/lua/ui/uiutil.lua')
local LayoutHelpers = import('/lua/maui/layouthelpers.lua')
local Group = import('/lua/maui/group.lua').Group
local remap = import(sca_utils .. 'remap.lua')

local mapGroup = false
sca={
		queue={
			name="queue",
			import_dir="/lua/ui/game/queue.lua",
			linka="controls",
			linkb="queueGroup",
			link2=nil,
			bresize=true,
			bLimitMove=false,
			saved=true, save_4_corr=true,
			layout_sca=true,
			layout_sca_mini=true,
			get_replay_state=true,
			normal=true,
			movable=false,
			configwindow = true,
		},
		mass={
			name="mass",
			import_dir="/lua/ui/game/economy.lua",
			linka="controls",
			linkb="massBG",
			link2=nil,
			bresize=false,
			bLimitMove=false,
			saved=true, save_4_corr=false,
			layout_sca=true,
			layout_sca_mini=false,
			get_replay_state=false,
			normal=true,
			movable=false,
			configwindow = true,
			},	
		energy={
			name="energy",
			import_dir="/lua/ui/game/economy.lua",
			linka="controls",
			linkb="energyBG",
			link2=nil,
			bresize=false,
			bLimitMove=false,
			saved=true, save_4_corr=false,
			layout_sca=true,
			layout_sca_mini=false,
			get_replay_state=false,
			normal=true,
			movable=false,
			configwindow = true,
		},	
		options={
			name="options",
			import_dir="/lua/ui/game/options.lua",
			linka="GUI",
			linkb="bg",
			link2=nil,
			bresize=false,
			bLimitMove=false,
			saved=true, save_4_corr=false,
			layout_sca=true,
			layout_sca_mini=false,
			get_replay_state=false,
			normal=true,
			movable=false,
			configwindow = true,
		},	
		mfd={
			name="mfd",
			import_dir="/lua/ui/game/multifunction.lua",
			linka="controls",
			linkb="bg",
			link2=nil,
			bresize=false,
			bLimitMove=false,
			saved=true, save_4_corr=false,
			layout_sca=true,
			layout_sca_mini=false,
			get_replay_state=false,
			normal=true,
			movable=false,
			configwindow = true,
		},	
		minimap={
			name="minimap",
			import_dir="/lua/ui/game/multifunction.lua",
			linka="controls",
			linkb="miniMap",
			linkc="BG",
			link2=nil,
			bresize=true,
			bLimitMove=true,
			saved=true, save_4_corr=true,
			layout_sca=true,
			layout_sca_mini=true,
			get_replay_state=false,
			normal=true,
			movable=false,
		},	
		construction={
			name="construction",
			import_dir="/lua/ui/game/construction.lua",
			linka="controls",
			linkb="constructionGroup",
			link2=nil,
			bresize=true,
			bLimitMove=false,
			saved=true, save_4_corr=true,
			layout_sca=true,
			layout_sca_mini=true,
			get_replay_state=true,
			normal=true,
			movable=false,
			configwindow = true,
		},	
		selection={
			name="selection",
			import_dir="/lua/ui/game/selectionmanager.lua",
			linka="controls",
			linkb="panelmin", 
			link2="construction",
			bresize=true,
			bLimitMove=false,
			saved=false, save_4_corr=false,
			layout_sca=true,
			layout_sca_mini=true,
			get_replay_state=true,
			normal=true,
			movable=false,
		},	
		orders={
			name="orders",
			import_dir="/lua/ui/game/orders.lua",
			linka="controls",
			linkb="bg",
			link2=nil,
			bresize=false,
			bLimitMove=false,
			saved=true, save_4_corr=false,
			layout_sca=true,
			layout_sca_mini=true,
			get_replay_state=false,
			normal=true,
			movable=false,
			configwindow = true,
		},	
		unitview={
			name="unitview",
			import_dir='/mods/uimod/sca_utils/uimanager.lua',
			linka="unitview",
			linkb=nil,
			link2=nil,
			bresize=false,
			bLimitMove=false,
			saved=true, save_4_corr=false,
			layout_sca=true,
			layout_sca_mini=true,
			get_replay_state=false,
			normal=true,
			movable=true,
			configwindow = true,
		},
		score={
			name="score",
			import_dir='/mods/uimod/sca_utils/uimanager.lua',
			linka="score_grp",
			linkb=nil,
			link2=nil,
			bresize=false,
			bLimitMove=false,
			saved=true, save_4_corr=false,
			layout_sca=true,
			layout_sca_mini=true,
			get_replay_state=false,
			normal=true,
			movable=true,
			resizer_offset = {Left = -8, Top = -6, Right = 16, Bottom = 36},
		},
		borders={
			name="borders",
			import_dir="/lua/ui/game/borders.lua",
			linka="controls",
			linkb="resizegroup",
			link2=nil,
			bresize=true,
			bLimitMove=true,
			saved=true, save_4_corr=true,
			layout_sca=true,
			layout_sca_mini=true,
			get_replay_state=false,
			normal=true,
			movable=false,
			configwindow = true,
		},
		resizeopt={
			name="resizeopt",
			import_dir="/mods/uimod/sca_utils/uimanager.lua",
			linka="resize_opt",
			linkb="panel",
			link2=nil,
			bresize=false,
			bLimitMove=true,
			saved=false, save_4_corr=true,
			layout_sca=true,
			layout_sca_mini=true,
			get_replay_state=false,
			normal=true,
			movable=false,
		},
		--[[TEMP massupg stuff
		massfabthing={
			name="massfabthing",
			import_dir=sca_utils.. "massfabswitcher.lua",
			linka="MassFabSwitchContainer",
			linkb=nil,
			link2=nil,
			bresize=false,
			bLimitMove=false,
			saved=true, save_4_corr=false,
			layout_sca=true,
			layout_sca_mini=true,
			get_replay_state=false,
			normal=true,
			movable=true,
			},
			mexupthing={
			name="mexupthing",
			import_dir=sca_utils.. "mexup.lua",
			linka="MexUpContainer",
			linkb=nil,
			link2=nil,
			bresize=false,
			bLimitMove=false,
			saved=true, save_4_corr=false,
			layout_sca=true,
			layout_sca_mini=true,
			get_replay_state=false,
			normal=true,
			movable=true,
			},]]
}
sca_data=	{
			transparencyCheckBox=1,  -- data saved in game;perfs
			transparenceSlider=0.6,			   
			inverse_barre=1,
			affiche_construc=1,  -- display the windows construction/orders/queue/selection when nothing is selected ? if 1 -->no
			affiche_help=0, -- display the help tips (building/units informations) ?			   
			max_Zoom=0.4,			   
			hide_orders=0,
			hide_mfd=0,
			hide_mass=0,
			hide_energy=0,
			hide_options=0,
			hide_queue=0,
			hide_construction=0,
			hide_unitview=0,
			new_unit_view=1,
			popzoom = 0.35,
			iconsize = 0.44,
			verticalenergy = 0,
			verticalmass = 0,
			verticaloptions = 0,
			verticalMFD = 1,
			altconstruction = 0,
			vertconstruction = 0,
			miniui_econ = 0,
			showborders = 1,
			ordersgrid = 34,
			vertqueue = 0,
			const_sizing = 0,
			}


--UI manager contains the mod functionalities for the UI
local init= false
layout_sca = false  -- is sca the current layout ?
local Prefs = import('/lua/user/prefs.lua')--preferences
local UIconfigPanel = false
local save_third_button = false
local bthird_button=false
local layoutCode = false

--which faction is in use?
factionIndex = 0
factionTable = {
	[-1] = 'DEFAULT',
    [0] = 'UEF',
	[1] = 'AEON',
	[2] = 'CYBRAN',
}

-- function save and load
save_all = function() end
load_all = function() end

-- to reset all the save
function reset_sca()
	LOG('Reset SCA')
	Prefs.SetToCurrentProfile("uimanager_sav", UIManager.sav_for_reset)
	Prefs.SetToCurrentProfile("sca_key_map", {})
	Prefs.SavePreferences()
	createNiceLayout("sca")
	UIManager.uimanager_sav = Prefs.GetFromCurrentProfile("uimanager_sav")
	RefreshLayout()
	UIManager.reset()
	parent=GetFrame(0)	
	LayoutManager.Init()
	UIManager.Splash(parent)
	if debug_sca then print("Creating options of uimod.lua") end
end

function Refresh_third_button()
	if UIManager.Get_opt("middle_mouse_bouton")==1 then
	 	import('/lua/ui/game/worldview.lua').viewLeft.HandleEvent=function(self,event)
			if event.Type=="ButtonPress" and event.Modifiers.Middle and not event.Modifiers.Ctrl and not event.Modifiers.Alt then 
				import(sca_utils.. "zoompopper.lua").ToggleZoomPop()
			else
				save_third_button(self,event)
			end 
		end
	else
		import('/lua/ui/game/worldview.lua').viewLeft.HandleEvent=save_third_button
	end
end

-- done at the startup, only once
function initialisation_sca()
	--WARN('INITIALISATION')
	
	--radial orders menus
	local armiesInfo = GetArmiesTable()
	factionIndex = armiesInfo.armiesTable[armiesInfo.focusArmy].faction	or 0
	if not gamemain.GetReplayState() then
		remap.init()
	end
	import(sca_utils.. 'radialmenu.lua').SetFaction(factionIndex)
	radialparent = import('/lua/ui/game/gamemain.lua').GetGameParent()
	import(sca_utils.. 'radialmenu.lua').CreateGroup(radialparent, 200, 200)
	
	
	--[[TEMP: I like this mod, with a little work we could incorporate it. meanwhile it's in here so I can use it
    local parent = import('/lua/ui/game/borders.lua').controls.controlClusterGroup

    import(sca_utils.. 'mexup.lua').CreateMexDisplay(parent)
    import(sca_utils.. 'massfabswitcher.lua').CreateMassFabSwitchDisplay(parent)]]

	save_third_button=import('/lua/ui/game/worldview.lua').viewLeft.HandleEvent
	Refresh_third_button()

	if debug_sca then import('/lua/ui/uimain.lua').ToggleConsole() print("Welcome to the debug mode of UIMOD !!") end

	-- initialization, creation of uimanager, uilocker and everything
	UIconfigPanel=UIManager.construct_all()	

	-- first launch of this version, if (version + 0.01 > oldversion) --> reset preferences
	if (Prefs.GetFromCurrentProfile("uimanager_sav") == nil) or ((Prefs.GetFromCurrentProfile("uimanager_sav")["modVersion_int"] + 0.005)<UIManager.sav_for_reset["modVersion_int"]) then
	  -- initialization, creation of uimanager, uilocker and everything
		reset_sca()
	end
			
	import(sca_utils.. 'layoutmanager.lua').Init()

	-- start on layout choose, or load sca
	if Prefs.GetFromCurrentProfile("uimanager_sav")["defaultLayout"] then
		import(sca_utils.. 'layoutmanager.lua').selectLayout(Prefs.GetFromCurrentProfile("uimanager_sav")["currentscaLayout"][1], Prefs.GetFromCurrentProfile("uimanager_sav")["currentscaLayout"][2])
	else
		UIUtil.SetCurrentLayout("sca")
		UIManager.resizeIcons(math.ceil(64*(UIManager.uimanager_sav["iconsize"]) + 32))
	end
	init=true  -- intitialisation done

	if Prefs.GetFromCurrentProfile("uimanager_sav") then
		local val = Prefs.GetFromCurrentProfile('uimanager_sav')
		ConExecute("cam_FarPitch ".. (math.ceil(val.cam_FarPitch)*90))
		ConExecute("cam_MinSpinPitch ".. (val.cam_MinSpinPitch)*-1.1+0.1)
		ConExecute("cam_NearPitch ".. (math.ceil((val.cam_NearPitch)*90)))
		ConExecute("cam_ZoomSpeedLarge ".. (math.ceil((val.cam_ZoomSpeedLarge)*20)))
		ConExecute("cam_MaxZoomMult ".. (((val.cam_MaxZoomMult)+0.9)))
		ConExecute("cam_PanSpeed ".. (((val.cam_PanSpeed)*5 + 0.2)))
	end
	UIManager.uimanager_sav.loadOK = true
	Prefs.SetToCurrentProfile("uimanager_sav", UIManager.uimanager_sav)
	
	if debug_sca then print("Initialisation succesfull")	end
end

-- call before one layout sca is set
function On_layout_sca()
	Refresh_third_button()
	init_layout_sca()
	loadModValues("sca")
	UIManager.modTransparence()
	UIManager.On_layout_sca()
end

-- [****************************************************************************************************
-- [**********************************        Make movable/resiable         **********************************
-- [****************************************************************************************************

-- allow you to make a group(with checkbox,slider, etc)/picture/bitmap to be movable, resizable, etc.
--control is the object
-- bLimitMove, if true you can't move the control past the screen edges
-- bHide: do you want it by default Hide ?

-- it's also up tou you to save it (cf. at the bottom of this file Save/loadMovValue; at to take take of his transparency cf. uimanager.Modtransparency)

function Make_movable(control, bLimitMove, name)
	if control !=nil then
		UIManager.dragOnUI(control, name, bLimitMove)
	else
		if debug_sca then WARN("WARNING UIMOD: in Make_movable, try to call a non existant control") end
	end
end

function import_sca(name)
	local link=nil
	if name!="" and name!=false then 
		if sca[name]!=nil and sca[name]!=false then
			if sca[name].linka!=nil then
				if sca[name].linkb!=nil then
					if sca[name].linkc != nil then
						link=import(sca[name].import_dir)[sca[name].linka][sca[name].linkb][sca[name].linkc]
					else
						link=import(sca[name].import_dir)[sca[name].linka][sca[name].linkb]
					end
				else
					link=import(sca[name].import_dir)[sca[name].linka]
				end
			else
				link=import(sca[name].import_dir)
			end
		else
			WARN("WARNING UI MOD: import_sca call to a nil -->sca[",name,"].")
		end
	end
	return link
end
	
-- init the particular 'sca' layout
function init_layout_sca()
	local link=nil
	for name,val in sca do
		if sca[name].link2!=nil then link=import_sca(sca[name].link2) else link = import_sca(name) end
		
		if sca[name].movable and sca[name].layout_sca and sca[name].normal and (not(gamemain.GetReplayState() and name =="orders") and not(not(gamemain.GetReplayState()) and name =="replay")) then
			if not (Prefs.GetFromCurrentProfile("uimanager_sav")["miniui_econ"]==1 and not sca[name].layout_sca_mini) then
				if sca[name].get_replay_state then
					Make_movable(link, sca[name].bLimitMove, name)
				else
					Make_movable(link, sca[name].bLimitMove, name)
				end
				if sca[name].layout_sca and sca[name].normal==false then
					Make_movable(import_sca(name), nil, name)
				end
			end
		end

	end
	-- for the minimap, should change later
	if not(Prefs.GetFromCurrentProfile('stratview')) and not(gamemain.GetReplayState()) then import_sca("minimap"):Hide()		end
end 


-- reinit all the function of the actual layout
function RefreshLayout()
	for i, v in tempScrollArrowTable do
		v:Destroy()
	end
	tempScrollArrowTable = {}
	UIUtil.SetCurrentLayout("sca")

	local val = Prefs.GetFromCurrentProfile('uimanager_sav')
	ConExecute("cam_FarPitch ".. (math.ceil(val.cam_FarPitch)*90))
	ConExecute("cam_MinSpinPitch ".. (val.cam_MinSpinPitch)*-1.1+0.1)
	ConExecute("cam_NearPitch ".. (math.ceil((val.cam_NearPitch)*90)))
	ConExecute("cam_ZoomSpeedLarge ".. (math.ceil((val.cam_ZoomSpeedLarge)*20)))
	ConExecute("cam_MaxZoomMult ".. (((val.cam_MaxZoomMult)+0.9)))
	ConExecute("cam_PanSpeed ".. (((val.cam_PanSpeed)*5 + 0.2)))
	
	--TODO: fix this options resizer problem (options resizer stays hidden after a layout refresh) in a better way
	if UIManager.ResizerActivation then
		import('/lua/ui/game/selectionmanager.lua').controls.panelmin:Show()
		import('/lua/ui/game/queue.lua').controls.queueGroup:Show()
		if UIManager.ResizeTable["options"] and Prefs.GetFromCurrentProfile("uimanager_sav")["miniui_econ"]==0 then
			import_sca("options").Resizer:Show()
			import_sca("options").Resizer.Depth:Set(900)
			import_sca("options").Resizer:SetAlpha(0.6, true)
			import_sca("mfd").Resizer:Show()
			import_sca("mfd").Resizer.Depth:Set(900)
			import_sca("mfd").Resizer:SetAlpha(0.6, true)
			import_sca("energy").Resizer:Show()
			import_sca("energy").Resizer.Depth:Set(900)
			import_sca("energy").Resizer:SetAlpha(0.6, true)
			import_sca("mass").Resizer:Show()
			import_sca("mass").Resizer.Depth:Set(900)
			import_sca("mass").Resizer:SetAlpha(0.6, true)
			import_sca("minimap").Resizer:Show()
			import_sca("minimap").Resizer.Depth:Set(900)
			import_sca("minimap").Resizer:SetAlpha(0.6, true)
		end
		import('/lua/ui/game/selectionmanager.lua').Resizing()
		import('/lua/ui/game/queue.lua').Resizing()
	end
	if layoutCode and not gamemain.GetReplayState()then
		layoutCode()
	end
end


-- [****************************************************************************************************
-- [**********************************        Load/save procedure           **********************************
-- [****************************************************************************************************

mod_modif={    -- the reset value
			}

-- The function below allow you to save and load any control
-- be simple sure that there isn't any lazywar difficulties on the load
--
-- Save() and Load() is for one control
-- name_control : the name used in the table and in game.pref for exemple 'option' should be save as optionLEFT, optionTOP, optionRIGHT...
-- ctr: the control you want to save
-- if b_save_also_Rigth_Bottom is true then you save also Right and Bottom, otherwise only Left and Top are saved
-- name_in_game_pref : the name of the table in game.pref for example if typ='hello' should be save in 'uimod_SCA_hello' in game.pref / used to have two layout different saved

-- saveModValues is call each time someone close the configPanel
-- loadModValues is call several time: on openning the layout, etc.

function save(name_control, ctr,b_save_also_Rigth_Bottom,name_in_game_pref)
LOG("save-->",name_control)
	local creat={Left=0,Top=0,Right=200,Bottom=200}
	if (Prefs.GetFromCurrentProfile("uimod_SCA_" .. name_in_game_pref)[name_control]) then
		mod_modif[name_control]=(Prefs.GetFromCurrentProfile("uimod_SCA_" .. name_in_game_pref)[name_control])
	end
	
	if mod_modif[name_control]== nil then 
		mod_modif[name_control]=creat
	end

	if not (Prefs.GetFromCurrentProfile("uimanager_sav")["miniui_econ"]==1 and not sca[name_control].layout_sca_mini) then
		if ctr.Left !=nil then
			if mod_modif[name_control]["Left"]!= nil then
				mod_modif[name_control]["Left"] = ctr.Left()
			else
				table.insert(mod_modif[name_control]["Left"],ctr.Left())
			end
		end
		if ctr.Top !=nil then
			if mod_modif[name_control]["Top"]!= nil then
				mod_modif[name_control]["Top"] = ctr.Top()
			else
				table.insert(mod_modif[name_control]["Top"],ctr.Top())
			end
		end

		if debug_sca then print("     save  "..name_control.." ("..mod_modif[name_control]["Left"]..","..mod_modif[name_control]["Top"]..")") end
	
		if (b_save_also_Rigth_Bottom) then
			if ctr.Right !=nil then
				if mod_modif[name_control]["Right"]!= nil then
					mod_modif[name_control]["Right"] = ctr.Right()
				else
					table.insert(mod_modif[name_control]["Right"],ctr.Right())
				end
			end
			if ctr.Bottom !=nil then
				if mod_modif[name_control]["Bottom"]!= nil then
					mod_modif[name_control]["Bottom"] = ctr.Bottom()
				else
					table.insert(mod_modif[name_control]["Bottom"],ctr.Bottom())
				end
			end

			if debug_sca then print("       +   ("..mod_modif[name_control]["Right"]..","..mod_modif[name_control]["Bottom"]..")") end
		end
	end
end

function load(name, ctr, b_save_also_Rigth_Bottom,name_in_game_pref)
--LOG("load-->",name)
	if (Prefs.GetFromCurrentProfile("uimod_SCA_" .. name_in_game_pref) == nil ) then
			Prefs.SetToCurrentProfile("uimod_SCA_" .. name_in_game_pref, {})--assign and save mod values
			Prefs.SavePreferences()
			LOG("INFO UIMOD:Autocorrect modinterface on load : uimod_SCA_" .. name_in_game_pref .. " non existant, has been created.")
	end
	if ctr.Resizer then
		if (Prefs.GetFromCurrentProfile("uimod_SCA_" .. name_in_game_pref)[name]["Left"] != nil ) then
			vLeft = Prefs.GetFromCurrentProfile("uimod_SCA_" .. name_in_game_pref)[name]["Left"]
		else
			vLeft= 100
			LOG("INFO UIMOD: using default setting for ".. name .."Left="..vLeft.." in load")
		end
		if (Prefs.GetFromCurrentProfile("uimod_SCA_" .. name_in_game_pref)[name]["Top"] != nil ) then 
			vTop = Prefs.GetFromCurrentProfile("uimod_SCA_".. name_in_game_pref)[name]["Top"] 
		else
			vTop = 100
			LOG("INFO UIMOD: using default setting for ".. name .."Top="..vTop.." in load")
		end
		if (Prefs.GetFromCurrentProfile("uimod_SCA_" .. name_in_game_pref)[name]["Right"] != nil ) then
			vRight = Prefs.GetFromCurrentProfile("uimod_SCA_".. name_in_game_pref)[name]["Right"] 
		else
			if ctr.Width then 
				vRight=100 + ctr.Width()
			else
				vRight = 300
			end
			LOG("INFO UIMOD: using default setting for ".. name .."Right="..vRight.." in load")
		end
		if (Prefs.GetFromCurrentProfile("uimod_SCA_" .. name_in_game_pref)[name]["Bottom"] != nil ) then
			vBottom = Prefs.GetFromCurrentProfile("uimod_SCA_".. name_in_game_pref)[name]["Bottom"] 
		else
			if ctr.Height then
				vBottom=100 + ctr.Height()
			else
				vBottom = 300
			end
			LOG("INFO UIMOD: using default setting for ".. name .."Bottom="..vBottom.." in load")
		end

		ctr.Resizer.Left:Set(vLeft)
		ctr.Resizer.Right:Set(vRight)
		ctr.Resizer.Top:Set(vTop)
		ctr.Resizer.Bottom:Set(vBottom)
		
		if name == "borders" then
			ctr.Resizer.Depth:Set(100)
			ctr.Resizer:SetAlpha(0.35, true)
		else
			ctr.Resizer.Depth:Set(900)
			ctr.Resizer:SetAlpha(0.75, true)
		end
		
		if name == "score" then
			offset = sca["score"].resizer_offset
			if vLeft < (GetFrame(0).Right()/2) and vTop < (GetFrame(0).Bottom()/2) then
				ctr.Resizer.Left:Set(vLeft + offset.Left)
				ctr.Resizer.Top:Set(vTop + offset.Top)
				ctr.Left:Set(function() return ctr.Resizer.Left() - offset.Left end)
				ctr.Top:Set(function() return ctr.Resizer.Top() - offset.Top end)
				ctr.Resizer.Right:Set(function() return ctr.Right() + offset.Right end)
				ctr.Resizer.Bottom:Set(function() return ctr.Bottom() + offset.Bottom end)
			elseif vLeft > (GetFrame(0).Right()/2) and vTop < (GetFrame(0).Bottom()/2) then
				ctr.Resizer.Right:Set(vRight + offset.Right)
				ctr.Resizer.Top:Set(vTop + offset.Top)
				ctr.Right:Set(function() return ctr.Resizer.Right() - offset.Right end)
				ctr.Top:Set(function() return ctr.Resizer.Top() - offset.Top end)
				ctr.Resizer.Left:Set(function() return ctr.Left() + offset.Left end)
				ctr.Resizer.Bottom:Set(function() return ctr.Bottom() + offset.Bottom end)
			elseif vLeft < (GetFrame(0).Right()/2) and vTop > (GetFrame(0).Bottom()/2) then
				ctr.Resizer.Left:Set(vLeft + offset.Left)
				ctr.Resizer.Bottom:Set(vBottom + offset.Bottom)
				ctr.Left:Set(function() return ctr.Resizer.Left() - offset.Left end)
				ctr.Bottom:Set(function() return ctr.Resizer.Bottom() - offset.Bottom end)
				ctr.Resizer.Right:Set(function() return ctr.Right() + offset.Right end)
				ctr.Resizer.Top:Set(function() return ctr.Top() + offset.Top end)
			else
				ctr.Resizer.Right:Set(vRight + offset.Right)
				ctr.Resizer.Bottom:Set(vBottom + offset.Bottom)
				ctr.Right:Set(function() return ctr.Resizer.Right() - offset.Right end)
				ctr.Bottom:Set(function() return ctr.Resizer.Bottom() - offset.Bottom end)
				ctr.Resizer.Left:Set(function() return ctr.Left() + offset.Left end)
				ctr.Resizer.Top:Set(function() return ctr.Top() + offset.Top end)

			end
		else
			LayoutHelpers.FillParent(ctr, ctr.Resizer)
		end
	else
		LOG('USING DEFAULTS FOR ' ..name)
		ctr.Left:Set(0)
		ctr.Top:Set(0)
		ctr.Right:Set(200)
		ctr.Bottom:Set(200)
	end
end

function saveModValues(nom)
	local nom_sav = false
	if nom=="default" then nom_sav="sca" else nom_sav=nom end
	if debug_sca then print ("save : " .. nom_sav) end
	
	local link2=nil
	for name,val in sca do
		if sca[name].link2!=nil then link2=import_sca(sca[name].link2) else link2=nil end
		if sca[name].saved and (sca[name].layout_sca) then
			save(sca[name].name,import_sca(name),true,nom_sav)
		end
	end
	local prefsav = Prefs.GetFromCurrentProfile("uimanager_sav")
	mod_modif["sca_data"]={}
	if prefsav!=nil then
		for name,val in sca_data do
			if prefsav[name]!=nil then mod_modif["sca_data"][name]=prefsav[name] end
		end
	end
	Prefs.SetToCurrentProfile("uimod_SCA_" .. nom_sav, mod_modif)--assign and save mod values
	Prefs.SavePreferences()--save prefs now, this is done automatically on exit too
	if debug_sca then print("Modinterface: preferences saved succesfully") end
end

function loadModValues(nom)
	local nom_sav = false
	if nom=="default" then nom_sav="sca" else nom_sav=nom end
	if debug_sca then print ("load : " .. nom_sav)	end
	
	local link2=nil
	for name,val in sca do
		if sca[name].link2!=nil then link2=import_sca(sca[name].link2) else link2=nil end
		if sca[name].saved and (sca[name].layout_sca)  and (not(gamemain.GetReplayState() and name =="orders") and not(not(gamemain.GetReplayState()) and name =="replay")) then
			if not (Prefs.GetFromCurrentProfile("uimanager_sav")["miniui_econ"]==1 and not sca[name].layout_sca_mini) then
				load(sca[name].name,import_sca(name),sca[name].save_4_corr,nom_sav)
			end
		end
	end
	
	if debug_sca then print("Modinterface: load succesful") end
end

function minval(val1,val2)
	local ret=val1
	if val1>val2 then ret=val2 end
	return ret
end

function modval(name,left, top, right, bottom)
	local creat={Left=0,Top=0,Right=200,Bottom=200}
	if mod_modif[name]== nil then 
		mod_modif[name]=creat
	end
	if top!=nil then mod_modif[name]["Top"]=top
	else mod_modif[name]["Top"]=0 WARN("WARNING UIMOD: attemps to assign a nil value on TOP in createNiceLayout") end
	if left!=nil then mod_modif[name]["Left"]=left
	else mod_modif[name]["Left"]=0 WARN("WARNING UIMOD: attemps to assign a nil value on LEFT in createNiceLayout") end
	if ((right!=nil and bottom!=nil)) and (right!= false and bottom!=false) then 
		mod_modif[name]["Right"]=right
		mod_modif[name]["Bottom"]=bottom
	else
		if import_sca(name).BitmapWidth then
			mod_modif[name]["Right"] = left + import_sca(name).BitmapWidth()
			mod_modif[name]["Bottom"] = top + import_sca(name).BitmapHeight()
		end
	end	
end
 
--sets up prefs on first launch
function createNiceLayout(layout)
	--bord is the UI borders, it depends on the resolution
	bord=GetFrame(0)
	mod_modif={}
	--import('/lua/ui/game/borders.lua').GetMapGroup()
	
	--borders
	--LOG("accessing border values:")
	--LOG("left: " .. bord.Left())
	--LOG("right: " .. bord.Right())
	--LOG("top: " .. bord.Top())
	--LOG("bottom: " .. bord.Bottom())
	
	--borders
	modval("borders",
		bord.Left(),
		bord.Top(),
		bord.Right(),
		bord.Bottom())

	
	--construction
	modval("construction",bord.Left() + 190,
		bord.Bottom() - 133,
		minval(bord.Left() + 580,830),
		bord.Bottom() - 10)
	--
	--queue
	modval("queue",bord.Left() + 190,
		bord.Bottom() - 225,
		minval(bord.Left() + 580,830),
		bord.Bottom() - 135)
	
	--massBG
	modval("mass",bord.Right() - 119,
		bord.Bottom() - 228,
		bord.Right() - 17,
		bord.Bottom() - 18)			
	--energyBG
	modval("energy",bord.Right() - 227,
		bord.Bottom() - 228,
		bord.Right() - 125,
		bord.Bottom() - 18)			

	
	
	--minimap
	modval("minimap",30,
		30,
		200,
		200 )
	
	--if not(gamemain.GetReplayState()) then 
	
		--orders
		modval("orders",bord.Left()+20,
			bord.Bottom() - 220,
			bord.Left() + 20 + 158,
			bord.Bottom() - 10)

	
	--else
	
		--replay
		modval("replay",bord.Left() + 100,
			bord.Top() + 300,
			bord.Left()+ 258,
			bord.Top()+ 518 )

	
	--end	
	
	--mfdcontrol
	modval("mfd",bord.Right()-238 -320,
		bord.Top()+ 2,
		bord.Right() -320,
		bord.Top()+ 50 + 2)
		
	--options
	modval("options",bord.Right() - 274 -40,
	bord.Top() + 2,
	bord.Right() -40,
	bord.Top() + 46 + 2)
		
	
	--view_example
	modval("unitview",bord.Left()+30,
		bord.Bottom() - 245 -126, --UIManager.unitview.Bottom()- UIManager.unitview.BitmapHeight()) --bord.Bottom()-100)
		bord.Left()+352, --UIManager.unitview.Left()+UIManager.unitview.BitmapWidth())
		bord.Bottom() - 245) --import('/lua/ui/game/queue.lua').controls.queueGroup.Top()-15)

	local counter=1
	
	local armiesInfo = GetArmiesTable()
	if GetArmiesTable!=nil then
		for i, v in armiesInfo.armiesTable do
			if v.showScore and not v.civilian then
				counter = counter + 1
			end
		end
	end
	if counter<3 then counter=3 end
	
	--score
	modval("score",bord.Right() - 248,
		bord.Bottom() -18*(counter+2)- 272,
		bord.Right() - 22,
		bord.Bottom() - 260)
		
	--[[TEMP
	modval("mexupthing", bord.Left() + 400,
		bord.Top() + 400,
		bord.Left() + 480,
		bord.Top() + 540)
	modval("massfabthing", bord.Left() + 480,
		bord.Top() + 400,
		bord.Left() + 560,
		bord.Top() + 540)]]
		
	sca_data=	{
			transparencyCheckBox=1,
			transparenceSlider=0.6,			   
			inverse_barre=1,
			affiche_construc=1, 
			affiche_help=0,		   
			max_Zoom=0.4,			   
			hide_orders=0,
			hide_mfd=0,
			hide_mass=0,
			hide_energy=0,
			hide_options=0,
			hide_queue=0,
			hide_construction=0,
			hide_unitview=0,
			new_unit_view=1,
			popzoom = 0.35,
			iconsize = 0.28,
			verticalenergy = 1,
			verticalmass = 1,
			verticaloptions = 0,
			verticalMFD = 0,
			altconstruction = 0,
			vertconstruction = 0,
			miniui_econ = 0,
			straticons = 1,
			showborders = 0,
			ordersgrid = 34,
			vertqueue = 0,
			const_sizing = 0,
			}
			
	mod_modif["sca_data"]=sca_data
		
	Prefs.SetToCurrentProfile("uimod_SCA_"..layout , mod_modif)
	
	local prefsav = Prefs.GetFromCurrentProfile("uimanager_sav")
	local sca_data_sav=Prefs.GetFromCurrentProfile("uimod_SCA_"..layout)["sca_data"]
	if prefsav!=nil and sca_data_sav!=nil then
		for name,val in sca_data_sav do
			if prefsav[name]!=nil and val!=nil then prefsav[name]=sca_data_sav[name] end
		end
		Prefs.SetToCurrentProfile("uimanager_sav", prefsav)
	end
	
	Prefs.SavePreferences()
end


--[[list of bmp sizes for reference
orders - 160x212
mfd vert - 64x212
mfd horiz - 240x52
options vert - 64x212
options horiz - 276x48
econ vert - 104x212
econ horiz - 368x44
unitview - 324x120
orders 3x4 - 160x212
orders 4x3 - 212x160
order 6x2 - 324x120
]]

function loadUserLayout(skin, layout)
	local windowPosSaver = Prefs.GetFromCurrentProfile("uimod_SCA_sca")
	local windowPosUser = Prefs.GetFromCurrentProfile("uimod_SCA_"..layout)
	Prefs.SetToCurrentProfile("layoutCode", nil)
	layoutCode = false
	for name in sca do
		if import_sca(name) then
			import_sca(name).OnHide = false
		end
	end
	
	if windowPosSaver and windowPosUser then
		for i in windowPosUser do
			windowPosSaver[i] = windowPosUser[i]
		end
		Prefs.SetToCurrentProfile("uimod_SCA_sca" , windowPosSaver)
	end

	local prefsav = Prefs.GetFromCurrentProfile("uimanager_sav")
	local sca_data_sav=Prefs.GetFromCurrentProfile("uimod_SCA_"..layout)["sca_data"]
	if prefsav!=nil and sca_data_sav!=nil then
		for name,val in sca_data_sav do
			if prefsav[name]!=nil and val!=nil then prefsav[name]=sca_data_sav[name] end
		end
		Prefs.SetToCurrentProfile("uimanager_sav", prefsav)
	end

	Prefs.SavePreferences()
end

function loadDefaultLayout(skin, layout)
	local windowPosSaver = Prefs.GetFromCurrentProfile("uimod_SCA_sca")
	local skinfile = import(skinning.GetActualSkinFile())
	local windowPosDefault = skinfile[skin].layouts[layout]
	layoutCode = false
	for name in sca do
		if import_sca(name) then
			import_sca(name).OnHide = false
		end
	end
	
	if windowPosSaver and windowPosDefault then
		for i in windowPosDefault do
			if i != "data" and i != "preview" and i != "factionskins" and i != "info" and i != "code" then
				windowPosSaver[i] = windowPosDefault[i]()
			elseif i == "code" then
				layoutCode = windowPosDefault[i]
			end
		end
		Prefs.SetToCurrentProfile("uimod_SCA_sca" , windowPosSaver)
	end

	local prefsav = Prefs.GetFromCurrentProfile("uimanager_sav")
	local sca_data_sav = skinfile[skin].layouts[layout].data
	if prefsav!=nil and sca_data_sav!=nil then
		for name,val in sca_data_sav do
			if prefsav[name]!=nil and val!=nil then prefsav[name]=sca_data_sav[name] end
		end
		Prefs.SetToCurrentProfile("uimanager_sav", prefsav)
	end
	Prefs.SavePreferences()

	local minsaver = Prefs.GetFromCurrentProfile("uimod_SCA_sca")
	for i, v in prefsav do
		if string.gsub(i, "(.*)_(.*)", "%1") == 'hide' then
			if v == 1 then
				minsaver[string.gsub(i, "(.*)_(.*)", "%2")]["oldLeft"] = minsaver[string.gsub(i, "(.*)_(.*)", "%2")]["Left"] or 0
				minsaver[string.gsub(i, "(.*)_(.*)", "%2")]["oldRight"] = minsaver[string.gsub(i, "(.*)_(.*)", "%2")]["Right"] or 100
				minsaver[string.gsub(i, "(.*)_(.*)", "%2")]["Left"] = 4000
				minsaver[string.gsub(i, "(.*)_(.*)", "%2")]["Right"] = 4500
			end
		end
	end
	Prefs.SetToCurrentProfile("uimod_SCA_sca", minsaver)
	Prefs.SavePreferences()
end

function ClearCode()
	layoutCode = false
	for name in sca do
		if import_sca(name) then
			import_sca(name).OnHide = false
		end
	end
end

--delete all simple textures
function clearSimpleTextures()
	local currentskin = Prefs.GetFromCurrentProfile("uimanager_sav")["skin"]
	local old = {}
	
	if currentskin.simpletextures then
		old = table.copy(currentskin.simpletextures)
	end
	
	--delete bitmaps created by old layout
	for i,bitmap in old do
		if simpletexture.bitmap != false then
			simpletexture.bitmap:Destroy()
			simpletexture.bitmap = false
		end
	end
end

--load all simple textures from a skin
function loadSimpleTextures()
	local gameparent = import('/lua/ui/game/gamemain.lua').GetGameParent()
	local newskin = Prefs.GetFromCurrentProfile("uimanager_sav")["skin"]
	local skinning = import(sca_utils .. 'skinning.lua')
	local controls = skinning.obj 
	local new = {}
	
	if newskin.simpletextures then
		new = table.copy(newskin.simpletextures)
	end
	
	local skinpath = ""

	
	--create new bitmaps for new layout
	for i,simpletexture in new do
		
	
		if simpletexture.parent then
			simpletexture.bitmap = Bitmap(controls[simpletexture.parent])
		else
			simpletexture.bitmap = Bitmap(gameparent)
		end
		
		simpletexture.bitmap.setTexture(UIUtil.UIFile( skinpath .. path ))
		
		simpletexture.bitmap.Width:Set(bitmap.BitmapWidth)
		simpletexture.bitmap.Height:Set(bitmap.BitmapHeight)
		
		--set x using left or right
		if simpletexture.Left and simpletexture.Right then
			simpletexture.bitmap.Left:Set(simpletexture.Left)
			simpletexture.bitmap.Right:Set(simpletexture.Right)
		elseif simpletexture.Left then
			simpletexture.bitmap.Left:Set(simpletexture.Left)
		elseif simpletexture.Right then
			simpletexture.bitmap.Right:Set(simpletexture.Right)
		else
			simpletexture.bitmap.Left:Set(0)
		end
		
		--set y using top or bottom
		if simpletexture.Top and simpletexture.Bottom then
			simpletexture.bitmap.Top:Set(simpletexture.Top)
			simpletexture.bitmap.Bottom:Set(simpletexture.Bottom)
		elseif simpletexture.Top then
			simpletexture.bitmap.Top:Set(simpletexture.Top)
		elseif simpletexture.Bottom then
			simpletexture.bitmap.Bottom:Set(simpletexture.Bottom)
		else
			new.bitmap.Top:Set(0)
		end
		
		--set depth
		if simpletexture.parent and simpletexture.Depth then
			simpletexture.bitmap.Depth:Set(parent.Depth)
		elseif simpletexture.Depth then
			simpletexture.bitmap.Depth:Set(function() return controls[simpletexture.parent].Depth + simpletexture.Depth end)
		else
			simpletexture.bitmap.Depth:Set(1000)
		end
			
	end
end

function TempScrollArrowFctn(control, direction)
	local Bitmap = import('/lua/maui/bitmap.lua').Bitmap
	local tempScrollArrowTex = Bitmap(control)
	table.insert(tempScrollArrowTable, tempScrollArrowTex)
	if direction == "left" then
		tempScrollArrowTex:SetTexture('/mods/uimod/skins/sca/default/construction/arrow_left.dds')
	else
		tempScrollArrowTex:SetTexture('/mods/uimod/skins/sca/default/construction/arrow_right.dds')
	end
	LayoutHelpers.AtHorizontalCenterIn(tempScrollArrowTex, control)
	tempScrollArrowTex.Top:Set(function() return (control.Bottom() + control.Top())/2 - 6 end)
	tempScrollArrowTex:DisableHitTest()
end
