--*****************************************************************************
--* File: lua/ui/game/zoompopper.lua
--* Author: III_Demon
--* Summary: Zoom POP! FAST!
--*
--* Copyright  2xxx me,  All wrongs reversed.
--*****************************************************************************
--	GetTargetZoom() -- max zoom number on 10x10 map is about 1000, on 20x20 its about 2000 -- 80 is nice for close
--	GetFocusPosition()	-- returns a table with X Y Z values for current camera position
--	SetZoom only zooms to current camera position (center, if fully zoomed), not to cursor.
--	GetMouseWorldPos() -- returns mouse coordinates on the surface of the map, X = E/W, Y = surface elevation, Z = N/S
--	GetZoom()	-- returns current actual camera zoom level
--	GetTargetZoom()	-- returns zoom level the camera is heading to

local pathui = '/mods/uimod/hook'
local uimanager = import('/mods/uimod/sca_utils/uimanager.lua')

function ToggleZoomPop()
	local cam = GetCamera('WorldCamera')
	local zoomRatio = (cam:GetTargetZoom() / cam:GetMaxZoom())	-- 0.5 is a good level for 'zoomed most of the way out'

	if zoomRatio > 0.3 then
		local zoom = uimanager.Get_opt("popzoom")*240 +1	-- 80 is just a bit wider than the default starting zoom
		local saved = cam:SaveSettings()
		local hpr = Vector(saved.Heading, saved.Pitch, 0)	-- note: roll is ignored and therefore 0
		cam:SnapTo(GetMouseWorldPos(), hpr, zoom) 
	else
		cam:Reset()
	end
end
